2021-04-28  Simon Josefsson  <simon@josefsson.org>

	telnet: Support --bind (-b) for NetKit compatibility.
	* NEWS: Add.
	* doc/inetutils.texi (telnet invocation): Add --bind (-b).
	* telnet/commands.c (tn): New variables hostaddr and srchostp.
	Parse -b parameter.  Update usage string.  If -b is set, call
	getaddrinfo on it and pass that ai_addr on to bind.
	* telnet/main.c (srcaddr): New global variable.
	(argp_options): Add --bind (-b).
	(parse_opt): Set srcaddr to -b value.
	(main): Propagate -b value to tn function.

2021-02-11  Simon Josefsson  <simon@josefsson.org>

	* TODO: Add items discussed on mailing list.

2021-02-05  Simon Josefsson  <simon@josefsson.org>

	Use gnulib sys_types module so we can assume sys/types.h.

	* tests/waitdaemon.c, tests/runtime-ipv6.c, tests/readutmp.c: Drop
	HAVE_SYS_TYPES_H test.
	* bootstrap.conf (gnulib_modules): Add explicit sys_types.

2021-02-05  Simon Josefsson  <simon@josefsson.org>

	Fix some autoreconf 2.71 warnings.

	* configure.ac: Remove obsolete AC_HEADER_STDC, AC_HEADER_TIME,
	AC_FUNC_SETVBUF_REVERSED, and AC_DECL_SYS_SIGLIST.  Don't check
	for sys/time.h, we never use the test result.

2021-02-01  Alfred M. Szmidt  <ams@gnu.org>

	* ftp/ftp.c (getreply): Fix possible buffer overflow (backport
	from OpenBSD); reported by O. Bittner, D. Maier, M. Munier,
	J. Beier of SecT, TU Berlin.

2021-01-29  Simon Josefsson  <simon@josefsson.org>

	ping6: Don't allow unprivileged users to flood ping.

	* ping/ping6.c (parse_opt): For non-root users, limit interval
	like ping.c to avoid DoS.  Reported in
	<https://bugs.debian.org/926750>.
	* ping/ping_common.h (PING_MIN_USER_INTERVAL): Add.
	* ping/ping.c (MIN_USER_INTERVAL): Remove, replaced by
	PING_MIN_USER_INTERVAL.
	(parse_opt): Update use.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	* telnet/commands.c (logoutcmd): Renamed from logout.  Conflicts
	with system utmp.h's logout(3).
	(cmdtab): Use logoutcmd instead of logout.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	* tests/libls.sh (LSDIR): Fix parallel testing.  Found on Guix and
	Debian, solution is to not use CWD as test directory for libls.
	Inspired by trivial patch by Guillem Jover <guillem@hadrons.org>.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	ping, ping6: Fix unchecked setuid return.

	* ping/ping.c (main): Fail if setuid fail.  Trivial patch from
	Jayakrishna Vadayath <jvadayat@asu.edu>.
	* ping/ping6.c (main): Likewise.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	* tests/hostname.sh: Use uname as fallback if system lack hostname
	command.  Only require mktemp when running root test.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	* tests/hostname.sh: Use system hostname, not system uname, for
	comparison.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	* configure.ac: Don't call gl_FUNC_READLINE.  Not needed since we
	now use readline gnulib module.

2021-01-28  Simon Josefsson  <simon@josefsson.org>

	Fix link failure with absent -lutil on Solaris 10.

	* configure.ac (LIBUTIL): Prefer PTY_LIBS in Makefile.am over
	adding -lutil for pty-functions.
	* src/Makefile.am (LDADD): Add PTY_LIB.
	* telnetd/Makefile.am (LDADD): Likewise.
	* tests/Makefile.am (identify_LDADD): Likewise.

2021-01-27  Simon Josefsson  <simon@josefsson.org>

	* bootstrap.conf (buildreq): Add gzip and xz.

2021-01-27  Simon Josefsson  <simon@josefsson.org>

	* .gitignore: Rewrite to use leading / for most top-level files,
	and general update.

2021-01-26  Simon Josefsson  <simon@josefsson.org>

	Sync release process with gnulib approach.

	* NEWS: Fix syntax to conform to gnulib release-prep rules.
	* cfg.mk: Drop news-check-regexp.
	* bootstrap.conf (gnulib_modules): Use readme-release.  Drop now
	implicit announce-gen, gnupload and maintainer-makefile.
	* bootstrap.conf (bootstrap_epilogue): Add function, fixing
	README-release.
	* gl/top/README-release.diff: Add file.
	* .gitignore: Add README-release.
	* cfg.mk (exclude_file_name_regexp--sc_trailing_blank): Add, for
	README-release.diff.
	* configure.ac (AC_INIT): Don't use sed-expression, it is
	incompatible with gnulib's do-release-commit-and-tag.
	* cfg.mk (git-version-gen-tag-sed-script): Drop.
	* .prev-version: Add file, indicating 1.9.4 as previous release.
	* README-alpha (Release procedures): Removed, replaced by
	README-release.
	* cfg.mk (release-prep-hook): Don't disable it, we now support it.

2021-01-25  Simon Josefsson  <simon@josefsson.org>

	Silence 'make syntax-check'.

	* libls/ls.c: Don't include <intprops.h> if we are not using it.

2021-01-25  Simon Josefsson  <simon@josefsson.org>

	Don't use deprecated gnulib module 'gettext' and replace
	readline.m4 with gnulib readline module.

	* bootstrap.conf (gnulib_modules): Remove gettext.  Add readline.
	* am/readline.m4: Remove file.

2021-01-25  Simon Josefsson  <simon@josefsson.org>

	Only do what git-version-gen recommends regarding .version.

	* Makefile.am (DISTCLEANFILES): Don't distclean
	$(top_builddir)/.version.

2021-01-25  Simon Josefsson  <simon@josefsson.org>

	Fix hostname.sh to not call system hostname, and improve
	diagnostics.

	* tests/hostname.sh: Fix typo.  Improve output on failures.

2021-01-25  Simon Josefsson  <simon@josefsson.org>

	Fix 'make check' on broken platforms without /etc/protocols.

	* tests/traceroute-localhost.sh: Skip test if /etc/protocols
	doesn't exist, copied from existing code in tests/inetd.sh.
	* tests/ping-localhost.sh: Likewise.

2021-01-25  Simon Josefsson  <simon@josefsson.org>

	git-version-gen: Sync with git-version-gen usage instructions.

	* Makefile.am (EXTRA_DIST): Add.
	(BUILT_SOURCES): Use srcdir.
	(.version): Likewise.

2021-01-24  Simon Josefsson  <simon@josefsson.org>

	* configure.ac: Fix disabling when all rcmd is missing.
	* configure.ac: Warn when rcmd is missing.
	* README-alpha (Prerequisites): Mention xz, for dist.

2021-01-24  Simon Josefsson  <simon@josefsson.org>

	Build/doc fixes.

	* README-alpha (Checking Out the Sources): Use git URL mentioned
	on Savannah page.
	(Prerequisites): Add bash, gcc, ncurses.
	* bootstrap: Updated from gnulib.

2020-11-10  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac (AC_PREREQ): Require autoconf 2.64, caused
	by changes in Gnulib.

2020-06-05  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/system/linux.c (linux_if_nameindex): New, incompatible
	signature of contemporary Gnulib function read_file().

2020-05-10  Mats Erik Andersson  <gnu@gisladisker.se>

	* whois/data.h (hide_strings): Add Brazilian pattern.
	* whois/ip6_del_list: Update with more ranges.

2020-05-08  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Delegation list for IPv6 ranges.

	* whois/.gitignore: Add `ip6_del.h'.
	* whois/Makefile.am (BUILT_SOURCES): Add `ip6_del.h'.
	(EXTRA_DIST): Add `ip6_del_list', `ip6_del.h', `make_ip6_del.pl'.
	(noinst_HEADERS): Add `ip6_del.h'.
	(ip6_del.h): New target.
	* whois/data.h (ip6_assign): New array.
	* whois/ip6_del_list: New file.
	* whois/make_ip6_del.pl: New file.
	* whois/whois.c (whichwhois): Regard absence of period, colon,
	and hyphen as evidence of NSI NIC or ASN.  Test for this and for
	email address before any test for numeric addressing.  Implement
	code for IPv6 delegation matching, to be triggered by the presence
	of a colon in the given query string.

2020-05-07  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Tweak command line arguments.

	* whois/whois.c (whichwhois): Skip any single character token,
	as it must be a search directive for a server.  Prune the known
	IPv6 delegations to reflect only the valid one.  Use ARIN as
	default IPv6 serving instance, since the old 6BONE server is no
	longer responsive.

2020-05-07  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Improved hiding of legal disclaimers.

	* whois/as_del_list: Two additional delegations.
	* whois/data.h (hide_strings): Add string patterns for present
	day services at ARIN, LACNIC, and RIPE.
	* whois/whois.c (do_query): After successful location of a stop
	pattern, go back into search state, instead of cancelling further
	matching.  The service at ARIN inserts identical disclaimer at
	the beginning, as well as at the end of a response.

2020-05-06  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2020-04-27  Tim Rühsen  <tim.ruehsen@gmx.de>

	telnet: Use memove for overlapping memory instead of strncpy.

	Overlapping source and destination buffers are not supported
	by strncpy and give undefined results.

	7.24.2.3 of ISO/IEC 9899:201x:
	"If  copying  takes  place  between  objects  thatoverlap,
	the behavior is undefined."

	* telnet/commands.c (cmds): Use memove for overlapping memory
	instead of strncpy.

2020-04-12  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Delegation of IP and AS.

	Attempt improving the list of IP range delegation within the scope
	of old A-class ranges.  The intention is to establish as many
	ranges of width 22, or wider, and also to verify old claims.

	* whois/as_del_list: Update and correct existing AS range
	delegations, and add a few more, random but existing.
	* whois/ip_del_list: Add a large number of delegations within
	former A-class ranges, and correct two erroneous instances.
	* whois/whois.c (whereas): Raise the upper limit of known ASN.
	(queryformat): Rewrite query statement intended for ARIN.

2020-04-06  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Include ERX ranges for APNIC.

	The content of the following web page was scanned to identify
	the ranges within old B-classes that were assigned to APNIC
	by the ERX project, Early Registration Transfer.  After some
	cross checking, a few intermediate ranges for other registars
	were included for better resolution.
	https://www.apnic.net/manage-ip/manage-historical-resources/erx-project/erx-transfer-to-apnic/

	* whois/ip_del_list: Add a large amount of APNIC address ranges.

2020-04-05  Mats Erik Andersson  <gnu@gisladisker.se>

	Support for libidn2 in addition to libidn.

	* am/libidn.m4 (have_IDN2, have_IDN): New local variables.
	Detect presence of libidn2 by checking for `idn2_to_ascii_lz',
	but still aim at backwards compatibility.  Detect header file
	`idna.h' as well as `idn2.h', but prefer libidn2 to libidn,
	should both libraries be detected.
	* configure.ac (--with-idn): Mention that IDN2 is acceptable.
	(idn_link): New variable.
	(ftp_PROPS, ping_PROPS, talk_PROPS, telnet_PROPS, tftp_PROPS)
	(traceroute_PROPS): Update these to state `idn', or `idn2'.

	* ftp/ftp.c [HAVE_IDN2_H && HAVE_IDN2]: Include `idn2.h'.
	[(!HAVE_IDN2_H || !HAVE_IDN2) && HAVE_IDNA_H]: Include `idna.h'.
	(hookup) [HAVE_IDN || HAVE_IDN2]: Use compatibility function
	idna_to_ascii_lz().
	* ping/libping.c (ping_set_dest): Likewise.
	* ping/ping6.c (ping_set_dest): Likewise.
	* src/tftp.c (resolve_name): Likewise.
	* src/traceroute.c (main): Likewise.
	* talk/get_addrs.c (get_addrs)
	[HAVE_DECL_GETADDRINFO || HAVE_IDN || HAVE_IDN2]: Declare ERR.
	[HAVE_IDN || HAVE_IDN2]: Likewise.
	* telnet/commands.c (tn): Declare HOSTTMP.  Likewise.

2020-04-04  Alfred M. Szmidt  <ams@gnu.org>

	* ping/ping6.c (print_packet_too_big): Use %u when printing MTU.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	uucpd: Fix buffer overflows.

	This fixes several missing string termination issues with strncpy.
	Also REMOTEHOST of size NI_MAXHOST was strcpy'ed into LINE, which
	just had 32 bytes on the stack.

	* src/uucpd.c (SCPYN): Promote macro to global scope, but expand
	its action by writing the final NUL character.
	(dologin): Increase size of LINE.  Use existing macro SCPYN
	instead of strncpy.
	[PATH_LASTLOG && HAVE_STRUCT_LASTLOG]: Delete local macro SCPYN.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	uucpd: Fix heap buffer overflow.

	Usernames >= 56 bytes would overflow the char arrays Username and
	Logname.  This change mitigates this, but still silently truncates
	these arrays.  Silent truncation should be checked throughout the
	code, possibly within a more comprehensive code review.

	* src/uucpd.c (Username, Logname): Increase size to 72 bytes.
	(doit): Use snprintf instead of sprintf.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	telnet: Use strdup instead malloc+strcpy.

	* telnet/commands.c (tn): Assign HOSTNAME using strdup().

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	telnet: Fix -Wsign-compare in suboption.

	* telnet/telnet.c (suboption): Explicitly cast sizeof() to int.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	telnetd: Silence -Wimplicit-fallthrough.

	* telnetd/state.c (willoption): Squeelch warning.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	telnetd: Silence unused warning for getterminaltype.

	* telnetd/utility.c (getterminaltype): Squeelch warning.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ftp: Silence -Wimplicit-fallthrough warning.

	* ftp/domacro.c (domacro): Squeelch warning.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ftp: Silence -Wimplicit-fallthrough.

	* ftp/cmds.c (domap): Squeelch warning.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ftp: Fix multipliers for M(ega) and G(iga).

	This is *not* a fix as the comment accidentally states.  It is to
	silence -Wimplicit-fallthrough and to avoid multiple
	multiplications in case of a non-optimized build.  The HASHBYTES
	type needs to be reviewed later as g/G only allows digits 1 and 2
	without integer overflow, which is undefined behavior.

	* ftp/cmds.c (sethash): Remove cascaded multiplications.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ftp: Fix return value of remglob.

	* ftp/cmds.c (remglob): Switch roles of old values after NULL check.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ftp: Fix possible buffer overflow.

	* ftp/ftp.c (hookup): Terminate string after strncpy.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ftp: Fix two misuses of strncpy (read buffer overflow).

	* ftp/ftp.c (pswitch): Correctly set the terminating NUL.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	talk: Fix uninitialized variable NREADY.

	* talk/ctl_transact.c (ctl_transact): Initialize NREADY to 0.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	whois: Silence -Wimplicit-fallthrough.

	* whois/whois.c (main): Squeelch warning.

2020-02-29  Tim Rühsen <tim.ruehsen@gmx.de>

	ping, ping6: Silence -Wimplicit-fallthrough.

	* ping/ping.c (parse_opt): Squeelch warning.
	* ping/ping6.c (parse_opt): Likewise.

2020-02-17  Tim Rühsen <tim.ruehsen@gmx.de>

	ping6: Fix memleak in ping_set_dest.

	* ping/ping6.c (ping_set_dest): New function signature.
	Rearrange code to avoid memory leak.
	* ping/ping6.h (ping_set_dest): Change signature in declaration.

2020-02-17  Tim Rühsen <tim.ruehsen@gmx.de>

	ping: Fix memleak in ping_set_dest.

	* ping/libping.c (ping_set_dest): New function signature.
	Rearrange code to avoid memory leak.
	[HAVE_DECL_GETADDRINFO]: Rename P as RHOST.
	* ping/ping.h (ping_set_dest): Change signature in declaration.

2020-02-16  Tim Rühsen <tim.ruehsen@gmx.de>

	libls: Remove unused variable kflag.

	* libls/ls.c (ls_main): Remove unused variable.

2020-02-16  Tim Rühsen <tim.ruehsen@gmx.de>

	ftpd: Fix multiple definition (GCC 10).

	* ftpd/extern.h (errcatch): Declare as extern.
	* ftpd/ftpd.c (errcatch): Define variable.

2020-02-16  Tim Rühsen <tim.ruehsen@gmx.de>

	telnetd: Fix multiple definition (GCC 10).

	* telnetd/utility.c (not42): Declare as extern.

2020-02-16  Tim Rühsen <tim.ruehsen@gmx.de>

	* src/rcp.c (tolocal): Remove unused variable LEN.

2020-02-16  Tim Rühsen <tim.ruehsen@gmx.de>

	telnet: Fix silent truncation (off-by-one check)

	If the DISPLAY variable had exactly 44 bytes, the SE byte (end sub
	negotiation) was silently truncated.  This concerns CVE-2019-0053.

	* telnet/telnet.c (suboption): Add case of equality in conditional,
	supplementing strict inequality.

2020-02-21  Mats Erik Andersson  <gnu@gisladisker.se>

	Various compiler warnings, getting closer to `-Werror'.

	* libls/print.c (printlong): The functions major() and minor() have
	no portable value type, so cast as `int'.

	* ping/ping.c (decode_type): Initialize HOSTNAME to NULL.

	* src/hostname.c (parse_opt, main) <SET_NAME_ACTION>: The prototype
	of sethostname() is not portable, so cast as `void *'.  Do this
	also on both members in a conditional clause.
	* src/logger.c (parse_level): Cast PRIORITYNAMES and FACILITYNAMES
	as `CODE *', since BSD-systems assign these a constant type.
	* src/syslogd.c (textpri, cfline): Likewise.
	* src/rcp.c (source, rsource): Type length of `stat.st_mode' is not
	portable, so cast as `int'.
	* src/traceroute.c (trace_write): Make loop variable I unsigned.

2020-02-20  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd, rshd: Avoid false failure message.

	* src/rexecd.c (doit) [HAVE_SETLOGIN]: Only call setsid() in case
	the session leader is different from the present process.
	* src/rshd.c (doit) [HAVE_SETLOGIN]: Likewise.

2020-02-20  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Recursive reception was broken.

	The commit 67b49c54 broke the use case of locally receiving
	multiple files for a recursive copying action.  This was found
	and established by Zhixiong Chi.  Now revert the relevant part
	of the old commit, as the suggested patch is nearly a verbatim
	change back.  The differences await further analysis.
	Original report is contained in:
	https://lists.gnu.org/archive/html/bug-inetutils/2019-12/msg00000.html

	* src/rcp.c (sink) [targisdir]: Revert to the legacy, and functional,
	implementation of string allocation.

2020-02-10  Mats Erik Andersson  <gnu@gisladisker.se>

	Simplify coding of test program `runtime-ipv6', by using
	standard getopt() library function, thus making the code
	self sufficient.

	* tests/runtime-ipv6.c: Migrate away from argp_parse() to
	standard getopt().  Let environment variable VERBOSE contribute
	a short message in case the program tests successfully.
	Also use AI_NUMERICSERV for completeness.

2020-02-09  Mats Erik Andersson  <gnu@gisladisker.se>

	test-snprintf: New test program.

	An implementation dependent feature of snprintf() is tested.
	The BSD unices and OpenSolaris relatives are known to be more
	forgiving, than is Linux/glibc and kfreebsd/glibc.  The issue
	was brought to our attention by Zhixiong Chi in:
	https://lists.gnu.org/archive/html/bug-inetutils/2019-05/msg00002.html

	* tests/test-snprintf.c: New file.
	* tests/Makefile.am (check_PROGRAMS, TESTS): Add `test-snprintf'.
	* tests/.gitignore: Likewise.

2020-02-04  Mats Erik Andersson  <gnu@gisladisker.se>

	Buffer overflow in tftp and tftpd.
	Recent versions of Gnu libc and Gcc are injecting buffer checks
	into strcpy().  Both executables, tftp and tftpd, are effectively
	copying into a formally declared `char th_msg[1]', ignorant of
	the underlying buffer being of size PKTSIZE.
	Problem was reported by Mike Gilbert and Ricardo Ribalda Delgado:
	https://lists.gnu.org/archive/html/bug-inetutils/2017-12/msg00001.html
	https://lists.gnu.org/archive/html/bug-inetutils/2019-07/msg00002.html

	* src/tftp.c (nak): Replace strcpy() by memcpy(), after the
	needed calculation of string length.
	* src/tftpd.c (nak): Likewise.

	* tests/tftp.sh: New compound test with multiple requests.

2020-02-03  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: AUDA services Australia.
	Update server name.  Forwarded from Adam King:
	https://lists.gnu.org/archive/html/bug-inetutils/2018-07/msg00001.html

	* whois/tld_serv_list (.au): Update server, now at AUDA.

2020-02-03  Mats Erik Andersson  <gnu@gisladisker.se>

	Better portability for BSD install.
	Install hooks for programs that require root ownership, were written
	with GNU install in mind.  Reported and suggested by Bill Cole:
	https://lists.gnu.org/archive/html/bug-inetutils/2018-07/msg00005.html

	* ping/Makefile.am (install-ping-hook): Place program switches
	to INSTALL_PROGRAM before file argument, thus helping BSD install.
	Rewrite failure comment, and add exit error code.
	* src/Makefile.am (install-traceroute-hook, install-rsh-hook)
	(install-rlogin-hook, install-rcp-hook): Likewise.

2020-02-01  Mats Erik Andersson  <gnu@gisladisker.se>

	tests: Less system logging.

	* tests/ftp-localhost.sh (LOGGING): New variable.  Let the server
	program do system logging only if LOGGING has been defined.
	* tests/tftp.sh (LOGGING): Likewise.  Add a test case where a
	non-existing file is requested.  Check that the number of tries
	and of successes agree in order to suppress the final text.

	* README: Add some remarks on our testing abilities.

2020-01-31  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: IP delegation update.

	* whois/ip_del_list: Update with entries as stated by IANA
	with publication date 2019-12-27.

2020-01-31  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Failure of service name.
	The IANA has made badly founded changes to the list of port names,
	promoting `nicname' and introducing the aliases list `Who Is',
	thus making `Who' and `Is' into functional services, and also
	loosing `whois'.  Some systems were careless enough to adopt
	this badly wrought change.  Reported by Shahab Vahedi in:
	https://lists.gnu.org/archive/html/bug-inetutils/2020-01/msg00023.html

	* whois/whois.c (openconn): Fall back to service `nicname',
	should `whois' fail.

2020-01-29  Mats Erik Andersson  <gnu@gisladisker.se>

	More work on CVE-2019-0053.
	Telnet protocol messages must not be corrupted when buffer
	overflows are detected, but should be reported as errors.

	* telnet/telnet.c (suboption): Check that prepared protocol
	message in fact fits in intermediary buffer without truncation.
	Tweak indentation for visibility of protocol elements in snprintf.

	Allocate space also for final NUL-character.

	* telnetd/telnetd.c (telnetdrun): Increase DATA string size by one.
	* telnetd/termstat.c (localstat, flowstat, clientstat): Likewise.

	Insufficiently declared length of string variable.

	* telnetd/utility.c (printsub): Declare TBUF with maximal extent.

2020-01-28  Mats Erik Andersson  <gnu@gisladisker.se>

	Better test coverage, mostly IPv6.

	* tests/ftp-localhost.sh [TEST_IPV6 && TARGET6]: Add the possible
	test cases that existed for IPv4, but did not for IPv6.
	[do_transfer]: Explicitly remove copied $PUTME for reliability.
	[TEST_IPV6 && TARGET6 && do_transfer]: New test for name mapping.
	* tests/syslogd.sh [do_unix_socket || do_inet_socket]: Do priority
	`notice' for each of local socket, IPv4 socket, and IPv6 socket,
	as is applicable.
	(COUNT_WRAP): Reworked calculation on grounds as above.
	[do_inet_socket && TEST_IPV6 && TARGET6]: Test facilities `user.info'
	and `user.debug' with IPv6.
	* tests/tftp.sh (do_secure_setting): Test all of $ADDRESSES.

	* tests/.gitignore: Add runtime-ipv6 to list.

2020-01-27  Mats Erik Andersson  <gnu@gisladisker.se>

	Portability to an old Solaris shell.

	* tests/tools.sh.in (EGREP, FGREP, RUNTIME_IPV4, RUNTIME_IPV6):
	Inside parameter substitution, put value between quotes, since
	some old shells stumble on non-quoted space characters.
	* tests/ifconfig.sh (evaluation of FORMAT): Likewise.

	Make sure that scripts are individually executable.

	* tests/ftp-parser.sh (EXEEXT): Test empty before reading tools.sh.
	* tests/libls.sh (EXEEXT): Likewise.
	* tests/ifconfig_modes.sh: Read tools.sh.

2020-01-26  Mats Erik Andersson  <gnu@gisladisker.se>

	Examination of testing scripts.

	* tests/ftp-localhost.sh [TEST_IPV4 && TARGET]: Implement one
	additional level of indentation in this large text block.
	Some additional fixes of indentation and improved readability.

	* tests/inetd.sh: Improve regex when refusing test directories.
	* tests/syslogd.sh: Likewise.
	* tests/ping-localhost.sh: Use back quotes for portability.
	* tests/traceroute-localhost.sh: Likewise.

2020-01-24  Mats Erik Andersson  <gnu@gisladisker.se>

	runtime-ipv6: Implicit dependency on services file.
	In a chrooted test environment, access to a particular
	resource like /etc/services, need not be granted.

	* tests/runtime-ipv6.c: Replace symbolic service name `tftp'
	by a numerical and harmless port string.

2020-01-24  Mats Erik Andersson  <gnu@gisladisker.se>

	Separation of test cases according to IPv4, and to IPv6.
	The two precious macros TEST_IPV4 and TEST_IPV6 are controlling
	whether the indicated address family is checked in our tests.
	Test coverage is left unequal.

	* configure.ac (TEST_IPV4): New macro.  The new switch
	`--disable-ipv4' suppresses IPv4 during target `check'.
	* tests/Makefile.am (tools_subst): Replace @TEST_IPV4@.
	* tests/tools.sh.in (TEST_IPV4, RUNTIME_IPV4, RUNTIME_IPV6):
	New variables.
	(TEST_IPV4, TEST_IPV6): If either is `auto', make a runtime check
	for availability, and set to `no' in case of failure.

	* tests/runtime-ipv6.c: Implement switches `-4' and `-6', making
	it possible to test for either address family at runtime.
	[EAI_NODATA]: Return this error in a corner case, or else EAI_FAIL.

	* tests/ftp-localhost.sh: Remove code now existing in tools.sh.in.
	Separate existing test cases according to IPv4 and IPv6, by means
	of conditionals with TEST_IPV4 and TARGET, or TEST_IPV6 and TARGET6.
	[TEST_IPV4 = TEST_IPV6 = no]: Skip test.
	* tests/ping-localhost.sh: Likewise.
	* tests/syslogd.sh: Likewise.
	* tests/telnet-localhost.sh: Likewise.
	* tests/tftp.sh: Likewise.

	* tests/ifconfig.sh [TEST_IPV4 = no]: Skip test.
	* tests/inetd.sh (TARGET6): New variable.
	[TEST_IPV4 = TEST_IPV6 = no]: Skip test.
	Implement subcases for IPv6, and condition old cases on TEST_IPV4.
	* tests/traceroute-localhost.sh [TEST_IPV4 = no]: Skip test.
	[TEST_IPV4 && TARGET]: Condition each case completely.

2020-01-22  Mats Erik Andersson  <gnu@gisladisker.se>

	Correctly detect presence of IPv6.

	* tests/runtime-ipv6.c [AI_ADDRCONFIG] (hints.ai_flags):
	Add AI_ADDRCONFIG for better selectivity.

2020-01-20  Mats Erik Andersson  <gnu@gisladisker.se>

	Test robustly in absence of IPv6.
	For systems without functional IPv6 addressing at runtime,
	suppress this address family in our tests, whenever IPv6 was
	configured as autodetected.  Helpful answer by Bruno Haible
	originating from effects in a Raspbian system:
	https://lists.gnu.org/archive/html/bug-inetutils/2020-01/msg00021.html

	* tests/Makefile.am (check_PROGRAMS): Add `runtime-ipv6'.
	* tests/ftp-localhost.sh (RUNTIME_IPV6): New variable.
	[TEST_IPV6 == auto]: Set TEST_IPV6 to `no' when runtime presence
	of IPv6 is in the negative.  Thus effectively inhibiting all use
	within this script of IPv6 addresses.
	* tests/ping-localhost.sh: Likewise.
	* tests/syslogd.sh: Likewise.
	* tests/telnet-localhost.sh: Likewise.
	* tests/tftp.sh: Likewise.
	* tests/runtime-ipv6.c: New file.

	* configure.ac (AC_ISC_POSIX): Delete obsolete test.

2020-01-18  Mats Erik Andersson  <gnu@gisladisker.se>

	Minor portability glitches in Solaris and in AIX.

	* am/libcurses.m4 (IU_LIB_TERMCAP) [!_XOPEN_CURSES]: Conditionally
	include the header <term.h>.
	* telnet/telnet.c [HAVE_CURSES_TGETENT & !_XOPEN_CURSES]: Likewise.
	* telnetd/utility.c [HAVE_CURSES_TGETENT & !_XOPEN_CURSES]: Likewise.

	* ftp/ftp.c (h_errno): Delete declaration, not in use.
	* ftpd/ftpd.c (FTP_NAMES): Assign a value to this macro.

2020-01-14  Mats Erik Andersson  <gnu@gisladisker.se>

	Make test of ftp-parser slightly more forgiving.  Darwin systems
	might prepend a path stem to local directory.  Assaf Gordon reported
	https://lists.gnu.org/archive/html/bug-inetutils/2020-01/msg00005.html

	* tests/ftp-parser.sh: Check number of responses to mixed command
	list, and extract any prepended path resulting from `lcd'.
	(DIR_STEM): New variable.  This modifies matching test after `lpwd'.

2020-01-13  Mats Erik Andersson  <gnu@gisladisker.se>

	The Gnulib module `regex' requires linking that was not made
	explicit in our source.  Discovered by Bruno Haible with AIX 7.2.
	https://lists.gnu.org/archive/html/bug-inetutils/2020-01/msg00012.html

	* talkd/Makefile.am (LD_ADD): Add $(LIBTHREAD) and $(LIB_MBRTOWC).

2020-01-13  Mats Erik Andersson  <gnu@gisladisker.se>

	Attempt to build correctly on Cygwin, new and old. Reported
	and suggested by Bruno Haible in
	https://lists.gnu.org/archive/html/bug-inetutils/2020-01/msg00013.html

	* configure.ac: Check for header <arpa/tftp.h>.  When it is
	missing disable the targets `tftp', and `tftpd'.
	* am/enable.m4 (IU_ENABLE_FOO): Append $EXEEXT to `target_BUILD'.

2020-01-12  Mats Erik Andersson  <gnu@gisladisker.se>

	Suppress building of remote execution commands on systems that
	offer no rcmd functionality.  This happens with embedded systems
	like Alpine Linux and musl libc, as reported by Assaf Gordon and
	Bruno Haible.

	* configure.ac: Check for function rcmd().  Disable building
	of `rcp', `rlogin', and `rsh' when no rcmd variant is present.
	(WITH_RCMD): New precompiler macro.

2020-01-11  Mats Erik Andersson  <gnu@gisladisker.se>

	The glibc manual page for ether address specifies <netinet/ether.h>.
	Use this for GNU/Linux in the hope of resolving also musl libc, as
	used with Alpine Linux.  Reported by Bruno Haible.

	* ifconfig/system/linux.c [HAVE_NETINET_ETHER_H]: Include the
	library header <netinet/ether.h> instead of the system specific
	header <linux/if_ether.h>.

2020-01-11  Mats Erik Andersson  <gnu@gisladisker.se>

	Consistent use of `grep' tools in scripts.

	* configure.ac (EGREP, FGREP): New and precious variables.
	* tests/Makefile.am (tools_subst): Replace @EGREP@ and @FGREP@.
	* tests/ftp-parser.sh (reply): Use $EGREP to detect size in answer,
	and apply a single, alternating regex.
	* tests/ifconfig_modes.sh: Replace all `grep' by $GREP.
	* tests/inetd.sh: Likewise.
	* tests/libls.sh: Likewise.  Drop unused `-e' flag.
	* tests/syslogd.sh: Likewise.  Use `$FGREP -f' instead of
	non-portable `$GREP -f'.  In two cases where `grep' needed
	multiple regexes, use $EGREP and alternating regexes.
	* tests/tools.sh.in (EGREP, FGREP): New variables.

2020-01-01  Simon Josefsson  <simon@josefsson.org>

	telnet: Validate supplied environment variables. CVE-2019-0053
	* telnet/telnet.c (suboption): Use snprintf instead of sprintf.
	* telnet/utilities.c (printsub): Likewise.

2020-01-01  Guillem Jover  <guillem@hadrons.org>  (tiny change)

	* ping/ping_echo.c (struct icmp_diag): Fix typo.

2020-01-01  Simon Josefsson  <simon@josefsson.org>

	* NEWS: Document user-visible changes since last release.

2020-01-01  Simon Josefsson  <simon@josefsson.org>

	* THANKS: Credit Mats.

2020-01-01  Simon Josefsson  <simon@josefsson.org>

	* cfg.mk: Silence 'make syntax-check'.

2020-01-01  Simon Josefsson  <simon@josefsson.org>

	* bootstrap: Updated from gnulib.

2020-01-01  Simon Josefsson  <simon@josefsson.org>

	* telnet/telnet.c (telsnd): Telnet -E(no escape) is treating
	_POSIX_VDISABLE char as escape.
	Reported by Mikhail Bychek <mikhail.bychek@sputnix.ru>.

2018-11-12  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/tftpd.c (main): Add LOG_NDELAY to openlog().  The file
	descriptor for logging must be active before chrooting happens.

2018-11-09  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

	* configure.ac (AC_PREREQ): Require autoconf 2.63.  Gnulib needs
	a more recent version due to demands put forward by libtool.

2018-09-06  Simon Josefsson  <simon@josefsson.org>

	* README-alpha (Development): Remove broken links.

	* bootstrap: Updated from gnulib.

2017-07-10  Omer Anson <oaanson@gmail.com>  (tiny change)

	* src/hostname.c (parse_file): Free name and allocate one extra
	byte for it.

2017-07-10  Omer Anson <oaanson@gmail.com>  (tiny change)

	* src/hostname.c (set_name): Handle case when hostname_new is
	NULL.

2017-07-10  Omer Anson <oaanson@gmail.com>  (tiny change)

	* ftpd/ftpd.c (options) <max-timeout>: Mention mandatory argument.

2017-06-22  Omer Anson <oaanson@gmail.com>  (tiny change)

	* ftp/main.c (main): Don't assume that uninitialized argv[argv] is
	NULL.

2017-03-04  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Use tty, not pty on Solaris.
	Setting of terminal attributes as well setting of window size
	must be done via the slave descriptor, not the master descriptor.

	* telnetd/term.c [SOLARIS || SOLARIS10] (set_termbuf):
	New variables NAME, TTY.  A call to ptsname() reveals whether
	`pty' is a master.  Then open that file, update TTY, and call
	_term_setattr().
	[SOLARIS || SOLARIS10] (init_termbuf): Simplify to use a single
	call to _term_getattr(), similar to set_termbuf().
	* telnetd/termstat.c: Include <fcntl.h>.
	[TIOCSWINSZ && (SOLARIS || SOLARIS10)] (clientstat) <TELOPT_NAWS>:
	New variables NAME, TTY.  Similar mechanism as above, but call
	ioctl with window size.
	[TIOCSWINSZ && (SOLARIS || SOLARIS10)] (defer_terminit): Likewise.

2017-03-03  Mats Erik Andersson  <gnu@gisladisker.se>

	Test utility displays some termcaps.

	* tests/Makefile.am (identify_LDADD): Set to contain
	`$(top_builddir)/lib/libgnu.a' and `$(LIBUTIL)'.
	* tests/identify.c: Include <string.h>.
	[HAVE_TERMIOS_H]: Include <errno.h>, <termios.h>, <pty.h>.
	[HAVE_TERMIOS_H && HAVE_FCNTL_H]: Include <fcntl.h>.
	[HAVE_TCGETATTR] (test_flag): New macro.
	[HAVE_TCGETATTR] (do_termcap): New function.
	[HAVE_TCGETATTR] (main): Call do_termcap().

2017-03-02  Fredrik Fornwall  <fredrik@fornwall.net>  (tiny change)

	ftp: Portability to Android.
	Without a check for HAVE_DECL_GETPASS and without making a
	local function declaration, the implicit declaration causes
	crashes on 64-bit systems lacking declared getpass(), such
	as Android.  Reported in:
	http://lists.gnu.org/archive/html/bug-inetutils/2016-10/msg00000.html

	* ftp/cmds.c [!HAVE_DECL_GETPASS] (user, account): Declare getpass()
	as external function.
	* ftp/ftp.c (login): Likewise.

2017-03-02  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Update Canadian TLD server.
	Old host name no longer exists.  Reported by Neil Mayhem:
	http://lists.gnu.org/archive/html/bug-inetutils/2017-01/msg00000.html

	* whois/tld_serv_list (.ca): New host 'whois.cira.ca'.

2017-02-27  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Portability of TTY termcap to Solaris systems.

	* telnetd/term.c: Include header <fcntl.h>.
	[SOLARIS10 || SOLARIS] (init_termbuf): If applicable, open
	the slave TTY and extract terminal capabilities, since these
	systems do not assign a line discipline to the master PTY.
	New variables NAME and TTY.

2017-02-27  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Portable option debugging.
	BSD systems assign IAC and _POSIX_VDISABLE the common decimal
	value 255. Hence the NVT enforces value duplication more often
	during their transmission, than GNU and Solaris systems do.

	* telnetd/utility.c (printsub) <LM_SLC>: Increase suboption
	pointer I sufficiently to counteract duplication.  This has
	to distinguish between in/out/none.  In recursive mode,
	suppress newline at the end of suboption printing.

	* telnetd/slc.c (send_slc) <SLC_EC, SLC_EL, SLC_EW, SLC_RP>
	<SLC_LNEXT>: Editing characters are reported using SLC_DEFAULT
	rather than ignored due to SLC_NOSUPPORT, when they are not
	supported locally.  This conforms with RFC 1184, section 2.4.
	The test for support checks the set 'current', not 'defset',
	which fits the wording found in RFC 1184.

2017-02-23  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Scrub USER from environment.
	Discard the environment variable USER.  It will later be set
	properly for autologin, but at least one BSD system passes
	a preset value when telnetd starts, a value which will cause
	rejected login when autologin is not in effect.

	* telnetd/telnetd.c (telnetd_setup): Unset environment
	variable USER before calling getterminaltype().

2017-02-21  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2017-02-21  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Debugging of mainly line mode options.

	* telnetd/telnetd.c (telnetd_run): Assemble flow control data
	in new string variable DATA, then send it and include for debug
	reporting in category 'options'.
	* telnetd/termstat.c (localstat, flowstat, clientstat): Likewise,
	also for line mode data.

	* telnetd/utility.c (printsub) <LM_MODE>: Test TBUF[0]
	to calculate replacement string, since TBUF[1] is not
	guaranteed to be initialized by the preceding snprintf().

2016-05-23  Mats Erik Andersson  <gnu@gisladisker.se>

	hostname: Avoid a trailing space.
	Suppress the space character after the last presented IP number.
	Problem reported by Terje Strand in
	http://lists.gnu.org/archive/html/bug-inetutils/2016-04/msg00001.html

	* src/hostname.c (get_ip_addresses): Emit a space character
	only in case a further IP address will be printed.

2016-02-16  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Subprivileged use case.
	A fallback for ICMP tracing relevant to GNU/Linux is implemented,
	allowing a rudimentary but suid-less use case.  The ability to
	identify intermediary hosts is missing, due to the crippled
	capability of receiving ICMP packets other than ICMP_ECHOREPLY.

	* src/traceroute.c (struct trace): New member `no_ident'.
	(trace_init): Initiate `t->no_ident'.
	<type TRACE_ICMP or TRACE_UDP>: In case a raw socket for an ICMP
	protocol fails, fall back to a datagram socket.
	(trace_read) <type TRACE_ICMP>: Short circuit `ic->icmp_id != pid'
	with the conditional `t->no_ident == 0'.
	(trace_write) <type TRACE_ICMP>: New variable I.  Initialize HDR
	to its full extent.  If `t->no_ident' is non-zero, insert our
	intended target as payload of HDR for trace identification.

2016-02-12  Mats Erik Andersson  <gnu@gisladisker.se>

	ping: Implement subprivileged echo method.
	Add fallback code usable by GNU/Linux to create a datagram
	socket for sending ICMP ECHOREQUEST.  The change is related
	to issue #37252.

	* ping/libping.c (useless_ident): New variable.
	(ping_init): When a raw socket fails, fall back to a datagram
	socket.  In case of success, increase `useless_ident' since
	the kernel choses a packet identity, overwriting our choice.
	(my_echo_reply, ping_recv): Short circuit the tests for packet
	identity with the value of `useless_identity'.

2016-02-09  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac (missing ipv6 or icmp6): Disable `ping6' using
	the macro IU_DISABLE_TARGET.

2016-01-23  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Allow remote user in command.
	Ability implemented after a query by Andreas Adamcik, on the
	legacy use of getlogin() versus the more admitting getuid().

	* ftp/ftp.c (hookup): Check for an embedded at-sign in the input
	variable `host', keeping the rightmost part.  New variable P.
	(login): Likewise, but also using the string part to the left of
	the last at-sign as remote user name.

	* doc/inetutils.texi (ftp invocation): Document this ability.
	* NEWS: Likewise.

2016-01-22  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2015-12-29  Mats Erik Andersson  <gnu@gisladisker.se>

	tests/ftp-localhost.sh: Incomplete error handling.
	The use of sysctl(8) with option `set -e` active during
	script execution needs a robust exception handler.
	Reported by Ingo Brückl in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-12/msg00000.html

	* tests/ftp-localhost.sh: Locate sysctl(8) using `command`
	with an augmented search path.  When computing VALUE_V6ONLY
	in a subshell, add a short circuit with `true` to prevent
	interruption of the test script.
	(SYSCTL): New variable.

2015-10-08  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Redefine faulty macro LOG_MAKEPRI whenever needed.
	Systems with Glibc header file <syslog.h> prior to 2.17,
	are not correctly defining the helper macro LOG_MAKEPRI.
	This effects our syslog service whenever it receives kernel
	messages from a remote host.  The issue was mentioned in
	Debian's BTS as report #729666.

	* src/logprio.h [LOG_MAKEPRI]: Check that the macro does
	not shift the first argument.  If it does, undefine it and
	apply our corrected definition.
	* src/syslogd.c [LOG_MAKEPRI]: Likewise.  Display a precompiler
	warning to the effect that we have diagnosed an issue.

2015-09-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* doc/inetutils.texi (ifconfig invocation): New chapter.

2015-08-19  Mats Erik Andersson  <gnu@gisladisker.se>

	AIX systems have a system call send_file().  Rename our calls.
	* src/tftp.c (send_file): Rename to...
	(tftp_sendfile): ... this.
	(put): Call tftp_sendfile, not send_file.
	* src/tftpd.c (send_file): Rename to...
	(tftpd_sendfile): ... this.
	(formats): List tftpd_sendfile call, not send_file.

2015-08-15  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Premature connection closure.
	When many connections are attempted in quick succession,
	a substantial number of them are cancelled.  This does not
	appear for manual use cases, but for contrived automated
	set-ups.  The cause seems to be a change in the evaluation
	of pty_read(), which was done to coincide with the condition
	in use by the original BSD implementation.  Issue reported and
	suggested by Chris Severance in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-07/msg00006.html

	* telnetd/telnetd.c (telnetd_run): Break the loop only by the
	stronger condition `pty_read() < 0', i.e., only on non-masked
	read errors.  This reverts a change introduced in 2015-03-15.
	* telnetd/utility.c (pty_read): Add a comment that the read
	errors EWOULDBLOCK, EAGAIN, and EIO are treated specially.

2015-08-07  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Statistics for BSD systems.

	* ifconfig/system/bsd.c (system_fh_ifstat_query)
	(get_if_data_by_name, system_fh_missing_stat): New functions.
	(_IU_DECLARE2): New macro.
	(system_fh_rx_bytes, system_fh_rx_dropped, system_fh_rx_errors)
	(system_fh_rx_packets, system_fh_tx_bytes, system_fh_tx_errors)
	(system_fh_tx_packets, system_fh_collisions): New functions
	defined using _IU_DECLARE2.
	(system_fh_tx_dropped): New function.
	* ifconfig/system/bsd.h (_IU_CAT2, _IU_DCL, _IU_EXTRN): New
	macros identical to those in `ifconfig/system/linux.h'.
	(SYSTEM_FORMAT_HANDLER) <ifstat?, collisions, rxbytes>
	<rxdropped, rxerrors, rxfifoerr, rxframeerr, rxpackets>
	<txbytes, txcarrier, txdropped, txerrors, txfifoerr, txpackets>:
	New handler hooks.
	(system_fh_ifstat_query, system_fh_missing_stat): New prototypes.
	(system_fh_rx_bytes, system_fh_tx_bytes, system_fh_rx_dropped)
	(system_fh_tx_dropped, system_fh_rx_errors, system_fh_tx_errors)
	(system_fh_rx_packets, system_fh_tx_packets, system_fh_collisions):
	New prototypes generated by _IU_EXTERN.

2015-08-02  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Verbose report on changed flags.

	* ifconfig/changeif.c (set_flags): In verbose report mode,
	compose a message to name those flags that were set, and
	also those that were cleared.

2015-08-01  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Apply flags correctly.
	When finalizing actions, some flags could be forgotten.
	In particular, the flag 'up' was ignored whenever an
	address was assigned at the same time.  This is related
	to the fact that an invocation only effecting interface
	flags, still resulted in a full printout if interface
	status.  This latter behaviour differs from all other
	implementations and is rather annoying.  The issue was
	detected and reported by Hans-Peter Budek in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-07/msg00000.html

	* ifconfig/options.c (pending_setflags, pending_clrflags):
	Define as static variables.
	(pending_valid): New variable.
	(argp_options) <message 'up'>: Delete the claim that 'up' be
	a default action together with address.
	(parse_opt_set_flag): When `ifp' exists, update `ifp->valid'
	with IF_VALID_FLAGS.  Otherwise, update `pending_valid'.
	(parse_opt_finalize): If `ifp' exists and `pending_valid` is
	set, then update `ifp->valid'.  The update of `ifp->setflags'
	and `ifp->clrflags' is performed independently of assigning
	an output format, as the latter would cause a printout also
	when only some flag is being altered.
	* ifconfig/options.h (IF_VALID_FLAGS): New macro.
	(IF_VALID_HWADDR): Updated value.
	(pending_setflags. pending_clrflags): Removed declaration.

2015-07-30  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: A work-around specific to GNU/Hurd.
	This system uses a mixture of BSD definitions
	and GNU/Linux interfaces.  In particular, some
	care is needed to check interface hardware type.

	* ifconfig/system/hurd.c (_ARP_MASK): New macro.
	(arphrd_symbols): Apply _ARP_MASK to each member `value'.

2015-07-25  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Symbolic name as peer address.

	* ifconfig/changeif.c (set_dstaddr): Adapt code block used
	by set_address(), thereby first using either getaddrinfo()
	or gethostbyname() to resolve a possibly symbolic peer
	destination, then setting the established address.

2015-07-25  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Support changing of hardware address.
	Implement the setting of link level addresses
	for systems running GNU/Linux.

	* ifconfig/changeif.c [HAVE_NETINET_ETHER_H]: Include
	header <netinet/ether.h>.
	(set_hwaddr): New function.
	(configure_if): Call set_hwaddr() whenever `ifp->valid'
	contains IF_VALID_HWADDR.
	* ifconfig/options.c (ifconfig_initializer): Add a further
	NULL at the end.
	(parse_opt_set_hwaddr): New function built by the generic
	macro PARSE_OPT_SET_ADDR.
	* ifconfig/options.h (struct ifconfig): Define IF_VALID_HWADDR
	and add a new member `hwaddr'.
	(parse_opt_set_hwaddr): New prototype.

	* ifconfig/system/linux.c (system_help): Add parsed option
	`ether|hwaddr|lladdr MACADDR'.
	(system_parse_opt_rest): New enum value EXPECT_HWADDR.  Insert
	this into the parser, triggering on all the keywords `ether',
	`hwaddr', and `lladdr' for best portability.

2015-07-21  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Implement a hardware list for BSD systems.
	Patterned on the hardware recognition already in use
	by GNU/Linux, use a similar mechanism for all of BSD.

	* ifconfig/system/bsd.c (print_hwaddr_ether): New function.
	(ift_symbols): New variable.
	(ift_findvalue): New function.
	(system_fh_hwaddr_query, system_fh_hwaddr)
	(system_fh_hwtype_query, system_fh_hwtype): Adjust mechanisms
	to use the table `ift_symbols' via ift_findvalue().


	ifconfig: Report tunnels in two more formats.

	* ifconfig/options.c (formats) <gnu-one-entry format>:
	Add two entries for the endpoints of tunnels.
	<osf format>: Add a line to display tunnels.


	ifconfig: Add a missing interface flag.

	* ifconfig/flags.c [IFF_CANTCONFIG] (if_flags): Add the
	extended interface flag `CANTCONFIG'.

2015-07-20  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: More info on tunnel interfaces.

	* ifconfig/options.c (formats) <net-tools format>: Add
	destination address for point-to-point interfaces.  It is
	present in some other formats.
	<unix format>: Display tunnel addresses for p-t-p interfaces.
	<osf format>: Add destination address for p-t-p interfaces
	and hardware type and hardware address for any device.

	* ifconfig/system/bsd.c (system_fh_brdaddr_query): Check
	that IFF_BROADCAST is set and access the relevant member
	`fp->ifa_broadaddr'.
	(system_fh_brdaddr): Check for set IFF_BROADCAST.
	(system_fh_tunnel_query, system_fh_tundst, system_fh_tunsrc):
	New functions.
	* ifconfig/system/bsd.h (SYSTEM_FORMAT_HANDLER): Add the
	keys `tunnel?', `tundst', and `tunsrc'.
	(system_fh_tunnel_query, system_fh_tundst, system_fh_tunsrc):
	New prototypes.

2015-07-18  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Integer overflow.
	During transmission of large files, size exceeding 2GB,
	a long integer variable overflows.  Issue reported and
	identified by Wenlin Kang in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-07/msg00004.html

	* src/rcp.c (sink): Change SIZE to have type `off_t'.

2015-07-18  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Improve the support for GNU/Hurd.
	Add system specific abilities, including parsing of command
	line and hardware addresses.

	* ifconfig/system.h [__GNU__]: Include "system/hurd.h".
	* ifconfig/system.c [__GNU__]: Include "system/hurd.c".
	* ifconfig/system/Makefile.am (noinst_HEADERS): Add the
	files `hurd.h' and `hurd.c'.
	* ifconfig/system/hurd.h, ifconfig/system/hurd.c: New files.

	* ifconfig/system/generic.c: Include <unused-parameter.h>.
	(system_parse_opt, system_parse_opt_rest, system_configure):
	Apply _GL_UNUSED_PARAMETER to all arguments, as these functions
	are placeholders and no-ops.

2015-07-17  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Sporadically appearing regression.
	Device flags are sometimes calculated before their
	query using SIOCGIFFLAGS.  First observed on GNU/Hurd.

	* ifconfig/printif.c (fh_brdaddr_query, fh_dstaddr_query):
	Execute ioctl(SIOCGIFFLAGS) before calculating UFLAGS.

2015-05-27  Alfred M. Szmidt  <ams@gnu.org>

	* Makefile.am (ACLOCAL_AMFLAGS): New variable.

2015-06-06  Guillem Jover  <guillem@hadrons.org>

	* ftp/cmds.c (setpeer): Misspelled message.

2015-05-22  Guillem Jover  <guillem@hadrons.org>

	libls: Alignment issue on sparc systems.
	The test suite executed by Debian's build daemon
	uncovered a failure on sparc due to incomplete
	alignment on word boundaries.

	* libls/fts.c (ALIGNBYTES, ALIGN): New macros.
	(fts_alloc): Add ALIGNBYTES to the size being allocated
	to P, a structure FTSENT.  Then compose the assignment of
	`P->fts_statp' with macro ALIGN to force correct alignment
	for the pointer to `struct stat'.

2015-05-19  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Fix BSD-specific interface access.
	Recently FreeBSD abandoned support for ioctl calls
	with SIOCGIFNETMASK and SIOCGIFBRDADDR.  Instead the
	use of `struct ifaddrs' is the only mechanism.  This
	had already been put to use in other cases, and is
	portably available in all BSD flavours.

	* ifconfig/system/bsd.c (system_fh_brdaddr_query)
	(system_fh_brdaddr, system_fh_netmask_query, system_fh_netmask):
	New functions.
	* ifconfig/system/bsd.h (SYSTEM_FORMAT_HANDLER): Add the new
	functions to this list, thus replacing the default handlers.
	Also add their prototypes.

2015-05-18  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Accept named, non-numerical ports.

	* ftp/cmds.c (setpeer): Test whether port string looks
	numerical.  Perform a look-up in the contrary case.

2015-05-17  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Regression during interface selection.
	Without arguments, ifconfig is expected to print status
	of all interfaces that are in state `UP'.  The mechanism
	to detect this state was corrupted when 32-bit flags were
	implemented.  The issue was reported by Juergen Daubert in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-05/msg00002.html

	* ifconfig/printif.c (fh_ifdisplay_query): Logically invert
	every use of N.
	[SIOCGIFFLAGS] (fh_ifdisplay_query): Calculate UFLAGS after
	executing `ioctl(SIOCGIFFLAGS)', since only then is the value
	of `form->ifr->ifr_flags' valid.  This side effect of ioctl()
	was not taken into account in previously committed code with
	32-bit flags.

2015-05-13  Guillem Jover  <guillem@hadrons.org>

	ping, ping6: Always use line buffered output.
	When stdout is redirected, libc will change the stream to
	be fully buffered.  Suppress this, gaining the standard
	behaviour of other implementations.  Issue was first reported
	as a wishlist bug of Debian: https://bugs.debian.org/782727.

	* ping/ping.c (main): Request line buffering on stdout, adding
	a call to setvbuf().
	* ping/ping6.c (main): Likewise.

2015-05-12  Alfred M. Szmidt  <ams@gnu.org>

	* bootstrap.conf (gnulib_modules): Add announce-gen.

2015-05-02  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/inetd.sh (PASSWD, PWDDB, PROTOCOLS): New variables.
	Check for system files required by `inetd'.  Skip test when
	not found, which can happen in incomplete chroots.

2015-04-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftpd/conf.c, ftpd/ftpd.c, ifconfig/system/bsd.c,
	ifconfig/system/linux.c, libtelnet/encrypt.c: Remove
	duplicate semicolon.

2015-04-16  Mats Erik Andersson  <gnu@gisladisker.se>

	* cfg.mk (git-version-gen-tag-sed-script): New variable using
	the same sed script as found in `configure.ac'.  It is needed
	to get a more reliable target `dist'.

	* tests/.gitignore: Add some generated test products.

2015-04-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.
	* doc/.gitignore: Add `/gendocs_template_min'.  The file
	is added during bootstrap.

2015-04-09  Mats Erik Andersson  <gnu@gisladisker.se>

	Incomplete test of syslogd.
	Whenever message passing via local socket is disabled,
	the wrapping test caused a false negative.  Fix this by
	letting it fall back to an INET socket.

	* tests/syslogd.sh: Include the `wrapping message' whenever
	either of $do_unix_socket or $do_inet_socket is true.  Fix the
	counter COUNT_WRAP to be set under the same prerequisite only.

2015-04-08  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Overlapping string locations.
	Configuration lines with leading white space are normalized
	by copying a string to an overlapping location.  Issue found
	by Alex Kost and reported to us in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-04/msg00001.html

	* src/syslogd.c (load_conffile): Declare P in smallest
	possible code block.  Use `memmove' instead of `strcpy'
	to neutralize the effects of overlapping locations.

	* tests/syslogd.sh: Add a new test case, checking resistance
	to leading white space and wrapped lines in configuration file.
	(OUT_NOTICE, COUNT_NOTICE, wrapped, COUNT_WRAP): New variables.

2015-04-02  Mats Erik Andersson  <gnu@gisladisker.se>

	Testing of inetd service.

	* tests/inetd.sh: In verbose mode, report the value of USER.
	Include a printout of the configuration file when the SIGHUP
	test loop fails.

2015-03-31  Alfred M. Szmidt  <ams@gnu.org>

	* doc/inetutils.texi: Re-order chapters.

2015-03-30  Mats Erik Andersson  <gnu@gisladisker.se>

	Texinfo: Slight reordering of nodes.
	This makes all chapters consistent in themselves.

	* doc/inetutils.texi: Put direntry `dnsdomainname' first in
	dircategory `Individual utilities', for alphabetic reasons.
	Interchange nodes `dnsdomainname invocation' and `hostname
	invocation' in response to that change.
	(ftp invocation): In sub-menu, move `The .netrc file' to be
	last entry in the list.  Move the node `Ftp environment' from
	last to third relative position in this chapter.  Position
	three comes from the ordering in the established sub-menu.

2015-03-30  Mats Erik Andersson  <gnu@gisladisker.se>

	Texinfo: Improve typeset output.

	* doc/inetutils.texi: Replace all @smallexample by @example.
	(inetd invocation): Make the multi-line example two spaces
	narrower in order to fit into a rendered PDF page.
	(tftpd invocation): Rephrase a sentence for easier line breaks,
	thus avoiding text extending into the right margin.

2015-03-21  Mats Erik Andersson  <gnu@gisladisker.se>

	Portability of time format string.

	* telnetd/utility.c (_var_short_name) <case 'd'>: Change `%P'
	to `%p' in format string for strftime(), as the former is a
	GNU exclusive extension of no portability at all.  Another
	conversion specifier `%l' is not POSIX conforming, but seems
	to be generally supported, so it is left untouched.

2015-03-20  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Texinfo documentation.

	* doc/inetutils.texi (telnetd invocation): Add a section
	on the use of replacement tokens in the execution string.

2015-03-19  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Enable autologin in legacy mode.
	Without Kerberos authentication the autologin code was not
	determining what user name to hand over to the login service.
	Adding the user name, when applicable, resolves the issue.
	Bug was reported by Kuaikuai Wu in
	http://lists.gnu.org/archive/html/bug-inetutils/2014-12/msg00010.html

	* telnetd/telnetd.c [SOLARIS10] (login_invocation):
	Add device path "-d %L" and user name "%U", the latter
	in the form of an else clause to the selector "%?u".
	[!SOLARIS10] (login_invocation): Likewise for "%U" only.

	* telnetd/utility.c (getterminaltype): Change the paramater
	name `user_name' to `uname', as the former shadows a precious
	and global variable name.
	(_var_short_name) <case 'L'>: New case, returning full path
	to the PTY device assigned to client.
	<case 'U'>: New case, returning a copy of the environment
	variable USER, or an empty string.

2015-03-16  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Honour host aliases.
	While establishing the connection, do not replace the desired
	peer name with its canonical name.  This prevents correct use
	of the netrc file.  Bug reported by John Sullivan in
	http://lists.gnu.org/archive/html/bug-inetutils/2015-02/msg00000.html

	* ftp/cmds.c (setpeer): Do not assign value from hookup()
	to HOST.  Instead, only test if it is non-null.

2015-03-15  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Suppress PTY packet data.
	The server is receiving PTY input in packet mode, but is not
	properly discarding PIOCPKT_DATA before handing over input
	to the network socket.  Do this correctly.

	* telnetd/telnetd.c (telnet_run) <input from pty>: Break the
	loop also if pty_read() returns zero.  Add a final call to
	pty_get_char() before ending FD_ISSET(pty, &ibits).  This call
	was mistakenly located within the subcase where TIOCPKT_NOSTOP
	or TIOCPKT_DOSTOP is handled.

2015-03-14  Mats Erik Andersson  <gnu@gisladisker.se>

	Complaints during IPv6-less testing.
	Unused IPv6 directives cause logged complaints by inetd.

	* tests/ftp-localhost.sh: Add a tcp6 listener to `inetd.conf'
	only if TEST_IPV6 is not `no'.
	* tests/tftp.sh: Likewise with udp6.

2015-03-14  Mats Erik Andersson  <gnu@gisladisker.se>

	Build failures while IPv6 is disabled.

	* configure.ac (ENABLE_hstrerror): New conditional variable.

	* src/rlogind.c [IPV6] (checkhost): Move right parenthesis
	outside of precompiler conditional.

	* telnetd/Makefile.am [ENABLE_hstrerror]: Add $(LIBRESOLV)
	to LDADD.  With IPv6 disabled, the code in `telnetd/telnetd.c'
	uses hstrerror(), so Solaris must link against libresolv.

2015-02-28  Mats Erik Andersson  <gnu@gisladisker.se>

	Fully configure testing without IPv6.
	Pick up testing addresses for IP and IPv6 at configuration time.
	Now a BSD jail can successfully test all network services.

	* configure.ac (TARGET, TARGET6): New precious variables.  Set their
	default values.
	* tests/Makefile.am (tools_subst): Add TARGET and TARGET to substi-
	tution rules.
	* tests/tools.sh.in (TARGET, TARGET6): New variables.

	* tests/ifconfig.sh (TARGET, target): New variables.
	(find_lo_addr): Replace hardcoded `127.0.0.1' with `$target'.
	* tests/ping-localhost.sh <ping6>: Add a test `$TEST_IPV6 != no'.
	* tests/syslogd.sh (TARGET6): Remove surrounding brackets.
	<$TEST_IPV6 != no>: Enclose `$TARGET6' in brackets for `$LOGGER'.

2015-02-27  Mats Erik Andersson  <gnu@gisladisker.se>

	Allow testing without IPv6.
	Configuration with `--disable-ipv6' as well as individual
	tests with `TEST_IPV6=no' need to avoid mandatory IPv6.

	* configure.ac (TEST_IPV6): New precious variable.
	* tests/Makefile.am (tools_subst): Add substitution of TEST_IPV6.
	* tests/tools.sh.in (TEST_IPV6): New variable.

	* tests/ftp-localhost.sh: Check `$TEST_IPV6 != no' before adding
	any test cases with IPv6 addressing.
	* tests/syslogd.sh: Likewise.
	* tests/telnet-localhost.sh: Likewise.
	(TARGET46): New variable, defaulting to `::ffff:$TARGET'.

	* tests/tftp.sh (TARGET, TARGET6): New variables.
	<$ADDRESSES = sense>: Compute this case before building a default
	address list.  Add switch `-a' when executing $IFCONFIG.
	(ADDRESSES): Start with TARGET, add TARGET6 if `$TEST_IPV6 != no'.

2015-01-31  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet: Printing of uninitialized characters.
	When preparing submodes of linemode for presentation, in case
	no submode is set, the string to be printed might make use of
	uninitialized string content, in an otherwise sane call to
	fprintf().  This is in error already in the legacy code.

	* telnet/utilities.c (printsub) <LM_MODE>: Test TBUF[0]
	to calculate replacement string, since TBUF[1] is not
	guaranteed to be initialized by the preceding sprintf().

2015-01-30  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2015-01-20  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Incomplete processing of PTY data.
	The reception of SIGCHLD can make the transfer of data from
	the PTY stream to the client side's network stream incomplete.
	The problem was raised as Debian Bug #607415, but is applicable
	also here, due to a common origin.  A setting with the option
	`-E /some/script' displays this error irregularly.

	* telnetd/telnetd.c (pending_sigchld): New variable.
	(telnetd_setup): Call setsig() when assigning SIGCHLD.  Set the
	action to chld_is_done().
	(telnetd_run) <I/O-loop>: If pending_sigchld is set, flush the
	network output buffer and exit the loop with cleanup(SIGCHLD).
	(chld_is_done): New function, used as signal action.

	* telnetd/utility.c (pty_read) <DEBUG>: Set consistent text
	prefixes in output.
	(printdata): Cast char array value as `unsigned char' to avoid
	an implicit cast as integer, implied in the format string `%02x'.

2015-01-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* telnetd/state.c (dooption) : Remove outdated and misnamed
	ifdef on TELOPT_ENVIRON.
	(suboption): Remove outdated ifdef on TELOPT_NEW_ENVIRON.
	(send_status) <DEBUG>: Pass only the suboption payload into
	printsub(), by stepping over IAC+SB in the string buffer.
	* telnetd/utility.c (printsub) <default>: When an unexpected
	mode must be reported numerically, print the correct byte in
	pointer[0], not some other pseudo-random value.

2014-11-11  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2014-11-11  Mats Erik Andersson  <gnu@gisladisker.se>

	ping: Fix testing when ping6 is not built.
	Reported by jb999 in bug-inetutils.

	* tests/ping-localhost.sh: Bracket test clauses to
	conform with intuitive logic and precedence rules.

2014-10-17  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd, logger: Incomplete range checking.

	* src/logger.c (IU_MAX_FAC): Delete macro.
	(decode): Use LOG_FACMASK in range checking.  The use of
	numeric facilities was broken for the most part.

	* src/logprio.h [!LOG_MAKEPRI] (LOG_MAKEPRI): Change to
	a portable and correct definition.
	[!INTERNAL_MARK] (INTERNAL_MARK): Adjust to the corrected
	behaviour of LOG_MAKEPRI.

	* src/syslogd.c [!LOG_MAKEPRI] (LOG_MAKEPRI): Change to
	a portable and correct definition.
	(printline): Reset `pri' to DEFUPRI whenever the facility
	is non-existent.  This protects against CVE-2014-3684.
	Make a three bit shift of LOG_KERN for code consistency.
	(cfline): After decoding priority, check also upper limit.
	Likewise for facility, and update `facilities_seen' only
	after a completed range error check.

	* tests/syslogd.sh (OUT_UNOTICE, OUT_LOCAL0): New variables.
	(COUNT4, COUNT5, COUNT4_notice, COUNT4_illegal, COUNT5_user)
	(COUNT5_local): Likewise.
	Add three new configuration stanzas to initial setup, all with
	invalid information.  In the second setup, capture facility
	`info' exactly, and make a new `notice' also exact.  Add a
	further file in the conf-directory, specifying capture of
	`local0.=notice'.  Add five new test messages using Unix
	socket, intending to detect more accurately the handling of
	priorities, numerical as well as illegal or default values.

2014-08-29  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/libls.sh: Add a dummy execution of $LS in order
	to avoid a false negative caused by code coverage runs.

2014-08-13  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/libls.sh <VERBOSE>: Execute `set -x'.
	(REPLY_a1, REPLY_A1, diff): Changed.  Update the check
	based on these, thus avoiding `sed -n '$='' which could
	not be trusted on NixOS' build daemon.

2014-08-11  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/libls.sh: Improve failure diagnostic when testing
	the switches `-a' and `-A'.  The build daemon at NixOS had
	an issue during this subcase.

2014-08-03  Mats Erik Andersson  <gnu@gisladisker.se>

	Support libshishi with Sun Studio.

	* configure.ac <shishi>: Call AC_SEARCH_LIBS, not AC_CHECK_LIB,
	when looking for libshishi.  This allows the C-compiler from
	Sun Studio 12.1 to correctly detect and build shishi support.

2014-08-02  Mats Erik Andersson  <gnu@gisladisker.se>

	More tests for better code coverage.

	* tests/Makefile.am [ENABLE_libls] (dist_check_SCRIPTS):
	Add `libls.sh'.
	[ENABLE_ftp] (dist_check_SCRIPTS): Add `ftp-parser.sh'.
	* tests/ftp-parser.sh: New script.
	* tests/ifconfig.sh: Add more test cases.
	* tests/libls.sh: New script.

	* ifconfig/options.c (formats): Add format `?' as a synonym
	for format `help'.

2014-08-01  Mats Erik Andersson  <gnu@gisladisker.se>

	ping, ping6: Repair pattern production.
	A pattern stated on the command line was never made
	productive, instead only nulls were inserted to the
	correct length.

	* ping/ping.c, ping/ping6.c (pattern_len): Set to MAXPATTERN.
	(parse_opt): Size of PATTERN is now MAXPATTERN.

	* ping/ping_common.h (MAXPATTERN): New macro.
	* ping/ping_common.c (init_data_buffer): Increment I before
	checking for end of pattern.  This avoids an insertion of
	the closing null character.
	(decode_pattern): Remove _GL_UNUSED_PARAMETER on `pattern_data'.
	Insert scanned data C into pattern buffer.

2014-08-01  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftp/ftp.c (ptransfer): Change BS to be of type float.
	Improve readability by having speed estimates printed
	as `Mbytes/s', `kbytes/s', or `bytes/s' as suitable.

2014-07-30  Alfred M. Szmidt  <ams@gnu.org>

	* telnetd/utility.c (nextitem, netclear, printoption, printsub)
	(printdata): Remove register keyword usage.

	(printsub): Don't add integer to string to try and skip quote.

2014-07-28  Giuseppe Scrivano  <gscrivan@redhat.com>

	* tests/ls.c: Include <config.h> not "config.h".

2014-07-26  Mats Erik Andersson  <gnu@gisladisker.se>

	whois: Cooperate with misbehaving servers.
	Some servers, like "whois.ripe.net", "whois.arin.net",
	and "whois.eu", partially abort communication when the
	socket is closed for writing.  Report by Alexander Zubkov:
	<http://lists.gnu.org/archive/html/bug-inetutils/2014-07/msg00003.html>.

	* whois/whois.c (gwhois_argp_options): Increase GRP
	and insert a separating subheader.
	(do_query): Remove call to shutdown().  The alternate
	and much similar lookup call query_crsnic() did not
	half-close the socket for writing.

	* doc/inetutils.texi (whois invocation): Add a section
	about environment variables accessed by `whois'.

2014-07-22  Mats Erik Andersson  <gnu@gisladisker.se>

	libls: Inconsistent options.
	The options '-l', '-m' and '-n' were not overruling each
	other in the expected manner.  Build `ls' from `libls' for
	testing purposes, but do not install it.

	* configure.ac (enable_libls): Set to `no' when testing
	against `ac_cv_func_fchdir' fails.  Publish with AC_SUBST.
	[ENABLE_libls]: New variable.
	* summary.sh.in (libls_BUILD, libls_PROPS, enable_libls):
	Detect these; report whether `libls' is being built.

	* libls/ls.c (ls_main) <'l' || 'm' || 'n'>: Reset missing
	flags correctly, in order that '-l', '-m' and '-n' overrule
	each other on the command line.

	* tests/Makefile.am [ENABLE_libls] (noinst_PROGRAMS): Add `ls'.
	[ENABLE_libls] (ls_LDADD): New variable.
	* tests/ls.c: New file.

2014-07-17  Mats Erik Andersson  <gnu@gisladisker.se>

	Portability of canonical host name.
	In response to a numerical address, getaddrinfo()
	does not populate `ai_canonname' by necessity.

	* ftp/ftp.c (hookup): Copy `RES->ai_canonname' only
	if set.  Copy from RHOST otherwise.
	* ping/libping.c (ping_set_dest): Likewise; with P.
	* ping/ping6.c (ping_set_dest): Likewise, with RHOST.
	* src/traceroute.c (main): Likewise.

2014-07-16  Mats Erik Andersson  <gnu@gisladisker.se>

	Handle access timing in fractions of a second.

	* configure.ac (HAVE_STRUCT_STAT_ST_ATIM_TV_NSEC)
	(HAVE_STRUCT_STAT_ST_ATIM_TV_USEC, HAVE_STRUCT_STAT_ST_CTIM_TV_NSEC)
	(HAVE_STRUCT_STAT_ST_CTIM_TV_USEC, HAVE_STRUCT_STAT_ST_MTIM_TV_NSEC)
	(HAVE_STRUCT_STAT_ST_MTIM_TV_NSEC): Check for existing time field
	for sub-second timing in `struct stat'.
	(HAVE_STRUCT_STAT_ST_BLKSTAT): Make the macro functional!

	* libls/cmp.c (modcmp) [HAVE_STRUCT_STAT_ST_MTIM_TV_NSEC]
	[HAVE_STRUCT_STAT_ST_MTIM_TV_USEC]: Compare in sub-seconds.
	(acccmp) [HAVE_STRUCT_STAT_ST_ATIM_TV_NSEC]
	[HAVE_STRUCT_STAT_ST_ATIM_TV_USEC]: Likewise.
	(statmod) [HAVE_STRUCT_STAT_ST_CTIM_TV_NSEC]
	[HAVE_STRUCT_STAT_CT_MTIM_TV_USEC]: Likewise
	(revmodcmp, revaccmp, revstatmod, revsizecmp): Replace code
	by a simple sign change of modcmp(), acccmp(), etcetera.

	* src/rcp.c [HAVE_STAT_ST_MTIMESPEC || HAVE_STAT_ST_MTIME_USEC]
	(write_stat_time): Remove unused and obsolete code.
	[HAVE_STRUCT_STAT_ST_ATIM_NSEC || HAVE_STRUCT_STAT_ST_ATIM_USEC]
	[HAVE_STRUCT_STAT_ST_MTIM_NSEC || HAVE_STRUCT_STAT_ST_MTIM_USEC]
	(write_stat_time): Code portably for sub-second accuracy.

2014-07-14  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Hash command semantic.
	Toggle hash state when argument is not set, only then.

	* ftp/cmds.c (sethash): Activate marker when a numeric
	argument is found; toggle when no argument is present.
	A non-numeric argument leads to status reporting only.

2014-06-05  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Alternate selection of .netrc file.

	* ftp/ftp_var.h (netrc): New variable.
	* ftp/main.c (argp_options) <-N/--netrc>: New option.
	(parse_opt) <'N'>: New case.
	(main): Initialize `netrc'.
	* ftp/ruserpass.c (remote_userpass): If `netrc' is NULL,
	check NETRC in environment.  Whenever `netrc' has content,
	us it instead of `~/.netrc'.  Once CFILE is valid, make
	sure that the file location is a regular file, otherwise
	returning to the interpreter.

	* tests/ftp-localhost.sh: Two new test cases, checking the
	functionality of NETRC in environment, and the option `-N'.

2014-05-16  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Size multipliers for hash increments.

	* ftp/cmds.c (sethash): New variable P.  Detect and
	apply multipliers when setting the increment size for
	hash markers, i.e., allow commands like "hash 32m".

2014-04-29  Mats Erik Andersson  <gnu@gisladisker.se>

	hostname: Degenerate cases.
	Better replies when name resolution fails.

	* configure.ac: Remove check for gethostname in libresolv.
	If hstrerror is missing, check for it in libresolv.
	(LIBRESOLV): New variable published using AC_SUBST.

	* src/Makefile.am (hostname_LDADD): New variable.

	* src/hostname.c (get_name): Call puts() only if NAME
	carries some content.  Will, most importantly, reply
	with an empty string, not an empty line, when no aliases
	are found.
	(get_aliases): Return an empty string when the host's
	name cannot be resolved.
	(get_fqdn): Fall back to the system reported hostname
	when name resolution fails.
	[HAVE_HSTRERROR] (get_ip_addresses): Exit with an error
	when name resolution fails.

	* tests/hostname.sh: Check availability of mktemp.
	(posttest): New function, used as trap.
	<root execution>: New test case with switch '-F'.

2014-04-26  Mats Erik Andersson  <gnu@gisladisker.se>

	libinetutils: Skeletal preparations for Heimdal.

	* configure.ac <krb5>: Disable rlogind and rshd.
	(KERBEROS_VERSION): Publish it using AC_SUBST.

	* libinetutils/kerberos5.c: New file, mostly copied
	in from `shishi.c' as a guide.

	* libinetutils/Makefile.am (libinetutils_a_SOURCES):
	Remove `des_rw.c', and add `kerberos5.c'.

	* libinetutils/kcmd.c: Remove support for KRB4, replacing
	all macros KERBEROS by KRB5.
	[KRB5]: Include <krb5.h> and "kerberos5_def.h".
	[KRB5] (kcmd): Update declarations, and make small,
	obvious adaptions to Kerberos5.
	(kcmd): Refactor steps common to SHISHI and KRB5, such as
	protocol exchange and address resolution.  They differ at
	the end, calling shishi_auth() or kerberos_auth().

2014-04-25  Mats Erik Andersson  <gnu@gisladisker.se>

	Begin support for Heimdal's Kerberos.
	Very incomplete code for `rsh', but a needed start.

	* libinetutils/kerberos5_def.h: New file.

	* libinetutils/krcmd.c: Remove support for KRB4, replacing
	most macros KERBEROS by KRB5.
	[KRB5]: Include <krb5.h> and "kerberos5_def.h".
	[KRB5] (kcmd, krcmd, krcmd_mutual): Update declarations,
	and make small, obvious adaptions to Kerberos5.
	[KRB5] (krcmd_mutual): Update value of AUTHOPTS.

	* libinetutils/Makefile.am (noinst_HEADERS):
	Add `kerberos5_def.h'.

	* src/rsh.c: Replace macro KERBEROS by KRB5, temporarily
	making an exception in some code related to encryption.
	[KRB5]: Include <krb5.h> and "kerberos5_def.h".
	[KRB5] (ctx, keyblock, server): New variables.
	[KRB5 && ENCRYPTION] (parse_opt) <case 'x'>: Remove
	call to des_set_key().
	[KRB5 || SHISHI] (main): Refactor code for port lookup
	and command string generation, since Kerberos5 and Shishi
	have common traits.
	[KRB5] (main): Adapt to new signatures of krcmd() and
	krcmd_mutual().  Initialize `ctx', and reimplement realm
	lookup using Kerberos5 API.

2014-04-25  Mats Erik Andersson  <gnu@gisladisker.se>

	Silence warnings with libshishi.

	* libinetutils/kcmd.c [KERBEROS || SHISHI] (kcmd):
	Declare realm argument as `const char *'.
	* libinetutils/krcmd.c [KERBEROS || SHISHI]
	(kcmd, krcmd, krcmd_mutual): Likewise.
	* libinetutils/shishi.c [SHISHI] (shishi_auth): Likewise.
	* libinetutils/shishi_def.h [SHISHI] (shishi_auth, krcmd)
	(krcmd_mutual): Likewise.
	* src/rcp.c [KERBEROS || SHISHI] (dest_realm): Likewise.
	* src/rlogin.c [KERBEROS || SHISHI] (dest_realm): Likewise.
	* src/rsh.c [KERBEROS || SHISHI] (dest_realm): Likewise.

	* src/rlogind.c (rlogind_auth): Initialize HOSTNAME.

2014-03-28  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Local time option.

	* src/syslogd.c (set_local_time): New variable.
	(option enum): Remove OPT_PIDFILE.
	(argp_options) <pidfile>: New alias 'P'.
	<-T/--local-time>: New option.
	(parse_opt) <case 'P'>: Replaces OPT_PIDFILE.
	<case 'T'>: New case.
	(logmsg): If `set_local_time' is set, use NOW to generate
	a time stamp, not the initial portion of the message.

2014-03-23  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Parse address family.
	Allow for address family argument on supported systems.

	* ifconfig/system/bsd.c (system_parse_opt_rest): New enum
	values EXPECT_COMMAND and EXPECT_AF.  Use the first to detect
	`create' and `destroy', but claiming lack of support.  Accept
	`inet' as family, but reject `inet6'.  Rewrite return status.
	* ifconfig/system/linux.c (system_parse_opt_rest): Rename
	enum value EXPECT_INET to EXPECT_AF.  Detect family `inet6',
	but reject it.
	* ifconfig/system/solaris.c (system_parse_opt_rest): New enum
	value EXPECT_AF.  Accept `inet' as address family argument,
	but reject `inet6'.  Rewrite return status.

2014-03-20  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Command line parsing.
	Implement flag parsing for BSD and Solaris.
	Accept only changeable flags on GNU/Linux.

	* ifconfig/system/linux.c (system_parse_opt_rest):
	Accept only masks which correspond to changeable flags,
	using IU_IFF_CANTCHANGE.
	* ifconfig/system/bsd.c, ifconfig/system/solaris.c
	(system_parse_opt_rest): New variables MASK and REV.
	Check if the command line argument can be interpreted
	as a changeable flag argument.

2014-03-15  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Changeable flags on GNU/Linux.

	* ifconfig/flags.h (IU_IFF_CANTCHANGE): Remove IFF_POINTOPOINT,
	IFF_ALLMULTI, IFF_BROADCAST, IFF_MULTICAST, and IFF_PROMISC,
	since they are changeable on GNU/Linux, and they are included
	natively in IFF_CANTCHANGE on other systems.

2014-03-13  Mats Erik Andersson  <gnu@gisladisker.se>

	logger: Source address resolution.

	* src/logger.c (open_socket) [HAVE_DECL_GETADDRINFO]
	<source is set>: Delete resolver hint for numeric address.

2014-03-10  Mats Erik Andersson  <gnu@gisladisker.se>

	hostname: Sanity checks in corner cases.

	* src/hostname.c (get_name): Use reply from get_fqdn()
	only if it gave a host name, not the artificial "(none)".
	(set_name): Reject an empty host name.
	(parse_file): Initialize NAME.  Improve error message
	when getline() claims empty input.  Break out of loop
	only if sscanf() produced a printable string.

2014-02-22  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Allow flags richer than 16 bits.
	Systems like GNU/kFreeBSD and FreeBSD use two `short int'
	to represent interface flags.  Adapt to this fact.

	* ifconfig/changeif.c (set_flags): Apply mask 0xffff to flags.
	[ifr_flagshigh]: Calculate flag changes also on ifr_flagshigh.
	* ifconfig/flags.c [IFF_PPROMISC] (if_flags): Add user land
	setable flag "PROMISC".
	[IFF_MONITOR] (if_flags): Add flag "MONITOR".
	[IFF_STATICARP] (if_flags): Add flag "STATICARP".
	[IFF_STATICARP] (flag_char_tab): Add short flag 's'.
	[IFF_MONITOR] (flag_char_tab): Add short flag 'm'.
	* ifconfig/options.c (formats) <unix>: Print flags numerically
	using format string "%x".
	* ifconfig/printif.c (put_flags): Change signature.  New type
	of F is `unsigned int'.  New variable UFLAGS.  Work with UFLAGS,
	not `flags'.
	(put_flags_short): New signature.
	[SIOCGIFFLAGS] (fh_ifdisplay_query, fh_brdaddr_query)
	(fh_dstaddr_query, fh_flags): New variable UFLAGS, replacing
	`form->ifr->ifr_flags'.
	* ifconfig/printif.h (put_flags): Change prototype.

2014-02-15  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: No listing of unchangeable flags.

	* ifconfig/flags.h [!IFF_CANTCHANGE]: Define it as naught.
	(IU_IFF_CANTCHANGE): New macro.
	* ifconfig/flags.c (if_list_flags): Do not list flags that
	are known to give constant properties.  New macro FLAGS_COMMENT.
	Add its contents to the end of the requested flags listing.
	Skip a named flag if it matches IU_IFF_CANTCHANGE.  Also skip
	flags named like 'link2/altphys', since their components
	do appear in the listing.


	Portability issues in test script.

	* tests/ifconfig_modes.sh (MTU): Set to 1324 initially,
	to get above 1280 needed for IPv6 compatibility.
	The switch '-o' of uname is not portable.

2014-02-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/ifconfig_modes.sh: Add test case to explain
	failures to automatically bring the interface up at
	an address change.  GNU/Linux is affected by this.

2014-02-14  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/flags.c (if_list_flags): Increment counter
	only in the for-statement; update the insertion of list
	delimiters.  Each second flag name was falsely scrubbed.

2014-02-14  Mats Erik Andersson  <gnu@gisladisker.se>

	Script for testing of ifconfig's modes.
	Will document all tested features.

	* tests/ifconfig_modes.sh: New file.  Intentionally
	without execution bit, and not for automatic testing.
	* tests/Makefile.am (EXTRA_DIST): Add `ifconfig_modes.sh`.

2014-02-12  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/options.c (formats): Add format `check'
	as a synonym for `check-existence'.

2014-02-09  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Detect one-time passwords.
	RFC 2228 reserves response code 336 for replies
	used with challange-response authentication.

	* ftp/cmds.c (user): React to response code 336 within
	FTP command `USER', print its message, and possibly
	discard an already supplied password.
	* ftp/ftp.c (login): Likewise.

2014-02-09  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Parse commands of RFC 2228.
	Tokens are implemented, but no actions.

	* ftpd/ftpcmd.y (ADAT, AUTH, CCC, CONF, ENC, MIC, PBSZ)
	(PROT): New tokens.
	(cmdtab): New entries `ADAT', `AUTH', `CCC', `CONF', `ENC',
	`MIC', `PBSZ', and `PROT'.  All are marked as unimplemented.

2013-12-23  Alfred M. Szmidt  <ams@gnu.org>

	* doc/inetutils.texi (rsh invocation): Use @item for first entry
	in @table.

2013-12-19  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2013-12-13  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Follow RFC 2577 by default.
	Prevent user name guessing as standard, but offer
	an option to keep the more informational responses.

	* ftpd/extern.h (logged_in): Remove unused variable.
	(rfc2577): New variable.
	(struct credentials): New component DELAYED_REJECT.
	* ftpd/ftpd.c (rfc2577): New variable.
	(OPT_NONRFC2577): New enum value.
	(options): New option `--non-rfc2577'.
	(parse_opt) <case OPT_NONRFC2577>: Reset `rfc2577'.
	(user): New variable RET.  After auth_user(), display
	messages in the old manner only if `rfc2577' is not set,
	or if guest access is being requested.  Otherwise, update
	`cred.delayed_reject' for later access.
	(end_login): Reset `pcred->delayed_reject'.
	(pass): On returning from auth_pass(), check also
	`cred.delayed_reject' to minimize the amount of user
	information returned to the client.


	ftpd: The standard protocol in RFC 959 demands
	that a client be informed before closing down.

	* ftpd/ftpd.c (pass) <repeated login failures>:
	Send a reply message 421 before closing connection.

2013-12-10  Mats Erik Andersson  <gnu@gisladisker.se>

	inetd: Logging of resolution and binding errors.

	* src/inetd.c (setup): Alternate syslog format,
	and debug message, when a service node has been set.
	(expand_enter): Likewise, adding debug message.


	ftp: Trivial misspelling.  Reported by Joe Steffee in
	<http://lists.gnu.org/archive/html/bug-inetutils/2013-11/msg00000.html>.

	* ftp/ftp.c (hookup): Spell `response' correctly.

2013-11-28  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind, telnet, telnetd: Modify exit status.

	* src/rlogind.c (rlogind_mainloop): Delay cleanup()
	call until libshishi has torn down its structures.
	(cleanup): New variable STATUS.  If `signo' is SIGCHLD,
	call waitpid() to reap the waiting child process and
	use its return status for the whole server's status.
	Waiting for the child resolves a race condition when
	tearing down the pseudo-terminal pair, since the slave
	now is gone when the master side is being closed down.

	* telnet/commands.c (tn): Use exit status 0 when setjmp()
	manages to execute telnet().  Otherwise, keep 1.
	(command) [unix || __unix || __unix__]: Enclose the
	complete else-block within preprocessor conditionals.

	* telnetd/pty.c (cleanup): Let STATUS have full scope
	in this function, and use it for exit().  Execute waitpid()
	only if `sig' is SIGCHLD, and update STATUS for later use.
	On SIGHUP, set STATUS to success, which happens only at
	reception of TELOPT_LOGOUT from client.
	* telnetd/state.c (dooption) <TELOPT_LOGOUT>: Call cleanup()
	with argument SIGHUP, since the client willingly leaves off.

2013-11-24  Mats Erik Andersson  <gnu@gisladisker.se>

	inetd: Ensure successful daemon mode.

	* src/inetd.c (main) <!debug>: Abort with a syslog message,
	should daemon() return unsuccessfully.
	* libinetutils/daemon.c (waitdaemon): Return with failure,
	should chdir("/") fail.


	Check all calls to chdir.

	* src/rshd.c (doit): Make a syslog error message and abort
	execution, should chdir("/") fail.
	* src/uucpd.c (doit): Abort with a message to stderr,
	should chdir("/") fail.

2013-11-23  Mats Erik Andersson  <gnu@gisladisker.se>

	Check all returns from fgets.
	Handle every failed fgets() with care.

	* ftp/cmds.c (user): Set account string to empty when
	fgets() fails.
	* src/rexec.c (main): Likewise for password string.
	* src/tftp.c (get_args): Call makeargv() only on successful
	call to fgets().  Otherwise, instantiate a trivial command
	list containing command name only.
	* telnet/commands.c (setescape): Leave escape character
	unchanged when fgets() fails.
	(tn) <get host>: Call makeargv() only for successful fgets().
	Otherwise, print a message and rely on later usage printout.
	(command): Print a line feed at EOF on stream error.

2013-11-15  Mats Erik Andersson  <gnu@gisladisker.se>

	tftp: Buffer size checking.
	Hardened builds need a helping hand in interpreting
	a bogus array length.

	* src/tftp.c (makerequest): New variables ARGLEN, LEN.
	Use them in calculating available space for file name.
	[HAVE_STRUCT_TFTPHDR_TH_U]: Calculate CP using an offset
	argument.  Needed to prevent false negatives from stack
	allocation protectors.

2013-11-05  Mats Erik Andersson  <gnu@gisladisker.se>

	Improve detection of readline.

	* am/readline.m4 (gl_FUNC_READLINE): Check for libedit
	with AC_LIB_LINKFLAGS_BODY and with AC_CACHE_CHECK.
	<readline in libreadline>: Ignore <editline/readline.h>.
	<readline in libedit>: Prefer <editline/readline.h>.
	Define HAVE_READLINE if readline() was located in one of
	the libraries, and if its use had not been disabled.
	Define HAVE_LIBREADLINE and HAVE_LIBEDIT if it was found
	in the corresponding library.
	* ftp/Makefile.am (LDADD): Remove $(LIBGLOB), $(LIBTERMCAP).
	The latter is handled by LIBREADLINE.

	* configure.ac (ftp_PROPS): Do not add $LIBTERMCAP.

2013-10-16  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd, talkd: Act on failed read_utmp.

	* src/syslogd.c (wallmsg)
	[UTMP_NAME_FUNCTION || !HAVE_GETUTXENT]: Check call
	to read_utmp() for failure, filing an error massage.
	* talkd/process.c (find_user) [!HAVE_GETUTXUSER]:
	Likewise, then returning FAILED.

	rsh: Symbolic descriptor name.

	* src/rsh.d (talk): Use STDOUT_FILENO and STDERR_FILENO
	as arguments to write().

2013-10-16  Mats Erik Andersson  <gnu@gisladisker.se>

	rsh: Kill child process after SIGPIPE.
	The default action for SIGPIPE will leave the
	child process running.  This caused, until now
	and including legacy implementations, blocking
	of stdin, and to conditionally leave also the
	remote server running.

	* src/rsh.c (end_of_pipe): New variable.
	(sigpipe): New function.
	(talk) [HAVE_SIGACTION]: New variable SA.
	<parent process>: Assign a signal handler to SIGPIPE.
	Add `&& !end_of_pipe' to the loop condition, so that
	talk() returns after SIGPIPE.  The child process will
	then be killed at the end of main().

2013-10-06  Mats Erik Andersson  <gnu@gisladisker.se>

	rsh: Detach input stream.
	The option `-n/--no-input' was incomplete.

	* src/rsh.c (main) <try_connect && null_input_option>:
	Call shutdown(SHUT_WR) on socket REM.
	(talk): Use symbolic macro SHUT_WR in shutdown().

	* doc/inetutils.texi (rsh invocation) <option '-n'>:
	Give an accurate description, forgetting about stderr.


	rshd: Better adaption to BSD.

	* src/rshd.c (doit): Use SHUT_RDWR in shutdown().
	(doit) [SHISHI] <verify checksum>: Rename local PORT
	to PPORT, since is shadows a variable of wider scope.
	(doit): Delay the call of setpgid() to also execute
	in the child process when PAM is supported.
	(doit) [HAVE_SETLOGIN]: Call setsid() and setlogin().
	Replace conditional `BSD > 43' with HAVE_SETLOGIN for
	better precision.
	[!HAVE_SETLOGIN]: Keep old call to setpgid().

2013-10-06  Mats Erik Andersson  <gnu@gisladisker.se>

	rexec: No echoing of passwords.

	* src/rexec.c: Include <termios.h>.
	(main) <password is '-'>: Call isatty().  If this
	is a terminal, print `Password:' and disable echo
	while reading password string.
	(do_rexec) <FD_ISSET(STDIN_FD)>: Write input from
	client to the outgoing socket SOCK.  This restores
	the ability to transfer contents to the server.


	rexecd: Better adaption to BSD.

	* configure.ac: Check for function setlogin.
	* src/rexecd.c (doit) [HAVE_SETLOGIN]: Before
	setting underpriviledged user, call setlogin().
	(doit) <with error port && child process>:
	Close PV[1], which is duplicate of stderr.
	[HAVE_SETLOGIN]: Call setsid(), not setpgid().

2013-10-03  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac (HAVE_SYSLOG_INTERNAL): Remove
	a misplaced character.

	* am/libcurses.m4 (IU_LIB_TERMCAP): Rework the
	message in AC_MSG_CHECKING() and always call
	AC_MSG_RESULT().

2013-10-02  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Capture syntax errors.
	Scanner and parser are insufficiently trimmed to
	each other, producing duplicate and inconclusive
	diagnostic messages.

	* ftpd/ftpcmd.y (yylex) <STR1 || ZSTR1 || dostr1>:
	Remove a break at the end, continue into ZSTR2.
	This allows detection of syntax errors.  A test
	case is `quote site chmod 0750' by a client.
	(yylex): Call yyerror() only if `yynerrs' is zero.
	Otherwise both scanner and parser would send error
	messages to the client.  Specify an explicit message
	in this call to yyerror().
	(yyerror): Use parameter `s' in reply message, but
	keep a default message in case `s' is empty.  This
	passes on any diagnostic message from the parser.

2013-09-26  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Implement FEAT and OPTS.
	Add two commands in accordance with RFC 2389.

	* ftpd/ftpcmd.y (cmdtab, sitetab): Change to static.
	(extlist): New variable, listing command extensions.
	(FEAT, OPTS): New tokens.
	(cmd) <FEAT || FEAT STRING || OPTS || OPTS STRING>:
	New cases.
	(cmdtab): Put commands in the order of RFC 959.
	Add FEAT and OPTS.
	(sitetab): Use lexicographic order.

2013-09-26  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Abort transfer in ascii mode.
	If the local ascii file causes a seek failure,
	then tell the server to abort transmission.

	* ftp/ftp.c (sendrequest) <restart_point && (STOR || APPE)>:
	Change RC to off_t.  On seek failure, send ABOR command,
	and get the reply.
	(recvrequest) <TYPE_A && restart_point>: Reset `errno'.
	<label done>: Send ABOR command, get reply.  Produce correct
	error message if stepping through the local file gave EOF.


	ftpd: Error message after seek failure.
	The standard RFC 1123 introduced a better error code 554
	to be used when a restart command is not successful.

	* ftpd/ftpd.c (retrieve) <restart_point && TYPE_A>: Reply
	with error code 554 if EOF was reach while seeking in file.
	<restart_point && !TYPE_I>: Likewise when lseek() gave EINVAL.
	(store) <restart_point>: Likewise for both modes.

2013-09-23  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Setting of idle time.
	The command to change idle time was broken.

	* ftpd/ftpcmd.y (cmd) <SITE IDLE NUMBER>: The token IDLE
	must go before `check_login' to avoid a lookahead syntax
	error.  Adjust the parameter reference for `check_login'.

2013-09-19  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Status and medium reports on BSD.

	* ifconfig/options.c (formats) <gnu, net-tools, unix>:
	Add medium and status to printout.
	* ifconfig/printif.c (format_handles): Add keys
	`media?', `media', `status?', and `status'.
	(fh_media_query, fh_media, fh_status_query, fh_status):
	New functions.
	* ifconfig/printif.h (fh_media_query, fh_media)
	(fh_status_query, fh_status): New declarations.

	* ifconfig/system/bsd.c: Include <net/if_media.h>.
	(ifm) [SIOCGIFMEDIA]: New variable.
	(media_descr): New variable.
	(subtype_descr) [IFM_SUBTYPE_DESCRIPTIONS]: Likewise.
	(ethernet_descr) [IFM_SUBTYPE_ETHERNET_DESCRIPTIONS]:
	Likewise.
	(subtype_shared_descr) [IFM_SUBTYPE_SHARED_DESCRIPTIONS]:
	Likewise.
	(option_descr): Likewise.
	(status_descr) [IFM_STATUS_DESCRIPTION]: Likewise.
	(system_fh_media_query, system_fh_media)
	(system_fh_status_query, system_fh_status): New functions.
	* ifconfig/system/bsd.h (SYSTEM_FORMAT_HANDLER):
	Add keys `media?', `media', `status?', and `status'.
	(system_fh_media_query)
	(system_fh_media, system_fh_status_quey, system_fh_status):
	New declarations.

2013-09-18  Alfred M. Szmidt  <ams@gnu.org>

	* cfg.mk (local-checks-to-skip): Added the
	sc_cast_of_x_alloc_return_value, sc_copyright_check,
	sc_program_name, sc_prohibit_always_true_header_tests,
	sc_prohibit_assert_without_use, sc_prohibit_doubled_word,
	sc_prohibit_error_without_use, sc_prohibit_have_config_h,
	sc_prohibit_magic_number_exit, sc_prohibit_strncpy,
	sc_prohibit_undesirable_word_seq, sc_prohibit_xalloc_without_use
	to list.

2013-09-15  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet: Uninitialized array of pointers.
	Contemporary tgetent() emulations are known to ignore
	the scratch buffer, as well as fill it in (contrary to
	claim in manual page).  Account for this.

	* telnet/telnet.c (mklist): Return quickly in case of
	an empty first parameter `buf'.  Carefully initialize
	`*ARGVP' to NULL at every stage.


	Harmless memory leak in test program.

	* tests/localhost.c: Include <stdlib.h>.
	(main): Remove `const' on P, and it free after use.

2013-09-12  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac: Add a relevant comment where AC_DEFINE
	and AH_TEMPLATE offered only the text `FIXME'.

	* am/result.m4 (IU_RESULT_ACTIONS): Build a relevant
	comment better than `FIXME'.

2013-09-10  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Rare memory leak.

	* ftp/ruserpass.c (remote_userpass) <missing domain>:
	Assign empty string to MYDOMAIN, do not allocate.
	The standard use is to set MYDOMAIN pointing into
	MYNAME without allocation.  Do assignment of TMP
	before if-clause.

2013-09-08  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Guard buffer size.
	An evil SHELL in environment would overflow a buffer.

	* ftp/cmds.c (shell): Step over a slash in NAMEP
	only if one was found.  Use strncat() with correct
	length parameter, instead of strcat().


	Minor coding issues.

	* ftp/ftp.c (pswitch) <struct comvars>: Declare array
	sizes for `nti[]' and `nto[]' to be identical to those
	of `ntin[]' and `ntout[]'.

	* ftp/ftp_var.h (stringbase, argbuf, argbase):
	Remove declarations.
	* ftp/main.c (argbase, argbuf, atringbase):
	New static string variables.

	* telnet/Makefile.am: Add @PATHDEFS_MAKE@.
	(AM_CPPFLAGS): Add $(PATHDEF_BSHELL).
	* telnet/commands.c (shell): Use PATH_BSHELL as default
	shell.  Put assignment before if-clause.

2013-09-08  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Legacy use with GNU/kFreeBSD.

	* configure.ac: Check for header <netinet/ether.h>.

	* ifconfig/system.c [__DragonFly || __FreeBSD__ ||
	__FreeBSD_kernel__ || __NetBSD__ || __OpenBSD__]:
	Add __FreeBSD_kernel__ to conditional.
	* ifconfig/system.h [__DragonFly || __FreeBSD__ ||
	__FreeBSD_kernel__ || __NetBSD__ || __OpenBSD__]:
	Likewise.
	* ifconfig/system/bsd.c [HAVE_NETINET_ETHER_H]:
	Include <netinet/ether.h>.
	* ifconfig/system/bsd.h (IU_BSD_TYPE)
	[__FreeBSD_kernel__]: Assign value to macro.

	* tests/ifconfig.sh: Add an informational check
	whether the legacy form `ifconfig lo0' works.

2013-09-07  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Remove line length limit.
	Once the argument parsing routine is rewritten
	to work with dynamic memory, the length limit
	on input lines can be removed in its entirety.

	* ftp/extern.h (slurpstring): Remove declaration.
	* ftp/ftp_var.h (argbuf): Change to string pointer.
	(MAXMARGV) [!MAXMARGV]: New macro.
	(margv): Change array length to MAXMARGV.

	* ftp/main.c (slurpstring): Declare as static.
	(main): Initalize `argbuf' to NULL.
	(cmdscanner): Remove check whether `line' exceeds
	MAXLINE in length.
	(slrflag): Declare as static.
	(makeargv): Free and allocate `argbuf' at entry.
	Insert a condition to ensure that at most MAXMARGV
	arguments are located, thus avoiding an overflow.

	* ftp/ruserpass.c (tokval): Change array length
	to BUFSIZ.

2013-09-06  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Macro execution and allocation.
	During macro execution, string parsing and
	substitution is rewritten to use dynamically
	allocated memory.

	* ftp/domacro.c (lengthen): New static function.
	(domacro): New variables ALLOCFLG, LINE2LEN.
	New label END_EXEC.  The variable LINE2 is no
	longer allocated, instead it stores the previous
	global `line' for repeated access.  A temporary
	string pointer `line' is dynamically allocated
	and is adjusted using lengthen().  Recovery from
	allocation failures jump to END_EXEC.  `line' is
	restored from LINE2 before exiting.

2013-09-05  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Minor allocation issues.
	Fix issues related to the global variable `line'.

	* ftp/cmds.c (another): New variable NEW.  Assign
	outcome of realloc() to NEW, to better avoid memory
	leakage.  Determine new size with `linelen'.
	(confirm): Rename LINE to INPUT, which does not
	shadow the global variable `line'.

	* ftp/domacro.c: Include <stdlib.h>.
	(domacro): Change LINE2 to a string pointer.
	Assign LINE2 using strdup(), freeing it later.

	* ftp/ftp.c (login) <execution of macro `init'>:
	Allocate MAXLINE bytes; set `linelen'.

	* ftp/ftp_var.h (linelen): New variable.

	* ftp/main.c (main): Reset `line', `linelen'.
	(cmdscanner): Remove LEN, using `linelen' instead.

2013-09-05  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Macro execution segfaults.
	Abort macro execution when command is ambiguous,
	is invalid, or if the control connection has been
	lost.  Otherwise segmentation faults can happen
	when the macro includes further commands.

	* ftp/domacro.c (domacro) <ambiguous, invalid>
	<not connected>: Reset LOOPFLG and break loop.
	Error message gives name of offending command.

2013-09-03  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Avoid numeric size of char array.

	* ftp/cmds.c (macdef): Use sizeof() to avoid size
	knowledge about arrays `struct macel.mac_name'
	or `macbuf'.
	* ftp/domacro.c (domacro): Likewise.
	* ftp/ruserpass.c (remote_userpass): Likewise.
	Change type of I to size_t.

	* doc/inetutils.texi <ftp invocation>: Mention
	restriction on macro naming.

2013-08-31  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/syslogd.sh: Lengthen sleeping periods.
	Add better diagnostics when some test case fails.

2013-08-31  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftpd/ftpd.c (statcmd): Report session timeout.

2013-08-31  Mats Erik Andersson  <gnu@gisladisker.se>

	Support BSD libedit.  (Used on GNU/kFreeBSD.)

	* am/readline.m4 (gl_FUNC_READLINE): Check for headers
	before library linkage.  Check for header file variants
	<editline/readline.h> and <editline/history.h>.
	While testing linking against libreadline and libedit,
	conditionally use HAVE_*_READLINE_H to include the
	correct header file.

	* ftp/cmds.c, ftp/main.c
	[!HAVE_READLINE_READLINE_H && HAVE_EDITLINE_READLINE_H]:
	Include <editline/readline.h>
	[!HAVE_READLINE_HISTORY_H && HAVE_EDITLINE_HISTORY_H]:
	Include <editline/history.h>

2013-08-30  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2013-08-29  Mats Erik Andersson  <gnu@gisladisker.se>

	Handle socket debugging.

	* ftp/ftp.c (initconn) <passivemode>: Suppress error
	message for errno EACCES while setting SO_DEBUG.  This is
	a minor part of debug mode, and denial is system dependent.
	Else report using error(), not perror().  Add DEBUG to text.
	<label noport>: Likewise.

	* src/inetd.c (setup): Likewise.

	* src/rsh.c (main) <try_connect && debug_option>:
	Improve error message to mention DEBUG.

2013-08-28  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: New command `lpwd'.

	* ftp/cmds.c: Include "xgetcwd.h".
	(lcd): Remove external prototype of xgetcwd().
	(lpwd): New function.
	* ftp/cmdtab.c (lpwdhelp): New variable.
	(cmdtab): Add entry for `lpwd'.
	* ftp/extern.h (lpwd): New prototype.

	* ftp/main.c (argp_options) <-d/--debug>:
	Improve relevance of help message.

2013-08-28  Mats Erik Andersson  <gnu@gisladisker.se>

	Identification of unices.  Check `__unix' and
	`__unix__' in addition to `unix'.  This is needed
	for `ftp' with GCC on NetBSD, OpenBSD.  Both macros
	are necessary to distinguish AIX and HP-UX!

	* ftp/cmds.c (setpeer)
	[(unix || __unix || __unix__) && (NBBY==8)]: Add
	macros __unix and __unix__ in conditional; this
	sends initial SYST request from NetBSD and OpenBSD.

	* ftpd/ftpcmd.y (cmd) [unix || __unix || __unix__]:
	Likewise; announce system as UNIX.

	* telnet/commands.c (Togglelist, filestuff)
	[(unix || __unix || __unix__) && TN3270]: Likewise.
	(status, transcomhelp)
	[(unix || __unix || __unix__) && TN3270]: Likewise.
	(zhelp) [unix || __unix || __unix__]: Likewise.
	(cmdtab) [unix || __unix || __unix__]
	<cases "transcom", "z">: Likewise.
	(command) [unix || __unix || __unix__] <!top>:
	Likewise; ignore SIGINT and SIGQUIT.
	* telnet/main.c (argp_options)
	[(unix || __unix || __unix__) && TN3270]: Likewise.
	(parse_opt) [(unix || __unix || __unix__) && TN3270]
	<case 't'>: Likewise.
	* telnet/telnet.c [unix || __unix || __unix__]:
	Likewise; include <signal.h>.
	(Scheduler) [(unix || __unix || __unix__) && TN3270]:
	Likewise.
	* telnet/tn3270.c (HaveInput, cursesdata, sigiocount)
	(tline, transcom) [(unix || __unix || __unix__) && TN3270]:
	Likewise.
	(init_3270, inputAvailable, DataToTerminal, Finish3270)
	(settranscom) [(unix || __unix || __unix__) && TN3270]:
	Likewise.
	* telnet/utilities.c (EmptyTerminal)
	[unix || __unix || __unix__]: Likewise; handle fdset.

	Check macro `__sun' to detect Solaris.  Possibly
	the code is portable also to Solaris Studio.

	* ifconfig/system.c [!__linux__]: Check macro  __sun,
	not the less portable __sun__.
	* ifconfig/system.h [!__linux__]: Likewise.
	* ping/ping6.c: Likewise.


	Helper program for identifying build environments.

	* tests/identify.c: New file.
	* tests/Makefile.am (noinst_PROGRAMS, identify_LDADD):
	New variables.

2013-08-28  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Secrecy in debug mode.

	* ftp/ftp.c (command) <debug>: Insert a missing `else'.
	This avoids displaying the password in clear text.
	Problem introduced in a change made 2013-05-17.

2013-08-25  Mats Erik Andersson  <gnu@gisladisker.se>

	False negative while testing syslogd.

	* tests/syslogd.sh (iu_socklen_max): Do not accept
	`GNU/kFreeBSD' as a system supporting unix sockets
	of length 108.

2013-08-18  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/Makefile.am (check_PROGRAMS) [ENABLE_inetd]:
	Add tcpget.
	* tests/inetd.sh (TARGET, TCPGET): New variables.
	(TELNET): Remove variable.
	Remove check for tty.  Use TARGET for host addressing.
	Use `tcpget' instead of `telnet', which allows the
	test to be performed by build robots.
	* tests/tcpget.c: New file.

2013-08-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/inetd.sh: Skip test in absence of assigned TTY.
	This is needed due to the use of a built `telnet'.

2013-08-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/inetd.sh (write_conf): Use numerical address
	for localhost.  This avoids dependency on system set-up.

2013-08-14  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/inetd.sh: New file.
	* tests/Makefile.am (dist_check_SCRIPTS)
	[ENABLE_inetd && ENABLE_telnet]: Add inetd.sh.

	* tests/telnet-localhost.sh: Set service node
	to $TARGET and $TARGET6 in inetd configuration.

	* tests/utmp.sh: Call $SED, not `sed'.

2013-08-09  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/syslogd.c (argp_options): Improve `mark' text.
	(logmsg) [INTERNAL_MARK]: Compute facility from
	macro INTERNAL_MARK for better consistency.

2013-07-20  Mats Erik Andersson  <gnu@gisladisker.se>

	talkd: Small audit of ACL.

	* talkd/acl.c (struct netdef): Let `ipaddr' and
	`netmask' be of type in_addr_t for better
	architecture independence.
	(netdef_parse): Likewise for IPADDR, NETMASK.
	(acl_match): Likewise for IP.  When checking
	address matches, make a bitwise AND of
	`net->ipaddr' with `net->netmask'.

	* talkd/talkd.c (main): Call openlog() before read_acl().
	(talkd_init): Delete call to openlog().

2013-07-13  Mats Erik Andersson  <gnu@gisladisker.se>

	talkd: Less ACL-logging.

	* talkd/process.c (process_request): File only
	a single syslog message when acl_match() denies
	access, by checking for message type LOOK_UP.

2013-07-13  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2013-07-11  Mats Erik Andersson  <gnu@gisladisker.se>

	talk, talkd: Convenience changes.

	* talk/display.c (display) <'^D'>: Clear both
	local windows, but render the character as
	notification on the remote terminal.

	* talkd/process.c (process_request) <ANNOUNCE>:
	If logging is set and reply is successful, make
	a syslog note about the participants.
	<LOOK_UP>: Likewise.

2013-07-04  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Gateway selection.
	Make `-g' additive in repeated use to better
	conform with other implementations.

	* src/traceroute.c (parse_opt) [IP_OPTIONS] <'g'>:
	Append `arg' to `opt_gateways' if the latter has
	already been assigned a value.

2013-06-28  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Portability of PID range.
	FreeBSD uses process ID beyond 65535.

	* src/traceroute.c (main): Only keep lower
	16 bits of getpid().  A larger identity span
	cannot be accommodated into the payload.

2013-06-27  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Require host name.

	* src/rshd.c (reverse_required): New variable.
	(options): New option `-r/--reverse-required'.
	(parse_opt) <'r'>: New case.
	(doit) <reverse_required>: New exit path for
	clients whose IP addresses have no host name.

2013-06-26  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Error handling.

	* src/rlogind.c (rlogind_auth) <reverse_required>:
	Call fatal() on failure to reverse resolve the address.
	Lower syslog severity to LOG_NOTICE.
	(rlogind_mainloop): Lower severity to LOG_ERR.

2013-06-24  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Reverse resolution of client.

	* telnetd/telnetd.c (telnetd_setup) [IPV6]
	<reverse_lookup>: The comparison of a full
	`struct sockaddr' always fails.  Thus compare
	only `struct in_addr', or `struct in6_addr'.
	Short-circuit test for differing families.
	In case of failure, call fatal(), not exit().
	[!IPV6] <reverse_lookup>: Call fatal(), not exit().

2013-06-24  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Portability of banner.

	* telnetd/telnetd.c (print_hostinfo): Use NVT
	conformant substring for second newline "\r\n".
	* telnetd/telnet.h (UNAME_IM_SUFFIX) [HAVE_UNAME]:
	Likewise.  Use place holder `%l' for name of server.

2013-06-23  Mats Erik Andersson  <gnu@gisladisker.se>

	Portable use of uname().  POSIX states non-negative
	status on success.  Solaris returns positive value.

	* ftpd/ftpcmd.y <cmd> [HAVE_UNAME]: Set string
	value if uname() returns a non-negative value.
	* telnetd/telnetd.c (print_hostinfo) [HAVE_UNAME]:
	Likewise.


	ftpd: Prevent disclosure of system version.

	* ftpd/extern.h (no_version): New declaration.
	* ftpd/ftpcmd <cmd>: Display system name and
	release identifier only if `!no_version' is true.
	* ftpd.c (no_version): Declare as global,
	not static.

2013-06-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* CHECKLIST: New documentation file.
	* Makefile.am (EXTRA_DIST): Add CHECKLIST.

2013-06-12  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Group name matching.
	Support group membership matching in the files
	`/etc/ftpusers' and `/etc/ftpchroot'.

	* bootstrap.conf (gnulib_modules): Add mgetgroups.
	* ftpd/conf.c: Include <stdlib.h>, <pwd.h>, <grp.h>,
	and <mgetgroups.h>.
	(checkuser): New variables NGROUPS, GROUPS, PWD.
	New code blocks for extracting and matching against
	group names given on input line.

	* doc/inetutils.texi <ftpd invocation>:
	New section on the file format of `/etc/ftpusers'.

2013-06-11  Mats Erik Andersson  <gnu@gisladisker.se>

	* paths (PATH_NOLOGIN): Change default value to
	`/etc/nologin' for best portability.
	* README: Add some observations on hard-coded
	file locations.

2013-06-11  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Erroneous access check.
	The result of a user name match in PATH_FTPUSERS
	is never applied.

	* ftpd/auth.c (auth_user): Immediately return with
	an error when a user is denied access based on an
	entry in PATH_FTPUSERS.


	ftpd: Better name matching mechanism.

	* ftpd/conf.c: Include <ctype.h>.
	(checkuser): Accept an input line without final
	newline.  Allow initial blanks on input line.
	For better portability, allow trailing text
	separated from user name by blanks.

	* doc/inetutils.texi <ftpd invocation>: Better
	exposure of ftpchroot effects.

2013-06-08  Mats Erik Andersson  <gnu@gisladisker.se>

	logger: Flexibel UNIX socket name.

	* src/logger.c (open_socket): Call strchr()
	to check if `host' contains a slash anywhere.
	Then it names a UNIX socket.

2013-05-29  Mats Erik Andersson  <gnu@gisladisker.se>

	tests: Directory loading in syslogd.

	* tests/syslogd.sh (CONFD): New variable.
	(IU_OPTIONS): Add directory setting `--rcdir'.
	<reloaded configuration>: Move directive for
	severity `debug' to a file in $CONFD.

	* src/syslogd.c (main) <NoDetach>: Mention the
	process ID when telling about debug signal USR1.

2013-05-29  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Load configuration from directory.
	Code suggested by Guillem Jover <guillem@hadrons.org>
	<http://lists.gnu.org/archive/html/bug-inetutils/2009-12/msg00054.html>.
	Minor changes with failure tracking.

	* paths (PATH_LOGCONFD): New variable.
	* src/Makefile.am (AM_CPPFLAGS): Add $(PATHDEF_LOGCONFD).
	* src/syslogd.c: Include <dirent.h>.
	(ConfDir): New variable.
	(argp_options): New option `-D/--rcdir'.
	(parse_opt) <'D'>: New case.
	(load_confdir): New function.
	(init): New variable RET.  Call load_confdir(),
	making sure that failures are reported.

2013-05-29  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Refactor loading of configuration file.
	Code outlined by Guillem Jover <guillem@hadrons.org>
	<http://lists.gnu.org/archive/html/bug-inetutils/2009-12/msg00053.html>.
	Added an important correction to the legacy code
	for building linked lists of logging files.

	* src/syslogd.c (load_conffile): New function.
	First build a new structure `struct filed' from
	input line, then incorporate it into `*nextp'.
	(init): Refactor code for loading a configuration
	file, moving it to load_conffile().
	New variable RC.  Remove CF, P, LINE_MAX, CBUF,
	CLINE, and CONT_LINE.
	Register an additional error message, should loading
	have been incomplete.

2013-05-27  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Check account locking and expiration.

	* src/rshd.c [HAVE_SHADOW_H]: Include <shadow.h>.
	(DAY) [!DAY]: New macro.
	(doit): Multiple, minor changes to error strings.
	[!WITH_PAM]: New checks of account being either
	locked, or expired.  The code tests HAVE_GETSPNAM
	and HAVE_STRUCT_PASSWD_PW_EXPIRE for system quirks.

2013-05-22  Mats Erik Andersson  <gnu@gisladisker.se>

	libinetutils: Clarify Kerberos dependency.

	* libinetutils/kcmd.c [KERBEROS || SHISHI]:
	Condition file content on KERBEROS, not KRB4.


	Mixed compiler warnings.

	* ftpd/ftpcmd.y (cmd) <EPRT>: Remove the suffix `LL'
	on constants, which enforces an unwanted cast.
	(host_port): Likewise.

	* libinetutils/kcmd.c (kcmd): Cast a string length
	computation as int, used for format precision.

	* libls/print.c (printlong): Cast nlink_t as int.

	* libtelnet/kerberos5.c (Data): Cast CD as `char *'
	for use by strlen().

	* src/rexecd.c (get_user_password) [!WITH_PAM]:
	Declare only in absence of WITH_PAM.
	(doit) [!WITH_PAM]: Declare NAMEP and PW_PASSWORD.
	(rexec_conv) [WITH_PAM]: Identify `data' as unused.
	* src/rlogin.c (writer) <!escapechar>: Disambiguate
	conditional statements inside a braced block.
	* src/rsh.c: Include <unused-parameter.h>.  Remove
	inclusion of "xalloc.h".
	(parse_opt): Identify `state' as unused.
	* src/rshd.c (doit) [SHISHI]: Declare ERR_MSG as a
	constant array.

	* telnet/commands.c (tn) [HAVE_IDN]: Declare HOSTTMP.

2013-05-22  Mats Erik Andersson  <gnu@gisladisker.se>

	* libtelnet/encrypt.c: Include <unused-parameter.h>.
	(encrypt_start, encrypt_request_start): Mark all
	parameters with _GL_UNUSED_PARAMETER.
	* libtelnet/kerberos5.c: Include <unused-parameter.h>.
	(kerberos5_init, kerberos5_status): Param `ap' is unused.
	* libtelnet/shishi.c: Include <unused-parameter.h>.
	(krb5shishi_init, krb5shishi_status): `ap' is unused.
	(krb5shishi_cleanup): Likewise.  Delete variable SUBKEY.

2013-05-18  Mats Erik Andersson  <gnu@gisladisker.se>

	libtelnet: Portability of enctype_names.

	* configure.ac (HAVE_CONST_CHAR_ENCTYPE_NAMES):
	Check if <arpa/telnet.h> declares enctype_names
	as `const char []'.
	* libtelnet/encrypt.c (enctype_names)
	[HAVE_CONST_CHAR_ENCTYPE_NAMES]: Declare as
	constant array.

2013-05-17  Mats Erik Andersson  <gnu@gisladisker.se>

	libtelnet: Selected compiler warnings.

	* libtelnet/auth.c (auth_send): Cast sizeof() as int.
	(auth_name): Remove AP.  Make SAVENAME a char array.
	Cast sizeof() as int.  Rewrite debug message for
	overflowing name.
	* libtelnet/enc_des.c (FB64_IV, FB64_IV_OK)
	(FB64_IV_BAD): Make definitions conditional.
	(fb64_session): Cast `key->length' as size_t.
	* libtelnet/encrypt.c (encrypt_is): Do assignment
	before if-statament.  Use format `%p' with pointer.
	(encrypt_reply): Likewise.
	(encrypt_start): Use separate assigment.
	(encrypt_keyid): Likewise.  Delete STRP and CP.
	(encrypt_start_output): Use separate assignment.
	(encrypt_send_request_end): Remove ENCRYPT and DECRYPT.

	* libtelnet/kerberos5.c (kerberos5_is_auth): Make static.
	(kerberos5_is_forward) [FORWARD]: Likewise.
	* libtelnet/shishi.c (Data): Third argument is `void *'.
	Cast as `char *' for strlen().
	(shishi_init_key) [ENCRYPTION]: Make static.  Cast result
	from shishi_key_value() as `unsigned char *'.
	(krb5shishi_reply): shishi_ap_rep_verify_der() needs a cast
	as `char *'.
	(krb5shishi_status): Delete RC.
	(krb5shishi_is_auth): Make static.  Delete KEY2.
	shishi_ap_req_der_set() needs cast as `char *'.

	* telnet/authenc.c (telnet_getenv): Do not cast `val'.

2013-05-17  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp, telnet: Erase passwords after use.

	* ftp/cmds.c (user): Erase password string after getpass().
	(account): Likewise, for account password.
	* ftp/ftp.c (login): Erase passwords after last use.
	(command): Print fake account password as debug text.

	* telnet/authenc.c (telnet_gets): Do assignment before
	if-statement.  Erase string found by getpass().

2013-05-17  Mats Erik Andersson  <gnu@gisladisker.se>

	libtelnet: Let input to printsub functions remain
	typed as `unsigned char *', but use `char *' for all
	printable output.

	* libtelnet/auth-proto.h (auth_printsub, auth_sendname)
	(kerberos4_printsub, kerberos5_printsub)
	krb5shishi_printsub): Update signatures.
	* libtelnet/auth.h (TN_Authenticator): Update `*printsub'.
	* libtelnet/enc-proto.h (encrypt_printsub, krbdes_printsub)
	(cfb64_printsub, ofb64_printsub): Update signatures.
	* libtelnet/encrypt.h (Encryptions): Update `*printsub'.

	* libtelnet/auth.c (auth_sendname): Rename first argument
	and change to `char *'.  New variable CP.
	(auth_gen_printsub): Change third argument and variables
	CP and TBUF to `char *'.
	(auth_printsub): Change third argument to `char *'.
	* libtelnet/enc_des.c (fb64_printsub, cfb64_printsub)
	(ofb64_printsub): Likewise.
	* libtelnet/encrypt.c (encrypt_gen_printsub)
	(encrypt_printsub): Likewise.
	* libtelnet/kerberos.c (kerberos4_printsub): Likewise.
	* libtelnet/kerberos5.c (kerberos5_printsub): Likewise.
	* libtelnet/shishi.c (krb5shisih_printsub): Likewise.

	* telnetd/utility.c (printsub) [AUTHENTICATION || ENCRYPTION]:
	Change BUF to `char *'.

2013-05-15  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Report client's principal name.

	* src/rshd.c (rprincipal): New variable.
	(doit) [SHISHI] <use_kerberos>: Set `rprincipal'
	using shishi_encticketpart_clientrealm().
	[KRB5] <use_kerberos>: New calls to krb5_kuserok()
	and krb5_unparse_name().
	(doit): Report success to syslog using `rprincipal'.

2013-05-15  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Report client's principal name.

	* libinetutils/shishi_def.h (struct auth_data):
	New member `rprincipal'.
	* src/rlogind.c (struct auth_data) [!SHISHI]:
	Likewise.
	(do_krb5_login) [KRB5]: Delete NAME.  Assign value
	to `ap->rprincipal' using previous krb5_unparse_name().
	(do_shishi_login) [SHISHI]:
	Call shishi_encticketpart_clientrealm() to set
	`ad->rprincipal'.  Let the syslog message mention
	the client's principal name, instead of remote name.

	rlogind: Login options for Solaris again!

	* src/rlogind.c (exec_login) [SOLARIS10 || SOLARIS]:
	Make option orders roughly similar.  Add option `-d'.
	<authenticated> [KERBEROS || SHISHI]: Add option `-u'
	with remote client's principal name.  Depending on
	`kerberos', let `-s' take argument `krlogin' or `rlogin'.

2013-05-15  Mats Erik Andersson  <gnu@gisladisker.se>

	Audit of login options.

	* configure.ac (SOLARIS10): Replace previous
	macro SOLARIS11.
	* src/rlogind.c (exec_login) [SOLARIS10]:
	Use previous Solaris settings.
	[SOLARIS]: Simplified setting.
	* telnetd/telnetd.c (login_invocation)
	[SOLARIS10 || SOLARIS]: Likewise, as two cases!

2013-05-14  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Silence unwanted debugging.

	* telnetd/telnetd.h (enum debug_mode): Add `debug_encr'.
	* telnetd/telnetd.c (debug_mode): Add member `encr'.
	* telnetd/utility.c (printsub): Return immediately if
	the option is TELOPT_AUTHENTICATION or TELOPT_ENCRYPT
	and the corresponding debug level is unset.

	telnetd: Logging of failed command line options.

	* telnetd/telnetd.c (main): Call openlog() before
	argp_parse().  Facility is now correct!
	(parse_linemode): Send a log notice
	about parsing failure; the client receives stderr!
	(parse_authmode) [AUTHENTICATION]: Likewise.
	(parse_debug_level): Likewise.

2013-05-14  Mats Erik Andersson  <gnu@gisladisker.se>

	libtelnet: The list of authentication names is
	allowed to contain NULL entries.  Prevent access
	to such entries.

	* libtelnet/auth.c: Position some assignments before
	the corresponding if-statement.
	(auth_init) [AUTHENTICATION]: Check that AUTHTYPE_NAME()
	is non-NULL before referencing it.
	(auth_disable_name, getauthmask, auth_onoff, auth_send)
	[AUTHENTICATION]: Likewise.

	* telnet/utilities.c (printsub) [AUTHENTICATION]: Likewise.
	* telnetd/utility.c (printsub) [AUTHENTICATION]: Likewise.

2013-05-13  Mats Erik Andersson  <gnu@gisladisker.se>

	libtelnet: Make availibility of DES_OFB64 in addition
	to DES_CFB64 independent of host system.

	* libtelnet/encryption.h (ENCTYPE_DES_OFB64)
	[ENCRYPTION]: Define if missing.
	(ENCTYPE_CNT, ENCTYPE_NAME_OK) [ENCRYPTION]:
	Always redefine.

	* libtelnet/encryption.c [ENCRYPTION]: Undefine
	ENCRYPT_NAMES before including <arpa/telnet.h>.
	(enctype_names) [ENCRYPTION]: New array variable.
	(encrypt_is, encrypt_reply, encrypt_start) [ENCRYPTION]:
	Before printing encryption type, check that ENCTYPE_NAME()
	is non-null in addition to checking only ENCTYPE_NAME_OK().

	* telnet/utilities.c (printsub) [ENCRYPTION]: Likewise.
	* telnetd/utility.c (printsub) [ENCRYPTION]: Likewise.

2013-05-13  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac <*olaris*>: New test for subcase
	`*olaris*11'.  Define SOLARIS11 for matches.

	* telnetd/telnetd.c (login_invocation)
	[SOLARIS && SOLARIS11]: Add `-p' to old value.

	* src/rlogind.c (exec_login) <authenticated>
	[SOLARIS]: Change service to `-s krlogin' in
	argument list to execle().

2013-05-09  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/logger.c (parse_level): Rename PRI to PRIO,
	so as not to shadow the global variable.  Initiate
	value to LOG_NOTICE, not to LOG_EMERG.

2013-05-08  Mats Erik Andersson  <gnu@gisladisker.se>

	libtelnet: Parity adjust non-DES key.

	* libtelnet/enc_des.c (des_parity, des_check_parity)
	(des_set_parity) [AUTHENTICATION && ENCRYPTION]
	[DES_ENCRYPTION || SHISHI]: New static functions.
	(fb64_session) [AUTHENTICATION && ENCRYPTION]:
	New variables OFFSET and DERIVED_KEY.  Accept keys
	of type SK_OTHER and adjust parity in a partitioned
	copy of the authentication key, as RFC 2952 suggests.

	Self-documenting array length.

	* libtelnet/enc_des.c (shishi_des_ecb_encrypt)
	[AUTHENTICATION && ENCRYPTION && SHISHI]:
	Use sizeof(Block) as array size.
	(fb64_start) [AUTHENTICATION && ENCRYPTION && SHISHI]:
	Likewise.

2013-05-07  Mats Erik Andersson  <gnu@gisladisker.se>

	configure.ac: Minor clean-up.

	* am/config_paths.m4 (IU_CONFIG_PATHS):
	Replace obsolete AC_HELP_STRING by AS_HELP_STRING.
	* am/libcurses.m4 (IU_LIB_NCURSES): Likewise.
	* am/readline.m4 (gl_FUNC_READLINE): Likewise.
	* configure.ac: Likewise.  Use AC_CONFIG_HEADERS
	instead of AC_CONFIG_HEADER.  Call AM_PROG_AR,
	but protect its use by means of m4_ifdef.
	(AM_INIT_AUTOMAKE): Add `-Wall' and `-Werror'.
	Remove second call to the same macro.

2013-05-01  Mats Erik Andersson  <gnu@gisladisker.se>

	* libtelnet/enc_des.c: Convert K&R style declarations
	to ISO C89.  Do assignments before return statements.
	(fb64_stream_iv, fb64_init, fb64_is, fb64_reply)
	(fb64_stream_key, fb64_keyid): Declare as static.
	(shishi_des_ecb_encrypt) [SHISHI]: Declare as static.
	Declare all three string arguments using `unsigned char'.
	When calling shishi_des(), cast third and sixth arguments
	as `const char *'.
	(fb64_start): Remove variable B.  Change X to size_t.
	(fb64_is): Remove B and X.
	(fb64_reply): Remove B, P, and X.

2013-04-30  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Account expiration.
	Better explanation, make it work also for BSD.

	* configure.ac (HAVE_STRUCT_PASSWD_PW_EXPIRE)
	(HAVE_STRUCT_PASSWD_PW_CHANGE): Check if `struct passwd'
	has members pw_expire and pw_change.

	* ftpd/extern.h (struct credentials): New member `expired'.
	(AUTH_EXPIRED_NOT, AUTH_EXPIRED_ACCT, AUTH_EXPIRED_PASS):
	New macros.
	* ftpd/ftpd.c (pass) <failed authentication>:
	If `cred.message' is empty, check `cred.expired' for
	further reasons of failure.
	* ftpd/auth.c (auth_user): Reset `pcred->expired'.
	(sgetcred): [HAVE_GETSPNAM && HAVE_SHADOW_H]:
	Separate account and password expiration into distinct
	checks, updating `pcred->expired'.  Use shadow password
	only in absence of all expiration.
	[HAVE_STRUCT_PASSWD_PW_EXPIRE]: New code block.

2013-04-26  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Make encryption portable.

	* src/rcp.c (main) [KERBEROS || SHISHI]: The encryption
	switch `-x' does not belong in the remote command string.
	It is must only be passed to `rsh'.  Remove the special
	command string claimed for all Kerberos variants.

2013-04-25  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Attempt to mend recurring test failures.
	The autobuilder Hydra is fairly often reporting
	failures for `tests/syslogd.sh' on GNU/Linux,
	appearing after configuration reload and then
	blocking INET socket messages.

	* src/syslogd.c (create_inet_socket): Set SO_REUSEADDR
	before IPV6_V6ONLY.
	* tests/syslogd.sh <reloaded configuration>: Remove
	blocker `user.none' on file `$OUT'.

2013-04-23  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac <libidn detection>: Replace by a call
	to IU_CHECK_LIBIDN.
	* am/libidn.m4 (IU_CHECK_LIBIDN): New file, new macro.

	* am/krb5.m4 (IU_CHECK_KRB5): Detect res_query using
	AC_SEARCH_LIBS for better portability to BSD.
	Set KRB5_IMPL to `krb5-config' if krb5-config is
	available to provide compiler flags.  If KRB5_PREFIX
	is `yes' and krb5-config does not exist, use the
	location `-I/usr/include/krb5' for KRB5_CFLAGS.
	Do not add $KRB4_LIBS to KRB5_LIBS when detecting
	either `MIT' or `Heimdal'.

2013-04-19  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind, rshd: Diagnostics with libshishi.

	* src/rlogind.c (do_shishi_login) [SHISHI && WITH_PAM]:
	Assign an error message when do_pam_check() fails.
	* src/rshd.c (doit) [SHISHI && !ENCRYPTION]:
	Abort with an error message when encryption was requested
	by the client, but is not present in the server.

2013-04-17  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind, rshd: Set realm with Kerberos5.

	* src/rlogind.c (do_krb5_login) [KRB5}: Declare SERVER
	with larger scope.  If `servername' has content, then
	call krb5_set_default_realm() with supporting code.
	* src/rshd.c (doit) [KRB5] <use_kerberos>: Likewise.

2013-04-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rlogind.c (parse_opt) [KERBEROS || SHISHI]
	<'k'>: Remove unused code checking `arg'.
	(do_krb_login) [KRB5]: Remove `else', which prevents
	later error message extraction.
	[SHISHI]: Likewise.

2013-04-11  Mats Erik Andersson  <gnu@gisladisker.se>

	Working distcheck target.

	* Makefile.am (BUILT_SOURCES): Replace $(top_srcdir)
	by $(top_builddir).
	(DISTCLEANFILES): Add `$(top_builddir)/.version' to list.
	($(top_builddir)/.version): Move target to build directory.

2013-04-11  Mats Erik Andersson  <gnu@gisladisker.se>

	Summary printout is a config.status command.

	* configure.ac (AC_CONFIG_FILES): Add summary.sh to list.
	(AC_CONFIG_COMMANDS): New command `summary'.
	(AC_MSG_NOTICE) <summary>: Removed.
	* .gitignore: Add summary.sh to list.
	* Makefile.am (EXTRA_DIST): Add summary.sh.in.
	* summary.sh.in: New file.
	* am/enable.m4 (IU_ENABLE_FOO): Publish `$1_PROPS'
	and `enable_$1' via AC_SUBST.

2013-04-10  Mats Erik Andersson  <gnu@gisladisker.se>

	* doc/inetutils.texi <main menu>: Order invocation
	nodes in lexicographical order.
	<ping6 invocation>: New node.

2013-04-09  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet, telnetd: Termcap buffer length recommendation.

	* telnet/telnet.c (termbuf): Increase length to 2048,
	and initialize to zero.
	(init_term) [HAVE_TGETENT]: Handle case `err == 1',
	since it can only happen here.
	* telnetd/utility.c (terminaltypeok) [HAVE_TGETENT]:
	Declare BUF.  Call tgetent() to decide return status.
	[!HAVE_GETENT]: Always return 1, lacking the knowledge
	to make any other decision relvant for return status.

	telnetd, libtelnet: Buffer overflow prevention.

	* telnetd/telnetd.h (getterminaltype): New signature.
	* telnetd/telnetd.c (telnetd_setup): Add buffer
	length in call getterminaltype().
	* telnetd/utility.c (getterminaltype): New second
	argument `size_t len'.  Pass `len' to auth_wait().
	* libtelnet/auth-proto.h (auth_wait): New signature.
	(kerberos4_status) [KRB4]: Likewise.
	(kerberos5_status) [KRB5]: Likewise.
	(krb5shishi_status) [SHISHI]: Likewise.
	* libtelnet/auth.h (typedef TN_Authenticator):
	New signature of member `*status'.
	* libtelnet/auth.c (auth_wait): New parameter `len'.
	Pass `len' in the call *authenticated->status().
	* libtelnet/kerberos.c (kerberos4_status): New third
	argument `size_t len'.  Call strncpy().
	* libtelnet/kerberos5.c (kerberos5_status): Likewise.
	* libtelnet/shishi.c (krb5shishi_status): Likewise.
	(krb5shishi_is_auth): Type CNAMEREALMLEN as size_t.

	libtelnet: Minor warnings for casts.

	* libtelnet/encrypt.h (typedef Session_Key)
	[!HAVE_ARPA_TELNET_H_SESSION_KEY]: Make `data' a
	const char pointer.
	* libtelnet/encrypt.c (EncryptDisable): Cast second
	argument in genget() as `char **'.  Cast argument
	to Ambiguous() as `char *'.
	(EncryptType): Likewise.

2013-04-05  Mats Erik Andersson  <gnu@gisladisker.se>

	talk: Non-ASCII characters.

	* talk/display.c: Include <ctype.h>.
	(display): Check printability with isprint().
	Prevent sign extension of char as integer.

2013-04-05  Mats Erik Andersson  <gnu@gisladisker.se>

	talk: Address resolution.

	* talk/get_addrs.c (get_addrs): Implement resolver
	using getaddrinfo().  This is now the preferred method.
	[HAVE_DECL_GETADDRINFO || defined HAVE_IDN]:
	Declare ERR with larger scope.
	[HAVE_DECL_GETADDRINFO]: New variables HINTS, RES, AI.
	Call getaddrinfo() for LHOST and RHOST.
	[HAVE_DECL_GETADDRINFO && AI_IDN]: Add AI_IDN to
	`hints.ai_flags'.

2013-04-04  Mats Erik Andersson  <gnu@gisladisker.se>

	More IDN support for clients.

	* configure.ac <summary>: Uppdate ftp_PROPS,
	talk_PROPS, telnet_PROPS, and tftp_PROPS using
	LIBIDN.
	* ftp/Makefile.am (AM_CPPFLAGS): Add $(INCIDN).
	(LDADD): Add $(LIBIDN).
	* talk/Makefile.am, telnet/Makefile.am
	(AM_CPPFLAGS, LDADD): Likewise.
	* src/Makefile.am (tftp_LDADD): Add $(LIBIDN).

	* ftp/ftp.c [HAVE_IDNA_H]: Include <idna.h>.
	(hookup): New variable RHOST.  Use RHOST in
	getaddrinfo().
	[HAVE_IDN]: Call idna_to_ascii_lz().
	[!HAVE_IDN]: Strdup `host' as RHOST.
	[AI_IDN]: Add to `hints.ai_flags'.
	[AI_CANONIDN]: Likewise.
	* ftp/main.c [HAVE_LOCALE_H]: Include <locale.h>.
	(main) [HAVE_SETLOCALE]: Call setlocale().

	* ping/libping.c (ping_set_dest) [AI_CANONIDN]:
	Add to `hints.ai_flags' independently if AI_IDN.
	* ping/ping6.c (ping_set_dest): Set AI_CANONNAME
	on `hints.ai_flags'.  Strdup `result->ai_canonname'
	to `ping->ping_hostname'.
	[AI_CANONIDN]: Add to `hints.ai_flags'.

	* src/tftp.c [HAVE_LOCALE_H]: Include <locale.h>.
	[HAVE_IDNA_H]: Include <idna.h>.
	(main) [HAVE_SETLOCALE): Call setlocale().
	(resolve_name): New variable RNAME.  Use RNAME
	with getaddrinfo().
	[HAVE_IDN]: Call idna_to_ascii_lz().
	[AI_IDN]: Add to `hints.ai_flags'.
	[AI_CANONIDN]: Add to `hints.ai_flags'.

	* talk/get_addrs.c [HAVE_IDNA_H]: Include <idna.h>.
	(get_addrs): New variables LHOST, RHOST.  Use these
	for address resolution with gethostbyname().
	[HAVE_IDN]: Call idna_to_ascii_lz() twice.
	* talk/talk.c [HAVE_LOCALE_H]: Include <locale.h>.
	(main) [HAVE_SETLOCALE]: Call setlocale().

	* telnet/commands.c [HAVE_IDNA_H]: Include <idna.h>.
	(tn): New variable HOSTTMP.
	[HAVE_IDN]: Call idna_to_ascii_lz() and let HOSTP
	be identical to HOSTTMP if the call was successful.
	Free HOSTTMP after use.
	[IPV6 && AI_IDN]: Set `hints.ai_flags' to AI_IDN.
	* telnet/main.c [HAVE_LOCALE_H]: Include <locale.h>.
	(main) [HAVE_SETLOCALE]: Call setlocale().

2013-03-30  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac <summary>: New variables `*_PROPS'
	for each targeted executable.  Set the likes of
	`ftp_PROPS' and use them to simplify output.

2013-03-28  Mats Erik Andersson  <gnu@gisladisker.se>

	Let Telnet client override Kerberos5 realm.

	* libtelnet/kerberos5.c (dest_realm): Rename from
	previous `telnet_krb5_realm'.
	* telnet/main.c (dest_realm) [KERBEROS || SHISHI]:
	Expand scope from KRB4 to KERBEROS.
	(argp_options) [KERBEROS || SHISHI] <-k/--realm>:
	Likewise.
	(parse_opt) [AUTHENTICATION && (KERBEROS || SHISHI)]
	<case 'k'>: Likewise.

2013-03-28  Mats Erik Andersson  <gnu@gisladisker.se>

	Partial adaptions to Kerberos5, sufficient
	to do some build and runtime testing, but
	without encryption.

	* configure.ac <KERBEROS_VERSION == krb5>:
	Disable `rcp', `rlogin', and `rsh'.
	* libinetutils/des_rw.c [ENCRYPTION && KRB4]:
	Replace KERBEROS by KRB4 in guard.
	* libinetutils/kcmd.c, libinetutils/krcmd.c:
	Likewise.
	* src/rlogind.c [KRB5 && HAVE_COM_ERR_H]:
	Include <com_err.h>.
	(do_krb5_login) [KRB5]: Insert prototype.
	* src/rshd.c [KRB4]: Replace previous KERBEROS
	by KRB4 throughout.
	[KRB5 && HAVE_KRB5_H]: Include <krb5.h>.
	[KRB5 && HAVE_COM_ERR_H]: Include <com_err.h>.
	(doit) [KRB5]: New partial template code and
	related variables for later refinement.
	[KERBEROS]: Set FROMADDR using memcpy().
	[ENCRYPTION && (KERBEROS || SHISHI)]: Call dup2()
	with macros STDIN_FILENO and STDOUT_FILENO.

	Replace obsolete interfaces.

	* libtelnet/kerberos5.c (encryption_init)
	[ENCRYPTION]: Call krb5_auth_con_getsendsubkey().
	(kerberos5_is_auth): New variable VALID.
	Call krb5_auth_con_getrecvsubkey().

	* src/rlogind.c (do_shishi_login) [SHISHI]:
	Test macro ENCRYPT_IO when calling syslog().

	* configure.ac <rsh summary>: Use $rsh_BUILD.

2013-03-22  Mats Erik Andersson  <gnu@gisladisker.se>

	Detection of Kerberos5.

	* configure.ac: Only search for Kerberos headers
	if they were explicitly requested.
	* telnet/utilities.c (printsub)
	[AUTHENTICATION || ENCRYPTION]: Define BUF if
	either macro is defined.
	* telnetd/utility.c (printsub): Likewise.

2013-03-21  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Portability of PAM to Solaris.

	* ftpd/pam.c: Include <unistd.h>.
	(TTY_FORMAT): New macro.
	(pam_user): New variable TTY_NAME.  Set PAM_TTY by calling
	pam_set_item() with a value constructed from getpid().

2013-03-19  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Support PAM beyond Linux-PAM.

	* configure.ac (FTPD_LIBPAM): Set to $LIBPAM
	for all PAM implementations.
	* ftpd/auth.c (auth_user) <default case>
	[WITH_PAM && !WITH_LINUX_PAM]: Call pam_user()
	if preceding tests were passed and if `auth_type'
	is AUTH_TYPE_PAM.
	(auth_pass) [WITH_PAM] <AUTH_TYPE_PAM>: Relax old
	conditioning on WITH_LINUX_PAM.
	* ftpd/extern.h (pam_user, pam_pass, pam_end_login)
	[WITH_PAM]: Likewise.
	* ftpd/ftpd.c (options) [WITH_PAM] <pam>: Likewise.
	(parse_opt) <pam> [WITH_PAM]: Likewise.
	(end_login) [WITH_PAM]: Likewise, use of pam_end_login().
	* ftpd/pam.c [WITH_PAM]: Likewise, entire file.
	(PAM_conv) <PAM_PROMPT_ECHO_OFF> [!WITH_LINUX_PAM]:
	Return PAM_CRED_INSUFFICIENT.
	(pam_doit) <failed pam_authenticate> [!WITH_LINUX_PAM]:
	Check for status PAM_CRED_INSUFFICIENT with empty
	password.

	* ftpd/ftpd.c (doc) [WITH_PAM]: Mention PAM service
	name 'ftp' in text.
	(options) [WITH_KERBEROS5] <kerberos5>: Correct
	misspelled authentication name.

2013-03-15  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Incomplete source route security.
	The protection against IPOPT_LSRR was not
	enforced during Kerberised execution.

	* src/rlogind.c (prevent_routing) [IP_OPTIONS]:
	New function, broken out of old code.  Replace
	socket number 0 by a parameter `fd', which makes
	certain that daemon-mode is examined correctly.
	(rlogind_auth) [IP_OPTIONS]: Call prevent_routing()
	early on, before code path separation for Kerberos.

2013-03-15  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Differentiate PAM services.

	* src/rshd.c (service) [WITH_PAM]: New variable.
	(doc) [WITH_PAM && (KERBEROS || SHISHI)]:
	Mention `krsh' in description.
	(doit) [WITH_PAM && (KERBEROS || SHISHI)]:
	Set PAM service type to "krsh" for kerberised action,
	and "rsh" otherwise.
	[WITH_PAM]: Pass `service' to pam_start() and to
	pam_set_item(PAM_TTY).
	(rsh_conv) [WITH_PAM]: Add _GL_UNUSED_PARAMETER to the
	function parameter `data'.

2013-03-14  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: PAM support with libshishi.

	* src/rlogind.c (doc) [WITH_PAM && SHISHI]:
	Mention `krlogin' in description.
	(do_pam_check) [WITH_PAM]: New function,
	refactored from previous code in do_rlogin().
	(do_rlogin) [WITH_PAM]: Remove variable USER.
	Replace code block by a call to do_pam_check()
	for service `rlogin'.
	(do_shishi_login) [SHISHI && WITH_PAM]:
	Call do_pam_check() for service `krlogin'.

2013-03-14  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rlogind.c (do_shishi_login) [SHISHI]:
	Do not free the static pointer PWD!
	Call getpwnam() for verification that local
	user exists.  Add check to prevent root access
	unless the flag `allow_root' is set.
	Call shishi_ap_done() before sending a log report.

2013-03-13  Guillem Jover  <guillem@hadrons.org>

	Use standard suid-mode for install.

	* ping/Makefile.am (SUIDMODE): Change mode to `4755'.
	* src/Makefile.am (SUIDMODE): Likewise.

2013-03-13  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Initial PAM support.
	New code for plain authentication only.

	* configure.ac <rlogind summary>: Report PAM.
	* src/Makefile.am (rlogind_LDADD): Add $(LIBPAM)
	and $(LIBDL).
	* src/rlogind.c [HAVE_SECURITY_PAM_APPL_H]:
	Include <security/pam_appl.h>.
	(pam_rc, pam_handle, pam_conv) [WITH_PAM]:
	New variables.
	(rlogin_conv) [WITH_PAM]: New function.
	(doc) [WITH_PAM]: Add info to string.
	(do_rlogin) [WITH_PAM]: New variable USER.
	New code block.
	(fatal) [WITH_PAM]: Call pam_end().

	* src/rlogind.c (rlogind_auth)
	[!HAVE_DECL_GETADDRINFO || !HAVE_DECL_NAMEINFO]:
	Use ADDRP only within this condition.

2013-03-11  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Functional option `--target-directory'.
	Implement the missing case where `-d' is given
	an argument.

	* src/rcp.c (target): New variable.
	(parse_opt) <'d'>: If `arg' has contents, copy it
	to `target'.
	(main): Only one command line argument is needed for
	calls with set `target'.  If `target' is not set,
	extract it from the very last command line argument,
	and decrease `argc' to reflect this action.  Apply
	colon() and verify() to `target'.
	(toremote): Extract host and user name from `target'.
	Let I loop until `argc', since `argc' no longer includes
	the target directory.
	(tolocal): New variable VECT.  Loop I until `argc'.
	Exchange `target' for `argv[argc - 1]'.  Fix VECT to
	be a short array with `target', and apply it to sink().

2013-03-09  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Portability fixes.

	* src/rcp.c: Include <stdint.h>.
	(options): Make argument to `-d' optional, since
	the remote server need that form of invocation.
	(source): Use format "%jd" and cast as intmax_t
	to work around buggy library modes, which otherwise
	are missing the last string argument.

2013-03-08  Mats Erik Andersson  <gnu@gisladisker.se>

	* bootstrap: Updated from gnulib.

2013-03-07  Mats Erik Andersson  <gnu@gisladisker.se>

	Relax setuid demands.

	* src/rcp.c (effuid): New variable.
	(main): Set `effuid' by calling geteuid().
	Remove test on non-zero geteuid().
	(toremote): If `rem < 0' and `errno == EACCES',
	then report failure to access privileged port.
	(tolocal): Use argument `effuid' for seteuid().
	* src/rlogin.c (main): Remove test on non-zero
	geteuid().  If `rem < 0' and `errno == EACCES',
	then report failure to access privileged port.
	* src/rsh.c (main): Likewise.

	* ping/libping.c (ping_init): Let error message
	mention privileges, instead of non-root access.

	Avoid assignment inside if-clauses, as per GCS.

	* src/rcp.c (main, tolocal, source, rsource, sink)
	(allocbuf): Assign to variables first, then test
	their values in an if-clause.
	* src/rlogin.c (main, get_window_size, getescape):
	Likewise.
	* src/rlogind.c (rlogind_auth, do_krb5_login)
	(protocol): Likewise.
	* src/rsh.c (main, talk, copyargs): Likewise.
	* src/rshd.c (doit): Likewise.

2013-03-02  Mats Erik Andersson  <gnu@gisladisker.se>

	Make the FTP transfer test somewhat robuster.

	* tests/ftp-localhost.sh <set-up of DLDIR>:
	Reset do_transfer as `false' before probing.
	Add `/tmp' as a candidate subdirectory.
	Set do_transfer to `true' only with a confirmed
	writable directory.  Exit with status 99, should
	TRANSFERTEST be set, but directory search fails.

2013-02-24  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Log selectively on program name.

	* src/syslogd.c (selector): New variable.
	(struct filed): New members `f_progname' and
	`f_prognlen'.
	(logmsg): Filter on committing program name if
	`f->f_progname' has been set for this file.
	(init): Free `f->f_progname' and `selector'.
	Capture program name selector while parsing.
	(cfline): If `selector' is set, indicate its value
	in debug printing, and copy it to `f->f_progname',
	also setting `f->f_prognlen'.

	* doc/inetutils.texi (syslogd invocation): Update.

2013-02-23  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Portably restart signals.  Necessary
	for Solaris.

	* src/syslogd.c (main) [HAVE_SIGACTION]:
	New variable SA.  Use sigaction() to install
	dispositions for SIGALRM, SIGUSR1, and SIGHUP.
	(domark) [!HAVE_SIGACTION]: Reactivate SIGALRM.
	(dbg_toggle) [!HAVE_SIGACTION]: Reactivate SIGUSR1.
	(trigger_restart) [!HAVE_SIGACTION]:
	Reactivate SIGHUP.

	* src/syslogd.c (printline): Use an else-block to
	prevent duplicate messages when `force_sync' is set.

2013-02-21  Mats Erik Andersson  <gnu@gisladisker.se>

	libls: Allow repeated invokations.  Remove exit()
	in this library.  Repair numerical stats.

	* libls/ls.c (ls_main): Clear `output', all option
	flags `f_*', and `optind' to handle correctly repeated
	invokations.  Replace exit() with return().
	<case 'l'>: Do not reset `f_numericonly'.
	<default case>: Return with value from usage().
	(travers): Replace exit() by return() and set `rval'.
	(display): Initialise USER and GROUP to NULL.
	Replace exit() with return().
	* libls/util.c (usage): Return type `int'.
	Replace exit() with return().
	* libls/extern.h (usage): Update.

	* libls/ls.c (ls_main, traverse, display):
	Pull variable assignment out of if-statement.

2013-01-25  Mats Erik Andersson  <gnu@gisladisker.se>

	libls: Use __opendir2() if present.

	* configure.ac: Check for __opendir2, not opendir2.

	* libls/fts.c (fts_build) [HAVE___OPENDIR2]:
	Change conditional test for declaration of OFLAG.
	Initialise OFLAG only with DTF_NODUP, and add
	DTF_REWIND and DTF_HIDEW conditionally.
	Remove macro opendir2.  Assign DIRP from either
	__opendir2() or opendir().  Then test DIRP.

2013-01-22  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Loose source routing.

	* src/traceroute.c [HAVE_NETINET_IP_VAR_H]:
	Include <netinet/ip_var.h>.
	(len_ip_opts, ip_opts, opt_gateways) [IP_OPTIONS]:
	New variables.
	(argp_options) [IP_OPTIONS]: New option `-g/--gateways'.
	(parse_opt) [IP_OPTIONS] <'g'>: New case.
	(main): Call trace_ip_opts().
	(trace_init) [IP_OPTIONS]: If `len_ip_opts' is positive,
	call setsockopt(IP_OPTIONS).
	(trace_ip_opts): New function.

	traceroute: Settable maximal hop count.

	* src/traceroute.c (argp_options): New option `-m/--max-hop'.
	(parse_opt) <'m'>: New case.
	(main): Exit with EXIT_FAILURE if HOP exceeds `opt_max_hops'.

2013-01-21  Guillem Jover  <guillem@hadrons.org>

	Cleanup automake variables.

	* ftp/Makefile.am (AM_CPPFLAGS): Consume depreciated
	macro INCLUDES.
	* ftpd/Makefile.am, ifconfig/Makefile.am,
	libinetutils/Makefile.am: Likewise.
	* libls/Makefile.am (AM_CPPFLAGS): Rename INCLUDES.
	* libtelnet/Makefile.am: Likewise.
	* ping/Makefile.am (AM_CPPFLAGS): Likewise.
	(LDADD): New macro.
	(ping_LDADD): Simplify using LDADD.
	(ping6_LDADD): Remove.
	* src/Makefile.am (AM_CPPFLAGS): Consume INCLUDES.
	* talkd/Makefile.am, telnet/Makefile.am,
	telnetd/Makefile.am: Likewise.
	* talk/Makefile.am (AM_CPPFLAGS): Rename INCLUDES.
	* whois/Makefile.am: Likewise.

2013-01-21  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac (AM_C_PROTOTYPES): Remove obsolete macro.
	Not supported by automake-1.13.

2013-01-17  Mats Erik Andersson  <gnu@gisladisker.se>

	ping6: Setting of tclass and flowinfo.

	* ping/ping6.c (tclass) [IPV6_TCLASS]: New variable.
	(flowinfo) [IPV6_FLOWINFO]: New variable.
	(argp_options): Make `--ttl' a synonym for `--hoplimit'.
	[IPV6_FLOWINFO]: New option `-F/--flowinfo'.
	[IPV6_TCLASS]: New option `-T/--tos'.
	(parse_opt) [IPV6_FLOWINFO]: New case 'F'.
	[IPV6_TCLASS]: New case 'T'.
	(main) [IPV6_TCLASS]: Call setsockopt(IPV6_TCLASS).
	[IPV6_FLOWINFO]: Call setsockopt(IPV6_FLOWINFO).
	* ping/ping_common.h (OPT_FLOWINFO, OPT_TCLASS): New macros.

2013-01-17  Mats Erik Andersson  <gnu@gisladisker.se>

	CVE-2010-2529: Infinite loop.

	* ping/ping_echo.c (print_ip_opt) <IPOPT_RR>: Break loop
	if option is truncated or exhausted.
	<IPOPT_TS>: Break loop if option is truncated.

2013-01-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/ping6.c: Include <arpa/inet.h>.
	(print_ip_data): New function.
	(print_icmp_error): In verbose mode, let print_ip_data()
	display information on returned packet.

	* ping/ping_echo.c (print_icmp): Use bitwise-and in test.

2013-01-16  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/ping_echo.c (print_ip_header): Empirically test
	`ip->ip_len' to decide whether ntohs() is needed.
	(print_icmp): Call print_ip_data() only in verbose mode.

2013-01-16  Guillem Jover  <guillem@hadrons.org>

	* ping/libping.c (ping_xmit): Do not call perror().
	Instead return a negative status.
	* ping/ping.c (send_echo): New variable RC.
	Abort with a message on any error condition.
	* ping/ping6.c (ping_xmit): Likewise.
	(send_echo): Likewise.

2013-01-07  Mats Erik Andersson  <gnu@gisladisker.se>

	tftpd: Error handling.
	Send NAK on error conditions in chrooted mode,
	preventing the client from hanging indefinitely.

	* src/tftpd.c (main): Send NAK with ENOUSER as
	response, should chrooted mode specify non-existent
	user or group.  Likewise when setgid() or setuid()
	fails.  Send NAK with EACCESS, should chroot() fail.
	(usage_str, usage): Remove unused constructs.

2013-01-05  Mats Erik Andersson  <gnu@gisladisker.se>

	tftpd: Group setting.
	A group named `nogroup' is not portable enough,
	so tidy the chrooting code for robustness.

	* src/tftpd.c (DEFAULT_GROUP): Remove macro.
	(main): Do not initialize `group'.  Delay code
	block for chroot set-up until after forking and
	socket binding.  Separate setgid() from setuid(),
	and inherit group membership from owner, should
	no group have been specified.

2013-01-02  Mats Erik Andersson  <gnu@gisladisker.se>

	tftpd: Chrooted mode.

	* src/tftpd.c: Include <grp.h>, <pwd.h>, <xalloc.h>.
	(chrootdir, group, user): New variables.
	(DEFAULT_GROUP, DEFAULT_USER): New macros.
	(options): New options `-g/--group', `-s/--secure-dir',
	and `-u/--user'.  Put new options in separate group.
	(parse_opt): Parameter `arg' is now in use.
	<`g', `s', `u'>: New cases.
	(main): Assign default values to `group', `user'.
	If chrooted mode was specified, execute chroot(),
	setgid(), and setuid().
	* tests/tftp.sh (do_secure_setting): New variable.
	Set to true only for the super-user, then activating
	two further read tests.
	(REDIRECT): Set also for empty VERBOSE.

	* doc/inetutils.texi <tftpd invocation>: Fill with
	sensible content for old and new capabilities.

2012-12-27  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Conform to standard application set-up.

	* src/traceroute.c (opt_type): Default to TRACE_UDP.
	(opt_port): Set to TRACE_UDP_PORT.
	(opt_ttl, opt_wait): New variables.
	(argp_options): New options `-f/--first-hop', `-I/--icmp',
	and `-w/--wait'.
	(parse_opt) <`p', `t'> : Use strtol() for better sanitation.
	<`f', `I', `w'>: New cases.
	(main): Free RHOST after use.
	[HAVE_IDN]: Free `hostname'.
	(do_try): Set timer from `opt_wait'.
	(trace_init): Set `t->ttl' from `opt_ttl'.

	* doc/inetutils.texi <traceroute invocation>: Update
	with new options.  Add a section on diagnostics.

2012-12-19  Mats Erik Andersson  <gnu@gisladisker.se>

	Detect a writable directory for better coverage.
	Add a test for mapping of file names.

	* tests/ftp-localhost.sh (DLDIR): New variable.
	Put files in $DLDIR of the chrooted user.
	(GETME, PUTME): Use mktemp() to generate names.
	[do_transfer]: New test of two nmap modes.

2012-12-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftp/cmds.c (cp_subst): Change SRC_LEN to size_t.
	New variable OFFSET.  Update `*to_p' after realloc(),
	making the cursor a valid pointer.
	(domap): Calculate BUF_LEN from `mapout', not `name'.
	<LOOP, subcase `no token'>: Move character copying
	to outer if-block, thus breaking an infinite loop.

2012-12-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftp/cmds.c (put, mput, getit, mget): Check if
	domap() has allocated new memory, and only then
	update string pointer and free old memory.
	(domap) <'[', LOOP>: If cp_subst() substituted
	something, set MATCH to 1.

2012-12-07  Mats Erik Andersson  <gnu@gisladisker.se>

	Activate servers in FreeBSD 9 and 10.  They work
	sufficiently well with the previous adaptions.

	* configure.ac <*-freebsd9* || *-freebsd10*>:
	Delete inhibition of ftpd, rlogind, telnetd, and uucpd.

	Mixed compilation warnings.

	* ftp/cmdtab.c (help): Cast strlen() as int.
	* libls/ls.c (display): MAXBLOCK is portably `long'.
	* src/rlogind.c (protocol): Make NFD an unsigned int.
	* telnet/sys_bsd.c (ayt) [SIGINFO]: Mark `sig' as unused.
	* telnet/telnet.c (init_term): Declare static.  Delete
	unused parameter `fd'.  Rewrite numerical end of TERMBUF.
	(gettermname): Update call to init_term().
	(lm_will, lm_do, lm_mode, slc_import): Cast sizeof()
	as int when comparing to NETROOM.
	(telnet) [!AUTHENTICATION && !ENCRYPTION]: Trivially
	use parameter `user'.

2012-12-07  Mats Erik Andersson  <gnu@gisladisker.se>

	Keep track of allocations.  Was an unlimited use of malloc()!

	* src/rcp.c (sink): Change CURSIZE to size_t.  Initialize
	NAMEBUF and CURSIZE.  Free buffer at each allocation, and
	set CURSIZE.  Capture error condition after failed malloc(),
	resetting CURSIZE and continuing with next loop iteration.

	Signedness warnings in src/.

	* src/hostname.c (parse_file): Use ssize_t for NREAD.
	* src/logger.c (IU_MAX_FAC): New macro.
	(decode): Remove C.  Use `n >= IU_MAX_FAC' to detect
	input error.  Return N for successful values.
	(send_to_syslog): Cast LEN as ssize_t in comparison.
	* src/rcp.c (allocbuf): Cast `bp->cnt' as size_t in comparison.
	* src/rexecd.c (die): Cast `sizeof buf' as int in comparison.
	(getstr): Cast `buf_len >> 3' as ssize_t in comparison.
	* src/rshd.c (getstr): Likewise.

2012-12-06  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Allow `--up', `--down' to be used before
	interface selection.  Applies to all flags.

	* ifconfig/options.c (pending_setflags, pending_clrflags):
	New variables.
	(parse_opt_set_flag): Use parameters to manipulate only
	pending_setflags and pending_clrflags, not `ifp->*flags',
	since the latter need not be allocated.
	(parse_opt_finalize): Assign values to `ifp->setflags'
	and `ifp->clrflags' using `pending_*flags'.
	* ifconfig/options.h (pending_setflags, pending_clrflags):
	New external declarations.

	Detect member `struct ifreq.ifr_mtu'.

	* configure.ac (HAVE_STRUCT_IFREQ_IFR_MTU): Check for
	member ifr_mtu in `struct ifreq'.
	* ifconfig/system/solaris.h (ifr_mtu)
	[!HAVE_STRUCT_IFREQ_IFR_MTU]: Protect macro definition.

	ifconfig: Attend to many compiler warnings.

	* ifconfig/flags.c (if_flags): Set member `rev' to 0,
	whenever it was missing.  Remove duplicate elements
	"OACTIVE" and "D2".  End array with full element.
	(flag_char_tab): End array with full stop element.
	* ifconfig/options.c: Include <unused-parameter.h>.
	(ifconfig_initializer): Initialize all members.
	(formats): End array with full stop element.
	(argp_options): New local macro GRP.  Add GRP to every
	element.  Add description to `peer' and `brdaddr'.
	End array with full stop element.
	(parse_opt_set_flag): Mark ifp as unused.
	(default_help_filter): Mark input as unused.
	(argp): Add NULL as missing, last element.
	* ifconfig/printif.c: Include <unused-parameter.h>.
	(put_char, put_int, put_ulong): Mark form as unused.
	(put_flags_short): Mark argc and argv as unused.
	(fh_nothing): Mark all parameters as unused.
	(fh_newline, fh_tabulator, fh_progname, fh_name)
	(fh_index): Mark argc and argv as unused.
	(fh_exit): Mark form as unused.

	* ifconfig/system/bsd.c: Include <unused-parameter.h>.
	(system_parse_opt, system_configure): Mark all parameters
	as unused.
	(system_fh_hwaddr, system_fh_hwtype): Mark argc and argv
	as unused.

	* ifconfig/system/linux.c: Include <unused-parameter.h>.
	(print_hwaddr_ether, print_hwaddr_arcnet, print_hwaddr_dlci)
	(print_hwaddr_irda, print_hwaddr_rose): Mark form as unused.
	Set had_output.
	(print_hwaddr_ax25): Set had_output.
	(system_fh_hwaddr, system_hw_type): Mark argc and argv as unused.
	(linux_argp_options): Add group member to element "txqlen".
	End array with full stop element.
	(linux_argp): Fill missing members with NULL.

	* ifconfig/system/solaris.c: Include <unused-parameter.h>.
	(system_parse_opt): Mark all parameters as unused.
	(system_configure) [!IF_VALID_TXQLEN]: Trivially use
	paramaters sfd, ifr, and ifs.

2012-12-04  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/system/bsd.c (system_help): Update.
	(system_parse_opt_rest): Populate function with
	parser and actions for command line arguments.

	* ifconfig/system/solaris.c (system_help): Update.
	(system_parse_opt_rest): Implement actions for the
	arguments "up" and "down" of an interface.

2012-12-03  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Audit displaying of metrics.
	The portable display is to supress metric naught.

	* ifconfig/printif.c (fh_metric_query) [SIOCGIFMETRIC]:
	Add the further condition `form->ifr->ifr_metric > 0'
	(fh_metric) [SIOCGIFMETRIC]: Do not report value 0 of
	`form->ifr->ifr_metric' as 1.
	* ifconfig/system/bsd.c (system_fh_metric): Remove.
	* ifconfig/system/bsd.h (SYSTEM_FORMAT_HANDLER):
	Delete key "metric".
	(system_fh_metric): Remove prototype.

	Implement exceptional handler for GNU/Linux.

	* ifconfig/system/linux.c (system_fh_metric_query)
	(system_fh_metric): New functions.
	* ifconfig/system/linux.h (SYSTEM_FORMAT_HANDLER):
	Add new keys "metric?" and "metric".
	(system_fh_metric_query, system_fh_metric):
	New prototypes.

2012-12-03  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig.sh: Avoid substring matches.

	* tests/ifconfig.sh (LO): Assign inside a loop,
	after matching by `expr' against interface name.

	Format string errors and warnings.

	* ifconfig/options.c (parse_opt_flag_list):
	Cast LEN as int for use as width in `%*.*s'.
	* src/rcp.c (source): Use "%zd" instead of "%lld".
	* src/rexecd.c (doit): Format "%d" for `pwd->pw_gid'.
	* telnet/commands.c (ayt_status) [SIGINFO]:
	Return status 1.
	(help): Cast HELPIDENT as int for use as format width.

2012-11-28  Mats Erik Andersson  <gnu@gisladisker.se>

	libinetutils.a: Build if_nametoindex(), if_nameindex(),
	and if_freenameindex() into library, if they are missing
	in the system library.

	* libinetutils/Makefile.am (libinetutils_a_SOURCES):
	Add if_index.c.
	* libinetutils/if_index.c: Moved from old location at
	`ifconfig/if_index.c'.  Do not include <ifconfig.h>.
	* libinetutils/libinetutils.h (if_nameindex)
	[!HAVE_STRUCT_IF_NAMEINDEX): New structure declaration.
	(if_nametoindex, if_nameindex, if_freenameindex)
	[!HAVE_STRUCT_IF_NAMEINDEX): New function declarations.

	* ifconfig/Makefile.am (ifconfig_SOURCES): Remove if_index.c.
	(noinst_HEADERS): Remove if_index.h.
	* ifconfig/if_index.c, ifconfig/if_index.h: Deleted files.
	* ifconfig/ifconfig.h: Do not include "if_index.h".
	* ifconfig/system.h: Do not include <if_index.h>.

	Test script for ifconfig utility.

	* tests/ifconfig.sh: New file.
	* tests/Makefile.am (dist_check_SCRIPTS) [ENABLE_ifconfig]:
	Add ifconfig.sh.

2012-11-23  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Reusable IP sockets.
	Automated test systems seemingly fail here.

	* src/syslogd.c (create_inet_socket): Set socket
	option SO_REUSEADDR on IP sockets.

2012-11-23  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Output formatting.

	* ifconfig/options.c (formats) <gnu format>:
	Test with `ifdisplay?' to suppress empty lines
	for dormant interfaces.
	<net-tools format>: Remove a newline for txqlen.
	<netstat format>: Use `exists?' on `ifstat?',
	leaving statistics empty if `ifstat?' fails.

2012-11-23  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Initial hwaddr support for BSD.

	* ifconfig/options.c (formats) <unix format>:
	Place hwtype/hwaddr stanza before addr stanza,
	and emit text only if hwtype evaluates to true.
	(argp_options): Mention `--format=help' in usage.
	* ifconfig/system/bsd.c: Multiple inclusions.
	(ifp): New variable.
	(ESTABLISH_IFADDRS): New macro.
	(system_fh_hwaddr_query, system_fh_hwaddr)
	(system_fh_hwtype_query, system_fh_hwtype):
	New functions.
	* ifconfig/system/bsd.h (IU_BSD_TYPE, ETHERNAME):
	New macros.
	(SYSTEM_FORMAT_HANDLER): Replace keys "dragonflybsd",
	"freebsd", "netbsd", and "openbsd" by the single
	IU_BSD_TYPE, encoding the only relevant system type.
	Add keys "hwaddr?", "hwaddr", "hwtype?", and "hwtype".
	(system_fh_hwaddr_query, system_fh_hwaddr)
	(system_fh_hwtype_query, system_fh_hwtype):
	New prototypes.

2012-11-21  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Make address changes possible on BSD.

	* ifconfig/changeif.c (SET_SIN_LEN): New macro.
	(SIOCSIF): Add SET_SIN_LEN, which is needed by
	every BSD system.

	* ifconfig/options.c (formats) <unix format>:
	Add `dstaddr?' stanza for tunnel interfaces.

2012-11-18  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/ifconfig.c (main): New independent code
	to be executed when `list_mode' is true.
	* ifconfig/options.c (list_mode): New variable.
	(argp_options): New option `-l/--list'.
	(parse_opt) <'l'>: New case.
	* ifconfig/options.h (list_mode): New variable.

2012-11-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/system/Makefile.am (noinst_HEADERS):
	Add `solaris.h' which was accidentally removed.

2012-11-17  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/system/Makefile.am (noinst_HEADERS):
	Add `bsd.h' and `bsd.c' for distribution.

2012-11-17  Mats Erik Andersson  <gnu@gisladisker.se>

	ifconfig: Implement stub for BSD systems.

	* ifconfig/options.c (formats) <unix format>:
	Add metric to printout.
	* ifconfig/system.c [__DragonFly__ || __FreeBSD__ ||
	__NetBSD__ || __OpenBSD__]: Include "system/bsd.c".
	* ifconfig/system.h [__DragonFly__ || __FreeBSD__ ||
	__NetBSD__ || __OpenBSD__]: Include "system/bsd.h".
	* ifconfig/system/bsd.c, ifconfig/system/bsd.h:
	New source files.

2012-11-16  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Adapt to legacy utmp.

	* configure.ac: Check for getutxent.
	* srs/syslogd.c (wallmsg)
	[UTMP_NAME_FUNCTION || !HAVE_GETUTXENT]: Refine
	preprocessor conditional to let read_utmp() handle
	systems with legacy implementation of utmp.  Adding
	a test of !HAVE_GETUTXENT achieves this.

2012-11-16  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd, talkd: Alternative utmp access.

	* configure.ac: Check for getutxuser.
	* src/syslogd.c (wallmsg) [!UTMP_NAME_FUNCTION]:
	Remove UTMPBUF and COUNT.  Call setutxent(),
	getutxent(), and endutxent().
	* talkd/process.c (find_user) [HAVE_GETUTXUSER]:
	Remove UTMPBUF and UTMP_COUNT.  Call setutxent(),
	getutxuser(), and endutxent().
	* tests/readutmp.c (main) [HAVE_GETUTXUSER]: Remove
	UTMPP, UPTR, and COUNT.  Call setutxent(), getutxuser(),
	and endutxent().
	[!HAVE_GETUTXUSER]: Free UTMPP.

2012-11-15  Mats Erik Andersson  <gnu@gisladisker.se>

	Disable targets robustly.

	* am/enable.m4 (IU_DISABLE_TARGET): New macro.
	* configure.ac <ftpd, rlogind, rshd, talk, talkd, telnetd>
	<uucpd>: Use IU_DISABLE_TARGET to disable unbuildable targets,
	avoiding the incomplete manipulations used so far.

2012-11-14  Mats Erik Andersson  <gnu@gisladisker.se>

	* libinetutils/daemon.c (waitdaemon) [_SC_OPEN_MAX]:
	Remove HAVE_SYSCONF from preprocessor conditional.

	* src/syslogd.c (main): Install `die' for SIGINT, SIGQUIT,
	and SIGUSR1 based on NoDetach.  Initially set `dpg_output = 1'
	only in debug mode.  Print a notice also in non-detached mode.
	(cfline): Move assignment to `f->f_file' outside of
	if-statement.
	(dbg_printf): Test `!(NoDetach && dbg_output)' for output.

	* tests/waitdaemon.c: New source file.
	* tests/Makefile.am (check_PROGRAMS): Add waitdaemon.
	(TESTS): Likewise.
	* tests/.gitignore: Likewise.

	* tests/syslogd.sh: Add a sleep period after `kill -HUP'.
	(OBSCURE): New environment variable.  Conduct configuration
	test for non-existent log host only if OBSCURE is set.

	* tests/utmp.sh: Use who(1), if possible, to improve
	reliability of test, checking known users only.
	* configure.ac <*-freebsd9* || *-freebsd10*>:
	Do not disable syslogd and talkd, as the updated test script
	`utmp.sh' will catch the failure as long as it remains.

	* src/Makefile.am (AM_CPPFLAGS): Add $(PATHDEF_TTY_PFX).
	* talkd/Makefile.am (AM_CPPFLAGS): Likewise.
	* telnetd/Makefile.am (AM_CPPFLAGS): Likewise.

	* whois/Makefile.am: Set `LANG=C' when invoking perl.

2012-11-10  Mats Erik Andersson  <gnu@gisladisker.se>

	Consistent use of device prefix.

	* srs/rlogind.c (setup_utmp, cleanup): Use PATH_TTY_PFX,
	not PATH_DEV.
	* talkd/announce.c (announce): Likewise.
	* talkd/process.c (find_user): Likewise.
	* telnetd/pty.c (setup_utmp, cleanup): Likewise.

	* src/rexecd.c (doit) [DEBUG]: Use PATH_TTY, not _PATH_TTY.

	* doc/inetutils.texi: Refer to `.k5login', not `.klogin'.

2012-11-09  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Support encrypted libshishi sessions.

	* src/rcp.c (toremote) <remote-to-remote>: In format strings,
	put options to PATH_RSH before the host argument.
	[(KERBEROS || SHISHI) && ENCRYPTION] <doencrypt>:
	Add option `-x' in format strings.
	[SHISHI && ENCRYPTION]: Close encryption handle and data.
	(tolocal): In format string, portability needs `-R' as
	option to PATH_CP, not `-r'.
	[SHISHI && ENCRYPTION]: Close encryption handle and data.
	(kerberos) [SHISHI && ENCRYPTION]: New variables I and XBP.
	Call krcmd_mutual() and initialize encryption data.

	* src/rshd.c (doit) <denied non-encryption>: Include host name
	in syslog message.

2012-11-06  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Allow enforced encryption with libshishi,
	rejecting other Kerberized sessions.

	* src/rshd.c (uses_encryption) [SHISHI]: New variable.
	(options) [(KERBEROS || SHISHI) && ENCRYPTION]:
	Expose option `-x/--encrypt'.
	(doit) [SHISHI] <client encrypts>: Set `uses_encryption'
	instead of `doencrypt'.  Fail connection request if
	`doencrypt && !uses_encryption', otherwise proceed.
	[SHISHI] <logging>: Refine message to indicate whether
	encryption is in use.

	* src/rlogind.c (do_krb_login) [SHISHI]: Initialize RC
	as SHISHI_VERIFY_FAILED.
	[KERBEROS]: Initialize RC as 1.

	* src/rlogind.c (setup_utmp): Calculate offset
	from PATH_DEV.
	* telnetd/pty.c (setup_utmp): Likewise.

2012-11-05  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Buffer overflow, causing stalled and
	incomplete login for encrypted connections.

	* libinetutils/shishi_def.h (SHISHI_ENCRYPT_BUFLEN):
	Rename from previous BUFLEN.
	* libinetutils/shishi.c (readenc): Likewise, used
	in calling memset() on `buf'.
	* src/rlogind.c (do_shishi_login): Replace 100 by
	sizeof(cksumdata) when calling snprintf().  Insert
	`encrypted' in syslog message for encrypted exchange.
	(BUFLEN): Define as SHISHI_ENCRYPT_BUFLEN, if possible,
	otherwise fall back to existing value, or to 1024.
	(protocol): Declare FIBUF of length BUFLEN, and DBUF
	of length BUFLEN+1.

2012-11-02  Mats Erik Andersson  <gnu@gisladisker.se>

	* telnet/commands.c: Include <limits.h>.  Needed
	by Solaris to have LLONG_MAX.

2012-11-02  Mats Erik Andersson  <gnu@gisladisker.se>

	* telnet/commands.c (tn): New block with sanity check of
	numerical port, being out of range, or mixed with letters.

2012-11-01  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Build without readline support.

	* configure.ac <enable_ftp>: Remove test for disabling
	FTP client based on `$gl_cv_lib_readline = no'.
	* am/readline.m4 (gl_FUNC_READLINE): Create option
	`--disable-readline' using AC_ARG_ENABLE([readline]).
	(HAVE_READLINE): Demand also `$enable_readline = yes`.
	* ftp/cmds.c [HAVE_READLINE_READLINE_H]: Inclusion guard
	for <readline/readline.h>.
	[HAVE_READLINE_HISTORY_H]: Guard <readline/history.h>.
	(another) [HAVE_READLINE]: Conditional use of readline()
	and of add_history().
	* ftp/main.c [HAVE_READLINE_READLINE_H]: Inclusion guard
	for <readline/readline.h>.
	[HAVE_READLINE_HISTORY_H]: Guard <readline/history.h>.
	(argp_options) [!HAVE_READLINE]: Alternate description
	for `-e/--no-edit'.
	(cmdscanner) [HAVE_READLINE]: Conditional use of readline()
	and of add_history().

2012-10-30  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/readutmp.c: New file.
	* tests/utmp.sh: New file.
	* tests/Makefile.am (check_PROGRAMS): Add readutmp.
	(dist_check_SCRIPTS): Add utmp.sh.
	* tests/.gitignore: Add readutmp to list.

2012-10-29  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Increase universality by recognizing the alias
	name `pftp' and the option `-e'.

	* ftp/cmds.c (another): New variable SIZE.  Use LEN
	typed as size_t.  Condition readline() on `usereadline'
	not `fromatty', otherwise read input based on getline().
	Likewise, condition add_history() on `usereadline'.
	(dotrans): Use type size_t for I, OSTOP, FOUND.
	* ftp/ftp_var.h (usereadline): New variable.
	* ftp/main.c (argp_options): New option `-e/--no-edit'.
	(parse_opt) <'e'>: New case.
	(main): Check if invoked as `pftp', setting passive mode.
	Clear `usereadline' without a TTY.
	(cmdscanner): Change L to ssize_t.  New variable LEN.
	Condition readline() and add_history() on `usereadline',
	else use a getline() block for input.

2012-10-28  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftpd/popen.c (ftpd_popen): Prevent null deference
	and allocation overflow in access to glob patterns.

2012-10-23  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: PAM robustness.  Fine tune message passing,
	since the finite state automata of FTP can choke
	on some multiline messages.

	* ftpd/extern.h (lreply_multiline): New prototype.
	* ftpd/ftpd.c (user): Transmit a reply containing
	only a single line, cutting at the last newline.
	(pass): If the credential of an authenticated user
	contains a message, reply using lreply_multiline().
	(lreply_multiline): New function.
	* ftpd/pam.c (PAM_conv): Insert a newline character
	between concatenated message strings.  Remove only
	trailing whitespace, leaving any colon untouched.
	(pam_doit): Compare message string to `password:',
	including a colon.

2012-10-19  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd: Portability of utmp.  Disclosed by Solaris 11.

	* src/syslogd.c (wallmsg): Call read_utmp() with the
	file argument UTMP_FILE, not PATH_UTMP.
	* talkd/process.c (find_user): Likewise.

	* tests/syslogd.sh (USER): New variable.
	<verbose mode>: Add a stanza to the configuration file
	for passing all messages also to user $USER.

2012-10-18  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Properly close a user session.

	* ftpd/ftpd.c (dologout): Call end_login().
	* ftpd/pam.c (pam_doit): Call finishing pam_end()
	only if ERROR is not PAM_SUCCESS.

2012-10-18  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Security audit.

	* ftpd/auth.c (auth_user): Declare ERR at top.
	Replace most `return` inside switch block by `break`.
	Put call checkuser(PATH_FTPCHROOT) at function end
	whenever authentication succeeded, thus making it
	reachable for all authentication modes.

	* ftpd/ftpd.c: Include <xgetcwd.h>.
	(curdir, makedir, removedir): Remove prototype xgetcwd().
	(main): Call localhost() before sending welcome msg.
	(complete_login): New variable CWD.  Set EUID before
	calling chdir() for real users.  Call xgetcwd() and
	set HOME in environment for all kinds of user.
	(end_login): Reset `pcred->logged_in`.
	(getdatasock, passive): Call _exit() at failure of
	seteuid(cred.uid).

	ftp: Self documentating code.

	* ftp/ftp.c (getreply): Make ARPA's reply codes
	explicit.  Let N carry these codes, not an ASCII
	character value.

2012-10-11  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Server and realm detection.

	* libinetutils/shishi.c (get_auth): Parse server
	name input using shishi_parse_name(), but only if
	`srvname' has some content.  Retrieve default
	realm by calling shishi_realm_default(), and
	pass it to shishi_hostkeys_for_serverrealm().

	rlogin: Handle urgent data for non-encrypted Kerberos.
	This enables window sizing and buffer flushing.

	* src/rlogin.c (main): Set sigaction flag SA_RESTART
	when installing SIGURG and SIGUSR1; a portability fix.
	(oob) [SHISHI]: Assign urgent data `rcvbuf[4]' to MARK
	whenever `use_kerberos' is true.  This is then compared
	to different TIOCPKT_*.

	* src/rlogind.c (fatal): Replace an empty format
	input by the string "unspecified error", in order
	to protect against segfaults in vsnprintf().

2012-10-11  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogin: Read urgent data also when Kerberos has
	been disabled.  Needed for window sizing.

	* src/rlogin.c (sigwinch): Call get_window_size()
	with STDIN_FILENO as file descriptor.
	(oob) [SHISHI]: Receive MSG_OOB data whenever
	`!use_kerberos' is true.

2012-10-11  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rlogind.c (rlogin_daemon)
	[(KERBEROS || SHISHI) && ENCRYPTION]: Protect
	encrypted port pre-selection.
	[(KERBEROS || SHISHI) && !ENCRYPTION]: Protect
	standard Kerberos port pre-selection.

2012-10-11  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Set local name correctly for libshishi.
	Improve selectivity of intended server host key.

	* libtelnet/shishi.h (krb5shishi_is_auth): Replace call
	to shishi_hostkeys_for_server(), with a variant where
	default realm is made explicit with shishi_realm_default().

	* telnetd/telnetd.c (telnetd_setup)
	[AUTHENTICATION || ENCRYPTION]: Exchange places of
	`local_hostname' and `remote_hostname' in call to
	auth_encrypt_init().

	rlogind: Enable Kerberised daemon mode listener.

	* src/rlogind.c (DEFPORT_KLOGIN, DEFPORT_EKLOGIN): New macros.
	(rlogin_daemon): New variable SERVICE.  Use service port
	`login', `klogin', or `eklogin' according to set options.

	* src/rlogin.c (main) <rcmd failure>: Print a NL, finishing
	an unfinished error massage emitted by Glibc.

2012-10-08  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Support libwrap in daemon mode.

	* configure.ac <rlogind summary>: Print $LIBWRAP.
	* src/Makefile.am (rlogind_LDADD): Add $(LIBWRAP).
	* src/rlogind.c [HAVE_TCPD_H]: Include <tcpd.h>.
	[WITH_WRAP && !HAVE_DECL_HOSTS_CTL]: New prototype
	for missing hosts_ctl() declaration.
	(allow_severity, deny_severity) [WITH_WRAP]:
	New variables.
	(check_host) [WITH_WRAP]: New function.
	(rlogin_daemon) [WITH_WRAP]: Call check_host().
	(protocol) [!SHISHI]: Trivial use of AP.

	* ftpd/server_mode.c (check_host): Use severity
	`deny_severity' to syslog() at rejects.

2012-10-05  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet: Reliability fix caused by OpenSolaris,
	where SIGWINCH regularly got lost.

	* telnet/sys_bsd.c (sys_telnet_init): New variable SA.
	[SIGWINCH]: Install handler with sigaction().
	[SIGTSTP]: Likewise.
	[SIGINFO]: Likewise.

2012-10-04  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/libping.c (ping_set_dest) [HAVE_DECL_GETADDRINFO]:
	Alternative and preferred resolver using getaddrinfo().
	* ping/ping6.c (print_echo) [NI_IDN]: Add flag NI_IDN
	to getnameinfo() if option OPT_NUMERIC is not set.
	(ping_set_dest) [AI_IDN]: Add flag AI_IDN to HINTS.
	* ping/ping_common.c (ipaddr2str) [NI_IDN]: Add flag
	NI_IDN to getnameinfo().
	* src/traceroute.c (main) [AI_IDN]: Add flag AI_IDN to HINTS.
	[AI_IDN && AI_CANONIDN]: Add flag AI_CANONIDN to HINTS.

2012-10-02  Mats Erik Andersson  <gnu@gisladisker.se>

	* libinetutils/logwtmp.c [HAVE_STRUCT_UTMPX_UT_SYSLEN]:
	Take care of overlong host name when storing length
	in `ut.ut_syslen'.
	* libinetutils/logwtmpko.c, libinetutils/utmp_init.c:
	Likewise.

	* ftpd/popen.c, libinetutils/daemon.c,
	libinetutils/ttymsg.c, src/inetd.c, src/rshd.c,
	src/syslogd.c, telnet/commands.c: Call _exit()
	with EXIT_SUCCESS or EXIT_FAILURE, not 0 or 1.

2012-10-02  Mats Erik Andersson  <gnu@gisladisker.se>

	uucpd: Upgrade, including IPv6.

	* src/uucpd.c: Include <unused-parameter.h>.
	(hisctladdr, hisaddrlen): Remove variables.
	(uucico_location, Logname): New variables.
	(nenv): Add `Logname'.
	(argp_options): New variable.
	(parse_opt): New function.
	(argp): Add `argp_options' and `parse_opt'.
	(main): New variables HISCTLADDR, HISADDRLEN.
	(readline): Read from STDIN_FILENO.
	(doit): New signature `(struct sockaddr *, socklen_t)'.
	Remove truncation of USER.  Ask password for non-existent
	user, then fail.  Check user shell after password check,
	and compare to `uucico_location'.  Set LOGNAME in `nenv'
	for portability.  Call execl() with `uucico_location'.
	[HAVE_INITGROUPS]: Guard call to initgroups().
	(dologin): New signature
	`(struct passwd *, struct sockaddr *, socklen_t)'
	[HAVE_DECL_GETNAMEINFO]: Use getnameinfo() as resolver.
	[!HAVE_DECL_GETNAMEINFO]: Extend code with gethostbyaddr()
	to accept IPv6.  Replace inet_ntoa() by inet_ntop().
	(dologin) [HAVE_STRUCT_UTMPX_UT_SYSLEN]: Correctly set
	the used length of `ut.ut_host'.

2012-10-01  Mats Erik Andersson  <gnu@gisladisker.se>

	uucpd: Restore inetd code.

	Code necessary for inetd mode was accidentally
	removed on 2009-10-26.  Replace daemon mode code.
	* src/uucpd.c: Include <grp.h>.
	(hisaddrlen): Type is socklen_t.
	(myctladdr): Removed.
	(main): Remove variables S and SP.  Remove broken,
	partial code for daemon mode operation.  New calls
	to dup2(), getpeername(), doit(), and dologout().
	(doit): New calls to initgroups() and execl().

2012-09-28  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Daemon mode update.

	Reinstalling an identical signal action was needed
	on legacy systems.  Made obsolete by setsig().

	* src/rlogind.c (rlogind_sigchld): Remove call to
	setsig() for reactivation.  Use _GL_UNUSED_PARAMETER.

	Make daemon mode able to do IPv4 and IPv6, but only
	if getaddrinfo() is available.  Use two sockets for
	better portability.

	* src/rlogind.c (use_af): New variable.
	(options): New switches `-4/--ipv4' and `-6/--ipv6'.
	Expose optional argument for `-d/--daemon'.
	(parse_opt) <'4', '6'>: New cases.
	(find_listenfd): New function, generating sockets
	for rlogin_daemon().
	(rlogin_daemon): Use select() on at most two
	listening sockets.  Let `use_af' determine IPv4
	and/or IPv6.  New variables LISTENFD[2], NUMFD,
	MAXFD, LFDSET.

2012-09-27  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogin, rlogind: Signal dispositions.
	Use a more portable signal API.

	* libinetutils/libinetutils.h: Include <signal.h>.
	(setsig): New prototype, exposing old function.

	rlogin: Old signal API is inconsistent, even between
	libc6 versions.

	* src/rlogin.c (setsig): Remove external prototype.
	(main): New variable SA.  Use STDIN_FILENO, not 0.
	Call sigaction() with SIGURG, SIGUSR1, not setsig().
	Pass `&osmask' to doit(), needed for window sizing.
	(doit): Rename parameter as `osmask' for clarity.
	New variable SA.  Call sigaction for SIGINT, SIGCHLD.
	(setsignal): Fully reworked implementation.
	(writeroob): New variable SA.  Use sigaction().
	(oob): Use STDOUT_FILENO, not 1.  Offer ioctl TCIOFLUSH
	for systems lacking TIOCFLUSH.
	(reader): Rename parameter as `osmask'.  New variable SA.
	Assume that contemporary getpid() returns positive values.
	Call fcntl(F_SETOWN) as early as possible, and set owner
	using PID, not PPID.  Use sigaction() for SIGTTOU, SIGURG.
	(lostpeer): Use input parameter in setsig().
	(copytochild): Likewise for kill().

	* src/rlogind.c (rlogind_sigchld): Rename parameter.
	Replace signal() by setsig().
	(main, rlogin_daemon, rlogind_mainloop, protocol):
	Replace signal().

2012-09-25  Mats Erik Andersson  <gnu@gisladisker.se>

	Disable incompatible utmpx implementation.

	* configure.ac <*-freebsd9* || *-freebsd10*>:
	Disable building of ftpd, rlogind, syslogd,
	talkd, telnetd, and uucpd.

2012-09-19  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac <libwrap check>: Call AC_CHECK_DECLS
	with hosts_ctl.
	* ftpd/server_mode.c (hosts_ctl)
	[WITH_WRAP && !HAVE_DECL_HOSTS_CTL]: Add external
	prototype whenever undeclared.

	* ftpd/ftpd.c (complete_login): Cast pid_t as int
	in formatted print.
	* src/inetd.c (run_service, readchild, print_service)
	(main): Likewise.
	* src/syslogd.c (main): Likewise.
	* src/uucpd.c (dologout, dologin): Likewise.
	(dologout) [PATH_LASTLOG && HAVE_STRUCT_LASTLOG]:
	Declare F conditionally.

	* ifconfig/changeif.c: Access `HAVE_DECL_*' using `#if',
	not using `#ifdef' constructs.
	* libinetutils/kcmd.c, libinetutils/localhost.c: Likewise.
	* src/rlogind.c, src/rshd.c: Likewise.

2012-09-17  Mats Erik Andersson  <gnu@gisladisker.se>

	talk: Delay start of curses interface until
	the other party has established a connection.

	* talk/init_disp.c (init_display): Remove assignment
	of `current_state'.
	* talk/io.h (p_error): Execute curses function calls
	only if `curses_initialized' is true.  Otherwise call
	perror().
	(message): Likewise, placing a call to printf() for
	non-empty message strings only.
	* talk/talk.c (main): Delay call to init_display() until
	after end_msgs().  New messages set in `current_state'.

	talkd: Enforce access rights on `~/.talkrc'.

	* talkd/acl.c (read_acl): Site-wide file uses `system > 0'.
	New code block for the parameter case `system < 0', pushing
	a single, deny-all rule.
	(open_users_acl): New variables LEVEL, RC and ST.  Check
	properties of ACL file using stat().  Enforce a deny rule
	if they are too permissive.
	* doc/inetutils.texi <talkd invocation>: Updated.

2012-09-15  Mats Erik Andersson  <gnu@gisladisker.se>

	Mark unused parameters as such.

	* ftp/cmds.c (setbinary, setascii, settenex, setftmode)
	(setform, setstruct, status, setbell, settrace, sethash)
	(setverbose, setipany, setipv4, setipv6, setepsv4, setport)
	(setprompt, setglob, shell, pwd, quit, disconnect, proxabort)
	(setcase, setcr, setpassive, setsunique, setrunique, cdup)
	(syst): Add _GL_UNUSED_PARAMETER.
	* ftp/ftp.c (abortsend, abortrecv, psabort, abortpt, reset):
	Likewise.
	* ftp/main.c (parse_opt): Likewise.

	Header file and parse_opt() are common treatments.

	* src/logger.c: Include <unused-parameter.h>.
	(parse_opt): Add _GL_UNUSED_PARAMETER.
	* src/rcp.c: Likewise.
	(lostconn): Likewise
	* src/rexecd.c: Likewise.
	* src/rlogind.c (parse_opt): Likewise
	(do_shishi_login): Remove variable IV.
	* src/rshd.c: Likewise.

	* telnet/commands.c: Include <unused-parameter.h>.
	(shell): Add _GL_UNUSED_PARAMETER.
	* telnet/main.c: Likewise.
	(parse_opt): Likewise.
	* telnet/sys_bsd.c: Likewise.
	(deadpeer, intr, intr2, susp, sendwin): Likewise.

	* tests/localhost.c: Likewise.
	(main): Likewise.

	* whois/whois.c: Likewise.
	(ripe_argp_parser, gwhois_argp_parser): Likewise.

2012-09-15  Mats Erik Andersson  <gnu@gisladisker.se>

	Add missing values in option lists, and in similar
	lists.  All were detected as compiler warnings.

	* ftp/cmds.c (types): Add missing values.
	* ftp/cmdtab.c (cmdtab): Likewise.
	* ftp/main.c (argp, argp_options): Likewise.

	* src/dnsdomainname.c (argp): Likewise.
	* src/hostname.c (argp, argp_options): Likewise.
	* src/logger.c (arpg): Likewise
	(argp_options): Likewise.  New macro GRP.

	Collect Kerberos options into a group where relevant.

	* src/rcp.c (options): Add missing values.
	* src/rexec.c (argp): Likewise
	(options): Likewise.  New macro GRP.
	* src/rexecd.c (options): Likewise
	* src/rlogin.c (argp, argp_options): Likewise.
	* src/rlogind.c (argp): Likewise.
	(options): Likewise.  New macro GRP.
	* src/rsh.c (argp, options): Likewise
	* src/rshd.c (argp, options): Likewise

	* telnet/commands.c (Togglelist, Setlist, ModeList)
	(SlcList, EnvList, AuthList, EncryptList, cmdtab)
	(cmdtab2): Add missing values.
	* telnet/main.c (argp, argp_options): Likewise.
	* telnet/network.c (timeout): Likewise.
	* telnet/sys_bsd.c (TimeValue): Likewise.

	* whois/whois.c (gwhois_argp, gwhois_argp_children)
	(ripe_argp): Add missing values.
	(gwhois_arpg_options, ripe_argp_options): Likewise.
	New macro GRP.

2012-09-14  Mats Erik Andersson  <gnu@gisladisker.se>

	libinetutils: Compiler warnings.

	* libinetutils/argcv.c (argcv_get): Cast element as int.
	* libinetutils/cleansess.c [HAVE_UTMP_H && HAVE_LIBUTIL_H]:
	Include <libutil.h>.
	* libinetutils/daemon.c: Include <unused-parameter.h>.
	(waitdaemon_timeout): Add _GL_UNUSED_PARAMETER.
	* libinetutils/kcmd.c (kcmd): Cast strlen() as ssize_t.
	Add parantheses in logical expression.
	[SHISHI]: Declare SIN_LEN as socklen_t.  Trivial use of
	parameter service.
	* libinetutils/logwtmp.c (OUR_WTMP): New macro.
	(_logwtmp): Call open() with OUR_WTMP.
	* libinetutils/shishi.c (shishi_auth): Cast sizeof() as
	ssize_t.  Cast sname as `char *' in assignment of P.
	(senderror): Remove function, keeping as comment.
	(gat_auth): Remove variables I and AUTH_CORRECT.  Cast
	size expression as int.
	* libinetutils/utmp_init.c [HAVE_UTMP_H && HAVE_LIBUTIL_H]:
	Include <libutil.h>.
	(utmp_init) [!HAVE_UTMPX_H && !HAVE_PUTUTLINE && HAVE_LOGIN]:
	Trivially use parameter id.
	* libinetutils/utmp_logout.c [HAVE_UTMP_H && HAVE_LIBUTIL_H]:
	Include <libutil.h>.
	(utmp_logout) [!HAVE_UTMPX_H && HAVE_PUTUTLINE]: Protect
	declaration of UT.

2012-09-14  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: More compiler warnings.

	* am/libcurses.m4 (IU_LIB_TERMCAP): Use AC_LINK_IFELSE
	instead of AC_CHECK_DECLS to find declaration of tgetent.
	* telnetd/term.c (copy_termbuf) [TIOCPKT_IOCTL]: Declare
	LEN as size_t.  Increment LEN in loop.
	* telnetd/utility.c (printdata): Cast *PTR as int.

2012-09-14  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Compiler warnings.

	* telnetd/pty.c (startslave) [!AUTHENTICATION]:
	Trivially use autoname.
	(start_login): Trivially use host, autologin, name.
	* telnetd/telnetd.c: Include <unused-parameter.h>
	(argp_options): Add missing fields.  Collect options
	for authentication into a separate group.  New macro GRID.
	(parse_opt): Add _GL_UNUSED_PARAMETER.
	(argp): Add missing fields.
	* telnetd/term.c (tty_setlinemode) [!TIOCEXT && !EXTPROC]:
	Trivially use `on'.
	* telnetd/utility.c (pty_output_datalen): Cast integer
	difference as size_t.
	(pty_get_char): Likewise.
	(stilloob): Add missing field in TIMEOUT.
	(getterminaltype) [!AUTHENTICATION]: Trivially use user_name.
	(printsub) [AUTHENTICATION && ENCRYPTION]: Declare BUF as
	array of unsigned char.
	<case TELQUAL_NAME>: Cast array reference as `char *'
	inside call to debug_output_datalen.
	(_var_long_name): Trivially use start and length.

2012-09-13  Mats Erik Andersson  <gnu@gisladisker.se>

	Use libdl only when needed, i.e., with libpam.

	* configure.ac (LIBDL): New variable.  Publish it
	using AC_SUBST.  When calling AC_CHECK_LIB for
	dlopen in libdl, add the action `LIBDL=-ldl' which
	avoids a global change of LIBS.
	* ftpd/Makefile.am (LDADD): Add $(LIBDL).
	* src/Makefile.am (rexecd_LDADD, rshd_LDADD): Likewise.

	Link libnsl, libresolv or libsocket only if needed.

	* configure.ac: Use AC_SEARCH_LIBS instead of AC_CHECK_LIB
	when sensing for libnsl, libresolv, and libsocket.

	Refine libidn detection and specification.

	* configure.ac <--with-libidn-prefix>: New option.
	<libidn detection>: Call AC_MSG_CHECKING after other
	checks, and call AC_MSG_RESULT with correct variable.
	Preload INCIDN and LIBIDN from $with_libidn_prefix.
	In call to AC_CHECKLIB(idn, ...), use preset LIBIDN.
	In summary message, print `-lidn' instead of LIBIDN.

2012-09-13  Mats Erik Andersson  <gnu@gisladisker.se>

	* ifconfig/changeif.c (herror prototype)
	[!HAVE_DECL_GETADDRINFO]: Conditional use of prototype.
	(set_address) [HAVE_DECL_GETADDRINFO]: New variables RC,
	ADDR, HINTS, AI, and RES.  New, alternate code for address
	resolution using getaddrinfo() and getnameinfo().

	* libinetutils/localhost.c (localhost) [HAVE_DECL_GETADDRINFO]:
	New variables RC, HINTS, RES, and FQDN.  New, alternate code
	for address resolution.

	* tests/Makefile.am (TESTS): Add `localhost' as test case.

2012-09-11  Mats Erik Andersson  <gnu@gisladisker.se>

	* ftpd/ftpcmd.y (cmd): Add parantheses to separate
	subordinate && from ||.
	* ftpd/ftpd.c (off_to_str): Cast OFF as long.
	(options): Fill in missing fields.
	(main) [!HAVE_INITSETPROCTITLE]: Trivially use envp.
	* ftpd/pam.c: Include <unused-parameter.h>.
	(pam_pass): Cast passwd as `char *'.
	(pam_end_login): Add _GL_UNUSED_PARAMETER.
	* ftpd/popen.c (ls_main prototype) [WITH_LIBLS]:
	Enclose within conditional WITH_LIBLS.
	* ftpd/server_mode.c (server_mode) [HAVE_FORK]:
	Trivially use argv.
	* libls/fts.c: Include <unused-parameter.h>.
	(fts_set): Add _GL_UNUSED_PARAMETER.
	* libls/ls.c (display): Cast MAXSIZE as off_t.

2012-09-10  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/ping.c (ping_finish): Replace format string "%ld"
	by "%zu" for counter status.
	* ping/ping6.c (ping_finish): Likewise.
	* ping/ping_common.h (struct ping_data): Set type size_t
	on fields ping_num_xmit, ping_num_recv and ping_num_rept.
	* ping/ping_router.c: Include <unused-parameter.h>.
	(ping_router): Add _GL_UNUSED_PARAMETER.

2012-09-07  Mats Erik Andersson  <gnu@gisladisker.se>

	talk, talkd: Portability issue.

	* talk/look_up.c (check_local): New variable ADDR.
	Call connect() with ADDR, built from `rp->addr'.

	* talkd/talkd.c (talkd_run): New variable CTL_ADDR.
	Call sendto() with CTL_ADDR, built from `msg.ctl_addr'.

2012-09-07  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Support IDN named hosts.

	* configure.ac: Check traceroute_BUILD and LIBIDN in
	summary message.
	* src/Makefile.am (traceroute_LDADD): Add $(LIBIDN).
	(INCLUDES): Add $(INCIDN).

	* src/traceroute.c: Include <unused_parameter.h>
	[HAVE_LOCALE_H]: Include <locale.h>.
	[HAVE_IDNA_H]: Include <idna.h>.
	(argp_options, argp): Add missing fields.
	(main): New variables RC and RHOST.  Let getaddrinfo()
	resolve RHOST.
	[HAVE_SETLOCALE]: Call setlocale().
	[HAVE_IDN]: Call idna_to_ascii_lz().
	(do_try): Add _GL_UNUSED_PARAMETER.

	ping, ping6: Use setlocale() independently of IDN.
	Attend to some compiler warnings.

	* ping/libping.c: Remove inclusion of <locale.h>.
	(ping_set_dest): Remove call to setlocale().
	* ping/ping.c: Include <unused-parameter.h>.
	[HAVE_LOCALE_H]: Include <locale.h>.
	(argp_options, argp): Add missing fields.
	(main) [HAVE_SETLOCALE]: Call setlocale().
	(sig_int): Add _GL_UNUSED_PARAMETER.
	(ping_run): Declare NRESP and I as size_t.
	(send_echo): Declare OFF as size_t.
	* ping/ping6.c: Include <unused-parameter.h>.
	(argp_options, argp): Add missing fields.
	(main) [HAVE_SETLOCALE]: Call setlocale().
	(sig_int, print_echo, ping_init): Add _GL_UNUSED_PARAMETER.
	(ping_run): Declare NRESP size_t and I as `unsigned long'.
	(send_echo): Declare OFF as size_t.
	(ping_echo): Replace format string "%d" by "%zd".
	(ping_set_dest): Remove call setlocale().
	* ping/ping_address.c: Include <unused-address.h>.
	(print_address): Add _GL_UNUSED_PARAMETER.
	* ping/ping_common.c: Include <unused-address.h>.
	(init_data_buffer): Use `size_t len' as second parameter.
	Declare I as size_t.
	(decode_pattern): Add _GL_UNUSED_PARAMETER.
	* ping/ping_common.h (init_data_buffer): Update prototype.
	* ping/ping_echo.c: Include <unused-parameter.h>.
	(ping_echo): Replace format string "%d" by "%zd".
	(print_echo, print_ip_data): Add _GL_UNUSED_PARAMETER.
	(print_icmp_code): Declare HLEN as size_t.
	(print_ip_header): Declare J as size_t.
	(icmp_diag): Add missing fields.
	* ping/ping_timestamp.c: Include <unused-parameter.h>.
	(print_timestamp): Add _GL_UNUSED_PARAMETER.

	inetd: Attend to compiler warnings.

	* src/inetd.c (toomany): Declare as unsigned.
	(argp_options, argp): Add missing fields.
	(struct servtab): Declare se_count as unsigned.
	(enter): Declare I as size_t.
	(parse_opt, echo_dg, discard_dg, chargen_dg)
	(machtime_stream, machtime_dg, daytime_stream)
	(daytime_dg): Add _GL_UNUSED_PARAMETER.

2012-09-07  Mats Erik Andersson  <gnu@gisladisker.se>

	talk, talkd: Compiler warnings.

	* talk/ctl.c (daemon_addr, ctl_addr, my_addr): Remove
	initial values, since they are incomplete.
	(open_sockt): Set `my_addr.sin_family' and `my_addr.sin_len'.
	(open_ctl): Likewise with `ctl_addr'.
	* talk/ctl_transact.c (ctl_transact): Likewise with
	`daemon_addr'.  Call htons() with `daemon_port'.
	* talk/get_addrs.c (daemon_port): Use in host byte order,
	calling ntohs() on `sp->s_port'.
	* talk/invite.c: Include <unused-parameter.h>.
	(re_invite): Add _GL_UNUSED_PARAMETER. Initialise `daemon_addr'.
	* talk/msgs.c: Include <unused-parameter.h>.
	(disp_msg): Add _GL_UNUSED_PARAMETER.
	* talk/talk.c (argp): Fill in missing fields.
	* talkd/talkd.c (argp_options, argp): Likewise.
	(parse_opt): Add _GL_UNUSED_PARAMETER.

2012-09-07  Mats Erik Andersson  <gnu@gisladisker.se>

	syslogd, tftp, tftpd, uucpd: Compiler warnings.

	* src/syslogd.c (argp_options, parse_opt): Fill in
	non-initialised fields.
	* src/tftp.c: Include <unused-parameter.h>.
	(cmdtab, argp_options, parse_opt): Fill in missing fields.
	(setbinary, setascii, status, intr, quit, settrace)
	(setverbose, timer): Add _GL_UNUSED_PARAMETER.
	* src/tftpd.c: Include <unused-parameter.h>.
	(options, argp, formats): Fill in missing fields.
	(parse_opt, timeout, justquit): Add _GL_UNUSED_PARAMETER.
	* src/uucpd.c (arpg): Fill in missing fields.

	Upgrade TFTP test.

	* tests/tftp.sh: Make mode `binary' explicit.  Add a case
	with `ascii' transmission.
	(ASCIIFILE, type): New variables.

2012-09-07  Mats Erik Andersson  <gnu@gisladisker.se>

	talkd: Full ACL capability.

	* talkd/acl.c (struct acl): New member `system'.
	(read_acl): Rename parameter `silent' as `system',
	used to distinguish site-wide and user setting.
	If `system' is true and file is set, but non-readable,
	then write a syslog message and abort execution.
	(open_user_acl): Call read_acl() with `system = 0'.
	(acl_match): New variables SYSTEM_ACTION, USER_ACTION,
	and FOUND_USER_ACL.  Check site-wide ACL against
	`msg->r_name' and user ACL against `msg->l_name'.
	Travers the full list of rules for applicable actions.
	Implement overriding mechanism depending on policy
	for the returned value.
	* talkd/intalkd.h (strict_policy): New variable.
	* talkd/talkd.c (strict_policy): Likewise.
	(arpg_options): New option `-S/--strict-policy'.
	(parse_opt) <'S'>: New case.
	(main): Call read_acl() with `system = 1'.
	* doc/inetutils.texi <talkd invocation>: Updated.

2012-09-06  Mats Erik Andersson  <gnu@gisladisker.se>

	talkd: Partial activation of ACL features.
	Upstream Gnulib has repaired read_utmp() call.

	* talkd/acl.c (ACT_ALLOW, ACT_DENY): Removed macros.
	(read_acl): Add parameter `int silent'.  Report missing
	file only if `!silent'.  Partially decrease syslog severity.
	New return values ACL_ALLOW and ACL_DENY.
	(open_users_acl): Call read_acl() with silent flag, a file
	is not mandatory for users.
	(acl_match): Return ACL_ALLOW as default result.
	* talkd/announce.c (print_msg, announce): Lower severity
	LOG_CRIT to LOG_ERR.
	* talkd/intalkd.h (ACL_ALLOW, ACL_DENY): New macros.
	(logging): New variable.
	(read_acl): Update prototype.
	* talkd/process.c (process_request): Delay ACL matching
	until protocol and address have been checked.  Send answer
	FAILED in reply whenever acl_match() returns ACL_DENY.
	Give syslog messages lower severity and condition on
	`logging || debug'.
	* talkd/table.c (insert_table): Change LOG_CRIT to LOG_ERR.
	* talkd/talkd.c (logging): New variable.
	(doc): Mention service `ntalk'.
	(argp_options): New option `-l/--logging'.
	(parse_opt) <'l'>: New case.
	(main): Call read_acl() with non-silent flag.  Explicitly
	use STDIN_FILENO as descriptor for talkd_run().
	(alarm_handler): New variable OERRNO. Protect and recover
	errno across handler actions.
	(talkd_run): Commit syslog messages for `logging || debug'.
	Lower severity to LOG_NOTICE.

	* doc/inetutils.texi <talkd invokation>: Expose the
	distinguishing features of the present implementation.

	* talk/init_disp.c (init_display): Catch SIGQUIT.

	* configure.ac: Include <sys/socket.h> when checking
	for `sockaddr_in6.sin6_len' and `sockaddr_storage.ss_len'.
	Check talk_BUILD and LIBCURSES in summary message.

2012-08-31  Mats Erik Andersson  <gnu@gisladisker.se>

	ping, ping6: Support IDN named hosts.

	* configure.ac: New checks for `locale.h' and setlocale().
	(--with-idn): New setting.
	(INCIDN, LIBIDN): New variables.
	* ping/Makefile.am (ping_LDADD): Add $(LIBIDN).
	(ping6_LDADD): Likewise.
	(INCLUDES): Add $(INCIDN).
	* ping/libping.c [HAVE_LOCALE_H]: Include <locale.h>.
	[HAVE_IDNA_H]: Include <idna.h>.
	(ping_set_dest) [HAVE_IDN]: New variables P and RC.
	Resolve HOST by a call to idna_to_ascii_lz().
	[HAVE_IDN && HAVE_SETLOCALE]: Call setlocale().
	* ping/ping6.c [HAVE_LOCALE_H]: Include <locale.h>.
	[HAVE_IDNA_H]: Include <idna.h>.
	(ping_set_dest): New variable RHOST used in getaddrinfo().
	[!HAVE_IDN]: Make RHOST a reference to HOST.
	[HAVE_IDN]: Resolve HOST by a call to idna_to_ascii_lz().
	[HAVE_IDN && HAVE_SETLOCALE]: Call setlocale().

2012-08-30  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac: Add a final AC_MSG_NOTICE, containing a summary
	of established compilation tasks.
	(KERBEROS_VERSION): Assign values `krb4' and `krb5'.  Change test
	values in case patterns.
	(enable_authentication, enable_encryption) [-n KERBEROS_VERSION]:
	Assign `yes' as default value in two separate tests.
	<KERBEROS_VERSION == Shishi>: Have `--without-shishi' bypass
	the feature checks for libshishi.  Set KERBEROS_VERSION empty
	when AC_CHECK_LIB fails.  Empty INCAUTH, LIBAUTH, and also
	KERBEROS_VERSION when AC_CHECK_HEADER fails.

	* tests/Makefile.am (bin_PROGRAMS): Remove variable.
	(check_PROGRAMS): New variable replaces bin_PROGRAMS, not added
	to variable TESTS.

	* tests/syslogd.sh (silence): New variable, decreases verbosity.

2012-08-24  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/tftp.sh (silence, bucket): New variables.
	Make the script silent in standard case.

2012-08-24  Petr Malát  <oss@malat.biz>  (tiny change)

	* telnetd/utility.c (terminaltypeok): Use 2kb buffer, as suggested
	by GNU termcap manual.

2012-08-24  Petr Malát  <oss@malat.biz>  (tiny change)

	* telnetd/utility.c (io_drain): New variable rfds.
	(io_drain): Use select to wait for data to be available.

2012-08-22  Petr Malát  <oss@malat.biz>  (tiny change)

	* telnet/telnet.c (options, do_dont_resp, will_wont_resp):
	Initialize variables.
	(init_telnet): Remove partial initialization from here.

2012-08-22  Simon Josefsson  <simon@josefsson.org>

	* bootstrap: Updated from gnulib.

2012-08-20  Mats Erik Andersson  <gnu@gisladisker.se>

	Server realm pairing: Let server name determine
	realm to be contacted, as per library configuration.

	* libinetutils/shishi.c (shishi_auth): Whenever realm
	is not explicit, call shishi_realm_for_server() to get
	a usable realm; pass on to shishi_realm_default_set().
	* libtelnet/shishi.c (krb5shishi_send): Likewise.

2012-08-17  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet: Selectable principal name.

	* libtelnet/shishi.c (krb5shishi_send): Add a prefix
	`host/' to RemoteHostName only if a prefix is missing.
	* telnet/commands.c (tn) [AUTHENTICATION || ENCRYPTION]:
	Strip off any prefix from HOSTP before resolving address.
	[IPV6]: Improve error message at failed resolution.

2012-08-16  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Configurable principal name.

	* libtelnet/misc.c (ServerPrincipal): New variable.
	(auth_encrypt_init): Add `char *principal' to signature.
	Assign value to ServerPrincipal.
	* libtelnet/misc.h (ServerPrincipal): New external variable.
	* libtelnet/misc-proto.h (auth_encrypt_init): Updated.
	* libtelnet/shishi.c: Prune newlines in error messages.
	(krb5shishi_is_auth): New variable REALM.  Delay shishi_ap()
	and shishi_ap_req_der_set() until after complete setup.
	Extract server name and realm from ServerPrincipal and
	override defaults accordingly.  Use variant calls to access
	realm also, shishi_hostkeys_for_serverrealm() and
	shishi_hostkeys_for_localservicerealm().

	* telnet/telnet.c (telnet): Call auth_encrypt_init()
	with `principal = NULL'.
	* telnetd/telnetd.c (principal) [AUTHENTICATION || ENCRYPTION]:
	New variable.
	(argp_options) [AUTHENTICATION || ENCRYPTION]: New option
	`-S/--server-principal'.
	(parse_opt) [AUTHENTICATION || ENCRYPTION] <'S'>: New case.
	(telnetd_setup) [AUTHENTICATION || ENCRYPTION]: Pass
	`principal' in call to auth_encrypt_init().

2012-08-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rcp.c (main) [KERBEROS || SHISHI]: Add `!use_kerberos'
	when checking for effective root UID.
	* src/rlogin.c (main): Likewise.
	* src/rsh.c (main): Likewise.

2012-08-15  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp, rlogin, rsh: Host names with instances.

	* libinetutils/kcmd.c (kcmd) [SHISHI]: New variable HOST.
	Whenever `*ahost' contains a slash, separate the true host
	name into HOST.  Use HOST in resolver, and reconstruct
	Kerberos principal as `*ahost' afterwards.
	* libinetutils/shishi.c (shishi_auth): New variable P.
	Check `sname' for a slash in principal name, and construct
	TMPSERVER with prefix "host/" if needed.
	* src/rcp.c (kerberos) <no Kerberos service>: New variable P.
	Strip prefix like `host/' from HOST.
	* src/rlogin.c (main): Likewise.
	* src/rsh.c (main): Likewise.

	rlogind, rshd: Qualified Kerberos server names.

	* libinetutils/shishi.c (get_auth): New variables SERVER
	and REALM.  Decompose `srvname' using shishi_parse_name().
	Construct SERVERNAME with prefix "host/" if needed.  Use
	shishi_realm_default_set() to set realm if present.
	* src/rlogind.c (options) [KERBEROS || SHISHI]: Rename
	long option name `--servername' as `--server-principal'.
	* src/rshd.c (options) [KERBEROS || SHISHI]: Likewise.

	* src/rlogin.c (main) <try_connect> [KERBEROS]: Declare HP
	and use gethostbyname() only for KERBEROS.
	* src/rsh.c (main) [KERBEROS]: Likewise.

	rcp, rlogin, rsh: Aborting Kerberized services.

	* src/rcp.c (kerberos) [KERBEROS || SHISHI]: Fail with error
	if Kerberos authentication fails.  Degrade to plain service
	only on ECONNREFUSED.  Resolve service `shell/tcp' only in
	this latter case.
	* src/rlogin.c (main) [KERBEROS || SHISHI]: Likewise.
	* src/rsh.c (main) [KERBEROS || SHISHI]: Likewise.

	Error message handling.

	* libinetutils/krcmd.c (krcmd_mutual) [SHISHI]: Report
	errors using shishi_strerror().
	* libinetutils/shishi.c (shishi_auth) <failed verification>:
	Write a null character at the end of the received error
	message, not at buffer end.
	* src/rshd.c (doit) [SHISHI] <authentication failure>:
	Check `err_msg && *err_msg' before use in rshd_error().

	Conditionals for extra features.

	* src/rcp.c (family) [WITH_ORCMD_AF || WITH_RCMD_AF || SHISHI]:
	Add SHISHI to conditional.
	(options, parse_opt) [WITH_ORCMD_AF || WITH_RCMD_AF || SHISHI]:
	Add SHISHI as provider of `--ipv4' and `--ipv6'.
	* src/rlogin.c: Likewise.
	* src/rsh.c: Likewise.
	(options) [(KERBEROS || SHISHI) && ENCRYPTION]: Condition
	`-x/--encrypt' on ENCRYPTION.

2012-08-09  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/tftp.sh: Use evaluation `${VERBOSE:+-v}'
	to handle empty string uniformly.

2012-08-09  Mats Erik Andersson  <gnu@gisladisker.se>

	Make building successful on FreeBSD 9.0.

	* paths (PATH_UTMP): Add `/var/run/utx.active'.
	(PATH_WTMP): Add `/var/log/utx.log'.
	* src/Makefile.am (AM_CPPFLAGS): Add $(PATHDEF_UTMPX).
	* talkd/Makefile.am (AM_CPPFLAGS): Add $(PATHDEF_UTMP)
	and $(PATHDEF_UTMPX).

2012-08-08  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet: Support k5login authorization.

	* libtelnet/misc.c (UserNameRequested): Assign
	NULL, not naught.
	* libtelnet/auth.c (authenticated): Likewise.
	(authenticators) [SHISHI]: Remove two references
	to krb5shishi_cleanup.
	* libtelnet/shishi.c (krb5shishi_send): Check for
	non-empty UserNameRequested as the very first action.
	Add UserNameRequested to `HINT.client'.
	(krb5shishi_reply): Call shishi_done(), and assign NULL
	to `shishi_handle'.
	(krb5shishi_status): Remove variables CNAME, CNAMELEN.
	Replace call to shishi_encticketpart_client() with a call
	to shishi_authorized_p().
	(krb5shishi_is_auth): Check version of libshishi and call
	shishi_cfg_authorizationtype_set() "k5login basic".
	Replace a call to shishi_encticketpart_crealm() with a
	call to shishi_encticketpart_clientrealm().
	(krb5shishi_is): Remove debug print using puts().
	(krb5shishi_printsub): Likewise.

	rlogind, rshd: Support k5login authorization.

	* libinetutils/shishi.c (get_auth): Check version
	of libshishi and call shishi_cfg_authorizationtype_set()
	with "k5login basic".

2012-08-03  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind, rshd: Protocol exchange adherence.
	The implementations in both, with and without
	Kerberization, did not follow identical protocols.

	* libinetutils/kcmd.c (kcmd) [SHISHI]: Write remote user name
	first, then the local user name, falling back to remote name.
	* src/rlogind.c (do_shishi_login) [SHISHI]: Read local user
	name first, then remote name.
	* src/rshd.c (doit): Read `locuser' immediately before `command'.
	[!KERBEROS && !SHISHI]: Read `remuser' first.
	[KERBEROS || SHISHI]: Read `remuser' last.
	[SHISHI]: Insert `Kerberized' into syslog message only for active
	Kerberized connection.

	* src/rsh.c (options) [WITH_ORCMD_AF || WITH_RCMD_AF || SHISHI]:
	Add SHISHI as provider of `--ipv4' and `--ipv6'.

	* doc/inetutils.text: Updated.

2012-08-03  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac: Check whether `struct sockaddr_in6'
	contains sin6_len.  Correctly check for ut_addr_v6
	inside `struct utmpx'.
	* libinetutils/kcmd.c (kcmd) [SHISHI]: Condition on
	HAVE_STRUCT_SOCKADDR_STORAGE_SS_LEN for access to ss_len.
	(getport): Likewise.
	* ping/libping.c (ping_set_dest): Access sin_len
	conditioned on HAVE_STRUCT_SOCKADDR_IN_SIN_LEN.
	* src/rexec.c (do_rexec): Build INET6 structure
	guided by HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN.
	* src/tftp.c (resolve_name): Access ss_len based on
	HAVE_STRUCT_SOCKADDR_STORAGE_SS_LEN.
	* src/tftpd.c (main): Likewise.

2012-08-01  Mats Erik Andersson  <gnu@gisladisker.se>

	Better adaptions to different UTMP implementations.
	FreeBSD 9.0 has left most traditions behind.

	* configure.ac: Check for login, loginx, logoutx, logwtmp,
	and logwtmpx conditioned on libutil.  Ensure `LIBUTIL=-lutil'
	in cases where `$ac_cv_func_login_tty = yes' or
	`$ac_cv_have_decl_openpty = yes'.  Check for more fields in
	`struct utmp': ut_line, ut_session, ut_time, ut_addr_v6,
	and ut_name.  Check for `struct lastlogx' and field ll_ss.
	Add checks of `struct utmpx' for fields ut_user, ut_name,
	ut_id, ut_line, ut_pid, ut_type, ut_exit, ut_tv, ut_session,
	ut_syslen, ut_host, ut_ss, ut_addr_v6.  Check for pututline
	and pututxline.
	(UTMPX): Removed macro.

	* libinetutils/libinetutils.h (utmp_init): Update.
	* libinetutils/cleansess.c [HAVE_LOGOUT && HAVE_LOGWTMP]:
	Make the source build conditionally.
	* libinetutils/logwtmp.c: Prefer utmpx code if available.
	Conditionally use fields in `struct utmpx' or `struct utmp'.
	* libinetutils/logwtmpko.c (logwtmp)
	[HAVE_UPDWTMPX && !HAVE_LOGWTMP]: New condition on build,
	and migration to `struct utmpx'.
	* libinetutils/utmp_init.c: Add parameter `char *host'.
	Guard structure fields with conditionals.  Distinguish
	access methods on HAVE_PUTUTXLINE, HAVE_LOGINX, and
	HAVE_UPDWTMPX, HAVE_LOGWTMPX.  Similarly, test
	HAVE_PUTUTLINE, HAVE_LOGIN, HAVE_UPDWTMP, and HAVE_LOGWTMP.
	New calls to setutxent() or setutent().
	* libinetutils/utmp_logout.c: Essentially likewise.  Erase the
	fields ut_exit, ut_user, ut_name, and ut_host.
	[HAVE_LOGOUTX]: Protect call to logoutx()/logwtmpx().
	[HAVE_LOGOUT]: Likewise for logout()/logwtmp().

	* libls/print.c: Do not include <utmp.h>.

	* src/rlogind.c: Remove conditional on UTMPX and local
	prototypes for utmp_ptsid() and utmp_init().  Always use
	setup_utmp()
	(setup_utmp): New argument `host'.
	[!HAVE_LOGOUT && !HAVE_LOGWTMP]: Call utmp_logout().

	* src/uucpd.c [HAVE_UTMPX_H]: Include <utmpx.h>.
	(dologout) [HAVE_LOGWTMPX]: Call logwtmpx().
	[HAVE_LOGWTMP && !HAVE_LOGWTMP]: Call logwtmp().
	[HAVE_PUTUTXLINE && !HAVE_LOGWTMPX && !HAVE_LOGWTMP]:
	Manual setup for recent FreeBSD.
	(dologin): Likewise.

	* telnetd/pty.c: Always use setup_utmp().
	(setup_utmp): New argument `host'.

	FreeBSD 9.0 uses new paths.

	* paths (PATH_UTMPX): Add `/var/run/utx.active'.
	(PATH_WTMPX): Add `/var/run/utx.log'.
	(PATH_LASTLOG): Add `/var/run/utx.lastlogin'.

2012-07-29  Mats Erik Andersson  <gnu@gisladisker.se>

	Out-of-tree build with libshishi.

	* telnet/Makefile.am (INCLUDES): Add `-I$(top_srcdir)'.

	Obsolete source file.

	* libtelnet/Makefile.am (libtelnet_a_SOURCES): Remove
	reference to `getent.c'.

2012-07-27  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogin, rshd: Protocol coherence.

	* configure.ac: Check for `getpwuid_r'.
	* libinetutils/kcmd.c (kcmd) [SHISHI]: Transmit `locuser' if
	defined at all.  Set `errno' to ENOENT at protocol failure.
	* libinetutils/krcmd.c [SHISHI && HAVE_GETPWUID_R]: Include
	<stdlib.h>, <unistd.h>, and <pwd.h>.  New static variables
	`pwbuflen', `pwbuf', `pwstor', and `pwd'.
	(krcmd) [SHISHI && HAVE_GETPWUID_R]: Determine local user
	using getpwuid_r() and pass this on to kcmd().
	(krcmd_mutual) [SHISHI && HAVE_GETPWUID_R]: Likewise.

	* src/rlogin.c (main) <label try_connect>: New variable
	KRB_ERRNO, used to track error causes reliably.
	* src/rlogind.c: Include <stdarg.h>.
	(rlogind_error): New function, reusing code from fatal().
	(fatal): Altered as trivial wrapper around rlogind_error().
	(do_krb_login): Check `*err_msg' in detecting messages.
	(do_shishi_login): Read `ad->rusername' and `ad->lusername'
	in the order mandated by exchange protocol, observing their
	meaning from server's view.  Check `error' in verifying
	successful exchange.  Provide error messages in case of
	failure.  Delay syslog message for success until applicable,
	and provide more detail in both syslog messages.
	* src/rshd.c (doit) [SHISHI]: Read `remuser' and `locuser'
	in the order relevant from server side perspective.  Check
	`error' in verifying successful exchange.  Pass error
	messages and better syslog messages in response to exchange
	and authentication.

2012-07-24  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp: Non-encrypting libshishi support.

	* src/rcp.c [SHISHI]: Include <shishi.h>, `shishi_def.h'.
	[ENCRYPTION]: Replace obsolete conditionals on CRYPT.
	(dest_realm, use_kerberos, doencrypt) [KERBEROS || SHISHI]:
	Always declare variables.
	(h, enckey, iv1, iv2, iv3, iv4, ivtab, keytype, keylen)
	(rc, wlen) [SHISHI]: New variables.
	(options, parse_opt) [KERBEROS || SHISHI]: Make `-K', '-k'
	and `-x' available with libshishi.
	(main) [KERBEROS || SHISHI]: If `doencrypt && !use_kerberos'
	then exit with failure.
	(toremot): Invalidate descriptor `rem'.
	[SHISHI]: Call shishi_done() at completion.
	(tolocal) [SHISHI]: Likewise.
	(kerberos) [KERBEROS || SHISHI]: New variable KRB_ERRNO,
	used to capture error conditions better.  New code for
	libshishi support.
	(oldw) [KERBEROS || SHISHI]: Extend to libshishi.

	* libinetutils/shishi.c (shishi_auth) <missing ticket>:
	Add realm to error message, call shishi_realm_default().

	* src/rsh.c (talk) [KERBEROS && ENCRYPTION]: Replace
	obsolete macro CRYPT.  Replace non-existent variable
	`doenencryption' by `doencrypt'.

2012-07-23  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp, rlogin, rlogind: IP_TOS mending.

	* src/rcp.c (toremote, tolocal)
	[IP_TOS && IPPROTO_IP && IPTOS_THROUGHPUT]: New variables
	SS and SSLEN.  Call getpeername() to determine domain and
	call setsockopt(IP_TOS) only for family AF_INET.
	* src/rlogin.c (main): Likewise.
	* src/rlogind.c (rlogind_mainloop)
	[IP_TOS && IPPROTO_IP && IPTOS_THROUGHPUT]: Set socket
	option IP_TOS only for family AF_INET.

2012-07-22  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogin, rsh: Find official host name.

	* libinetutils/kcmd.c (kcmd) [HAVE_DECL_GETADDRINFO]:
	New variable FQDN.  Establish official host name by
	calling getnameinfo() on requested host.

2012-07-22  Mats Erik Andersson  <gnu@gisladisker.se>

	rsh, rlogin: Working IPv6 with libshishi.

	* libinetutils/kcmd.c (kcmd) [SHISHI]: Add a
	parameter `int af' to signature.  Apply as
	`hints.ai_family = af'.
	* libinetutils/krcmd.c (kcmd) [SHISHI]: Update.
	(krcmd) [SHISHI]: Add parameter `int af'.  Pass
	this to kcmd().
	(krcmd_mutual) [SHISHI]: Likewise.
	* libinetutils/shishi_def.h (krcmd, krcmd_mutual):
	Update signatures.
	* src/rlogin.c (main) [SHISHI] <try_connect>:
	Add parameter `family' to krcmd() and krcmd_mutual().
	* src/rsh.c (main) [SHISHI] <try_connect>: Likewise.

2012-07-21  Mats Erik Andersson  <gnu@gisladisker.se>

	r-commands: Partial IPv6 support.
	Adapt host resolution to cope with IPv6,
	in particular for libshishi related code.

	* libinetutils/kcmd.c (getport): New signature
	`(int *, int)', adding address family parameter.
	Update code to use `struct sockaddr_storage'.
	New variable LEN.
	(kcmd): New alternate code using getaddrinfo(),
	instead of gethostbyname().
	[HAVE_DECL_GETADDRINFO]: New variables HINTS, AI, RES.

	* libinetutils/shishi_def.h <struct auth_data>: Changed
	type of FROM to `struct sockaddr_storage'.
	* src/rlogind.c <struct auth_data> [!SHISHI]: Likewise.
	(rlogind_auth): New variables ADDRP, PORT.  Adapt to new
	type of `auth_data.from'.
	[!KERBEROS]: Accept families AF_INET and AF_INET6.
	(rlogind_mainloop): Adapt to new `auth_data.from'.
	(do_rlogin): Likewise.
	[WITH_IRUSEROK_AF || WITH_IRUSEROK]: New variable ADDRP.
	(do_shishi_login): New type `struct sockaddr_storage'
	for SOCK.

2012-07-18  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogin: Close libshishi handle.
	The normal logout action should lead to an
	orderly close down of the active libshishi
	handle, otherwise the tickets get lost.

	* src/rlogin.c (doit) <reader returning> [SHISHI]:
	Call shishi_done() in authenticating mode, possibly
	also shishi_key_done() and shishi_crypto_close().

2012-07-18  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogin: Non-authenticating with libshishi.
	Verified functionality with `-K' switch.

	* src/rlogin.c (OPTIONS): Remove unused macro.
	(main): Call doit() with reference to SMASK,
	not OSMASK.
	(reader) [SHISHI]: Check OOB data only in
	Kerberos mode, i.e., for set `use_kerberos'.

	rlogind: Authenticating mode with libshishi.
	Avoid segmentation faults.

	* src/rlogind.c (so_krb_login): Properly set
	an empty error message by `*err_msg = NULL'.
	(do_shishi_login): Do not free CKSUM before use,
	but do so afterwards.

2012-07-14  Mats Erik Andersson  <gnu@gisladisker.se>

	telnetd: Activate authentication modes.
	Send TELOPT_AUTHENTICATION based on the
	authentication level chosen for the server.

	* telnetd/utility.c (getterminaltype)
	[AUTHENTICATION]: Choose between send_wont(),
	send_do() and send_will() with TELOPT_AUTHENTICATION
	depending on `auth_level'.

2012-07-13  Mats Erik Andersson  <gnu@gisladisker.se>

	* telnetd/telnetd.c (auth_level) [AUTHENTICATION]:
	Use only in kerberized server builds.
	(arpg_options, parse_opt) [AUTHENTICATION]
	<-a/--authmode>: Likewise.
	(parse_mode) [AUTHENTICATION]: Likewise.

	* telnetd/utility.c (io_drain) <EAGAIN in read()>:
	Silence useless logging message `ttloop: retrying'.

2012-07-13  Mats Erik Andersson  <gnu@gisladisker.se>

	telnet, telnetd: Set service name for libshishi
	in server and allow client to specify realm.

	* libtelnet/shishi.c (dest_realm): New variable.
	(krb5shishi_send): Call shishi_realm_default_set()
	whenever `dest_realm' is set.
	(krb5shishi_is_auth): New variable SERVER.  Construct
	a service name from `LocalHostName' and use it in a
	call to shishi_hostkeys_for_server().
	* telnet/main.c (dest_realm) [KRB4 || SHISHI]:
	New external variable.
	(argp_options) [AUTHENTICATION && (KRB4 || SHISHI)]:
	Activate the option `-k/--realm' also whith SHISHI.
	(parse_opt) [AUTHENTICATION && (KRB4 || SHISHI)]:
	Likewise.

2012-07-11  Mats Erik Andersson  <gnu@gisladisker.se>

	Allow builds on OpenSolaris with libshishi.

	* telnet/main.c: Include <arpa/telnet.h>.

2012-07-10  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Resolve conflicts `int' versus `size_t'.
	Inappropriate use of `int' leads to failure
	of authentication on 64-bit architectures.

	* libinetutils/shishi.c (shishi_auth): Let OUTLEN
	be `size_t'. Read and write lengths using MSGLEN.
	(get_auth): New argument type `size_t *cksumlen'.
	Let OUTLEN be `size_t'.  New variable LEN.
	(readenc, writeenc): New type `size_t outlen'.
	* libinetutils/shishi_def.h (shishi_auth):
	Modified signature.
	* src/rlogind.c (do_shishi_login): Use `size_t'
	for CKSUMLEN and `socklen_t' for SOCKLEN.
	* src/rshd.c (doit) [SHISHI]: Likewise.

2012-07-07  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rshd.c (doit) <PAM_NEW_AUTHTOK_REQD>:
	When either pam_authenticate() or pam_acct_mgmt()
	require token renewal, then call pam_chauthtok()
	and repeat the previous call.
	(rsh_conv) <PAM_PROMPT_ECHO_OFF>: Build a full
	pam_response structure using an emtpy password,
	instead of returning an empty pointer.  Make a
	syslog notice showing the passed message string.

2012-07-05  Mats Erik Andersson  <gnu@gisladisker.se>

	rsh, rshd: Functional Shishi code.  Tested on
	32-bit system, with and without encryption,
	but without PAM.

	* src/rlogind.c (servername): New variable.
	(options): New option `-S/--servername'.
	(parse_opt) <'S'>: Implement `-S'.
	(do_shishi_login): Add `servername' as additional
	argument to get_auth().
	* src/rsh.c (servername): New variable.
	(options): New option `-S/--servername'.  Rephrase
	explanation for `-v/--vacuous'.
	(parse_opt) <'S'>: Implement `-S'.
	(doit): Add `servername' as additional argument to
	get_auth().  Apply ntohs() to PORT in calculating
	CKSUMDATA.  Do not free CKSUM before use!
	(doit) [WITH_IRUSEROK_AF && !WITH_PAM]: Calculate
	FROMADDRP separately, not within nested conditionals.

	* libinetutils/kcmd.c (kcmd) [SHISHI]: Let arguments
	`laddr' and `faddr' be `struct sockaddr_storage *'.
	New variables LEN and PORT, use `struct sockaddr_storage'
	for SIN and FROM.  Modify resolver code to handle AF_INET
	and AF_INET6.
	* libinetutils/krcmd.c (krcmd) [SHISHI]: Produce error
	message using shishi_strerror() at failures.
	(krcmd_mutual) [SHISHI]: Use `struct sockaddr_storage'
	for LADDR and FADDR.
	* libinetutils/shishi.c (shishi_auth, get_auth): Return
	meaningful error status, not `1' every time.
	(shishi_auth) <ticket fetch failure>: Report Kerberos
	principal name, not only host name of server.
	(shishi_auth) <authentication response reading>: Store
	int32 sized answer in an integer, not in a char!  Report
	a failure in case authentication actually failed.
	(get_auth): Add a further parameter `char *srvname'.
	Call shishi_server_for_local_service() only if `srvname'
	was NULL.  Otherwise, manually assemble the host's
	principal name.
	(get_auth) <authentication type failure>: Follow protocol
	and send a response 0x01.
	(get_auth) <protocol version failure>: Follow protocol
	and send a response 0x02.
	* libinetutils/shishi_def.h (get_auth): Update signature.

2012-07-03  Mats Erik Andersson  <gnu@gisladisker.se>

	* libinetutils/kcmd.c (kcmd, getport)
	[HAVE_STRUCT_SOCKADDR_IN_SIN_LEN]: Initiate `sin.sin_len'.
	(kcmd): Calculate address strings using inet_ntop().
	Use correct address location in message `Trying ...'.
	* src/rsh.c (main) [KERBEROS || SHISHI]: New variable
	KRB_ERRNO used for proper error diagnostics.  Assign a
	value after each authentication call.
	(warning): Remove erroneous call to va_arg().

2012-07-02  Mats Erik Andersson  <gnu@gisladisker.se>

	* libinetutils/shishi_def.c (shishi_auth): New type
	`unsigned short port' of seventh parameter.
	* libinetutils/shishi.c (shishi_auth): Likewise.
	Call shishi_init() before shishi_realm_default_set().
	* src/rlogin.c (parse_opt) <'k'>: Copy value from `arg'.
	* src/rsh.c (options): The option `-k/--realm' takes
	a value REALM, which was missing.

2012-07-01  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Fix non-kerberized Shishi code.

	* src/rshd.c (options) [KERBEROS || SHISHI]: Add missing
	SHISHI to conditional activation of `-k/--kerberos' and
	`-v/--vacuous'.
	(doit) [KERBEROS] <check address family>: Remove SHISHI
	in conditional, thus preventing libshishi based server
	from issuing failure for non AF_INET connections.
	(doit) [SHISHI && use_kerberos] <authentication>:
	Insert missing `if (use_kerberos)' before code block
	for conducting Shishi authentication; adjust indentation
	of this complete block!
	(doit) [SHISHI] <checksum test>: Conditionally activate
	getsockname() for reporting receiving port.

2012-06-25  Mats Erik Andersson  <gnu@gisladisker.se>

	rlogind: Prepare for address independence.
	Update some coding techniques to simplify later
	IPv6 migration.

	* libinetutils/shishi_def.h (struct auth_data):
	New members `socklen_t fromlen', `char *hostaddr'.
	* src/rlogind.c (struct auth_data): Likewise.
	(rlogin_daemon) [HAVE_STRUCT_SOCKADDR_IN_SIN_LEN]:
	Assign missing value for `saddr.sin_len'.
	(rlogind_auth): Use `ap->hostaddr' as address string.
	[HAVE_DECL_GETNAMEINFO || HAVE_DECL_GETADDRINFO]:
	New variables RC and HOSTSTR; delete HP in this case.
	[HAVE_DECL_GETNAMEINFO]: Alternate code for finding
	host name.
	[HAVE_DECL_GETADDRINFO && HAVE_DECL_GETNAMEINFO]:
	Alternate code for host name validation.
	(rlogind_mainloop): Deleted variable SIZE.  New
	variables ADDRSTR and REPLY.  Put socket address
	size in `auth_data.fromlen'.  Determine host address
	`auth_data.hostaddr' by calling inet_ntop() once.
	[WITH_IRUSEROK_SA || WITH_IRUSEROK_AF || WITH_IRUSEROK]:
	Choose the best available iruserok variant.
	[WITH_RUSEROK_AF || WITH_RUSEROK]: Choose best variant.
	(do_shishi_login): Compute SOCKLEN as `sizeof (sock)'.

2012-06-25  Mats Erik Andersson  <gnu@gisladisker.se>

	rcp, rlogin, rsh, rshd: IPv6 ability.

	* src/rcp.c (family) [WITH_ORCMD_AF || WITH_RCMD_AF]:
	New variable.
	(options) [WITH_ORCMD_AF || WITH_RCMD_AF]: New options
	`4/ipv4' and `6/ipv6'.
	(parse_opt) [WITH_ORCMD_AF || WITH_RCMD_AF] <4, 6>:
	Assign value AF_INET or AF_INET6 to `family'.
	(toremote, kerberos) [WITH_ORCMD_AF || WITH_RCMD_AF]:
	Replace AF_INET by `family' in orcmf_af() and rcmd_af().
	(tolocal) [WITH_ORCMD_AF || WITH_RCMD_AF]: Likewise.
	[!KERBEROS && WITH_ORCMD_AF]: Correction to conditional.
	Call one of the rcmd() variants only if the macro KERBEROS
	is not defined.

	* src/rlogin.c (family) [WITH_ORCMD_AF || WITH_RCMD_AF]:
	New variable.
	(argp_options) [WITH_ORCMD_AF || WITH_RCMD_AF]: New
	options `4/ipv4' and `6/ipv6'.
	(parse_opt) [WITH_ORCMD_AF || WITH_RCMD_AF] <4, 6>:
	Assign value AF_INET or AF_INET6 to `family'.
	(main) [WITH_ORCMD_AF]: Call orcmd_af().
	[WITH_RCMD_AF && !WITH_ORCMD_AF]: Call rcmd_af().
	[WITH_ORCMD && !WITH_ORCMD_AF && !WITH_RCMD_AF]:
	Call orcmd().

	* src/rsh.c (family) [WITH_ORCMD_AF || WITH_RCMD_AF]:
	New variable.
	(options) [WITH_ORCMD_AF || WITH_RCMD_AF]: New options
	`4/ipv4' and `6/ipv6'.
	(parse_opt) [WITH_ORCMD_AF || WITH_RCMD_AF] <4, 6>:
	Assign value AF_INET or AF_INET6 to `family'.
	(main) [WITH_ORCMD_AF]: Use `family' in last argument
	to orcmd_af().
	[WITH_RCMD_AF]: Likewise for rcmd_af().

	* src/rshd.c (main): New type `struct sockaddr_storage from'.
	Cast &FROM as `struct sockaddr *' when calling doit().
	(doit): New signature `(int, struct sockaddr *, socklen_t)'.
	Adapt code to new parameter type `struct sockaddr * fromp',
	using casts whenever needed.  Check `fromp->sa_family'.
	[WITH_IRUSEROK_AF && !WITH_PAM]: New variable FROMADDRP.
	[KERBEROS || SHISHI]: Check for IPv4 only in this case.
	<hostname validation> [HAVE_DECL_GETNAMEINFO]: Use the
	flag NI_NAMEREQD.

2012-06-19  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: PAM session handling.

	* src/rshd.c: Include <sys/wait.h>.
	(doit) <port != 0 && parent> [WITH_PAM]: Call
	pam_close_session(), pam_setcred(), and pam_end().
	(doit) <without port> [WITH_PAM]: Call fork().  Parent
	waits for child and properly closes PAM session.
	(doit) <child> [WITH_PAM]: Call pam_open_session().

2012-06-18  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac (WITH_ORCMD_AF, WITH_ORCMD, WITH_RCMD_AF)
	(WITH_RRESVPORT_AF, WITH_IRUSEROK_AF, WITH_IRUSEROK_SA)
	(WITH_RUSEROK_AF): New macros.
	* src/rcp.c (toremote, tolocal, kerberos)
	[WITH_ORCMD_AF || WITH_RCMD_AF || WITH_ORCMD]:
	Replace rcmd() by orcmd_af(), rcmd_af(), or orcmd().
	* src/rsh.c (main)
	[WITH_ORCMD_AF || WITH_RCMD_AF || WITH_ORCMD]: Likewise.
	* src/rshd.c (doit) [WITH_RRESVPORT_AF]: Use rresvport_af()
	instead of rresvport().
	[WITH_IRUSEROK_SA || WITH_IRUSEROK_AF]: Replace iruserok()
	with iruserok_sa() or iruserok_af().
	[WITH_RUSEROK_AF]: Use ruserok_af(), not ruserok().

2012-06-18  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rshd.c (doit): New signature
	`(int, struct sockaddr_in *, socklen_t)'.
	(main): Pass FROMLEN to doit().
	(doit): New variables INPORT, RC, PORTSTR, ADDRSTR.
	(doit) [HAVE_DECL_GETNAMEINFO]: New variable ADDRNAME.
	(doit): Put numeric info in ADDRSTR, INPORT, PORTSTR
	early on, later replacing multiple inet_ntoa().  Do not
	overwrite `fromp->sin_port', but use INPORT, PORTSTR.
	Prefer using getnameinfo().
	(doit) <address verification> [HAVE_DECL_GETNAMEINFO]:
	New alternate code.

2012-06-15  Mats Erik Andersson  <gnu@gisladisker.se>

	rshd: Duplicate static memory results.  Consistently
	needed on systems running DragonFlyBSD.

	* src/rshd.c (doit): When assigning HOSTNAME, apply
	strdup() to results of inet_ntoa() and `hp->h_name'
	in order to avoid loss of its contents later on.

	rshd: Implement PAM support.

	* src/Makefile.am (rshd_LDADD): Add also $(LIBPAM).
	* src/rshd.c [HAVE_SECURITY_PAM_APPL_H]: Include
	<security/pam_appl.h>.
	(pam_rc, pam_handle, pam_conv) [WITH_PAM]: New variables.
	(rsh_conv) [WITH_PAM]: New function.
	(iruserok) [!WITH_PAM && __GLIBC__ && WITH_IRUSEROK]:
	Set prototype only in absence of WITH_PAM.
	(doc) [WITH_PAM]: Expand string content.
	(username, logname, homedir, shell, path): Increase lengths,
	including a preamble like `SHELL='.
	(rhost): New variable used for environment variable RHOST.
	(envinit) [!WITH_PAM]: Use only in absence of PAM support.
	(doit) [WITH_PAM]: New code.
	[!WITH_PAM && WITH_IRUSEROK]: Call iruserok() only in
	absence of PAM.
	[!WITH_PAM && !WITH_IRUSEROK && WITH_RUSEROK]: Likewise
	for ruserok().
	(doit) <fail label> [WITH_PAM]: Report errors via syslog.
	(doit): Replace numerical offset by key string size when
	setting `homedir', `path', `shell', and `username'.
	Really assign a value to `logname', for portability.
	(doit) <failed execl>: Report to syslog.

2012-06-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rshd.c (doit) [HAVE_GETPWNAM_R]: New variables
	PWBUF, PWBUFLEN, PWSTOR, and RET.  Call getpwnam_r(),
	checking both `ret' and `pwd == NULL' for failure.

2012-06-15  Simon Josefsson  <simon@josefsson.org>

	* bootstrap: Updated from gnulib.

2012-06-11  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd, rlogind: Distinguish logging facility.
	Use LOG_AUTH only for authentication messages.

	* src/rexecd.c (doit): Add LOG_AUTH to syslog() in user
	contexts.  Otherwise use default LOG_DAEMON in openlog().
	* src/rlogind.c (main, do_rlogin, do_krb4_login)
	(do_krb5_login, do_shishi_login): Likewise.

2012-06-09  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Long address transfer request.

	* ftpd/ftpcmd.y (LPRT): New token.
	(long_host_port): New value returning type.
	* doc/inetutils.texi (ftpd invocation): Updated.

2012-06-07  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd: Audit of PAM code.

	* src/rexecd.c (doc) [WITH_PAM]: Expand string.
	(doit): Remove variable TOKEN.  Add flag PAM_SILENT
	in call to pam_setcred().  Really update USER when
	calling pam_get_item(PAM_USER).  When execl() fails,
	close properly by calling pam_end().

2012-06-07  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Audit of existing PAM code.

	* ftpd/extern.h (pam_end_login) [WITH_LINUX_PAM]:
	New prototype.
	* ftpd/ftpd.c (end_login) [WITH_LINUX_PAM]: Call
	pam_end_login() to tear down current client.
	* ftpd/pam.c: Include <syslog.h>.
	(pam_doit): Add missing call to pam_open_session().
	(pam_end_login): New function.

2012-06-06  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Restrict to Linux-PAM, which is only valid code.

	* configure.ac (WITH_PAM): Add check for PAM_CONV_AGAIN.
	(WITH_LINUX_PAM, FTPD_LIBPAM): New variables.
	* ftpd/Makefile.am (LDADD): Replace LIBPAM by FTPD_LIBPAM.
	* ftpd/auth.c (auth_user, auth_pass) [WITH_LINUX_PAM]:
	Replace old WITH_PAM by correct WITH_LINUX_PAM.
	* ftpd/extern.h [WITH_LINUX_PAM]: Likewise.
	* ftpd/ftpd.c [WITH_LINUX_PAM]: Likewise.
	* ftpd/pam.c [WITH_LINUX_PAM]: Likewise.
	(PAM_CONV_AGAIN, PAM_INCOMPLETE): Removed macro definitions.
	(PAM_conversation): Initialise second element to NULL.
	(GET_MEM): Return PAM_BUF_ERR.
	(PAM_conv) [!PAM_CONV_AGAIN]: Set RETVAL to PAM_CONV_ERR.
	(pam_doit) [PAM_CONV_AGAIN]: Test `error == PAM_CONV_AGAIN'.
	[PAM_INCOMPLETE]: Test `error == PAM_INCOMPLETE'.
	(pam_doit): Return PAM_SUCCESS, not 0.
	(pam_user): Initialise `PAM_conversation.appdata_ptr'.

2012-06-02  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Long passive transfer request.

	* ftpd/extern.h (PASSIVE_PASV, PASSIVE_EPSV, PASSIVE_LPSV):
	New macros.
	* ftpd/ftpcmd.y (LPSV): New token.
	(cmd) <PASV>: Call passive() with PASSIVE_PASV.
	<EPSV>: Call passive() with PASSIVE_EPSV; both variants.
	<LPSV>: New subcommand.
	(cmdtab): New entry `LPSV'.
	* ftpd/ftpd.c (passive): Use macros PASSIVE_* to distinguish
	subcases.  Add two subcases for `LPSV', with pointer math
	shared with `PASV'.
	* doc/inetutils.texi: Updated.

2012-05-31  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Adaptive block size in image mode.

	* ftp/ftp.c (sendrequest): New variables BLKSIZE, BUFSIZE.
	Change type of BUF to `static char *' for allocation.
	Set BLKSIZE to `st_blksize' for input file.  Allocate and
	increase size of buffer as needed.
	<TYPE_I>: Use BUFSIZE for buffer length when calling read().
	(recvrequest): Call fstat() on successful stream `fout'
	and set BLKSIZE to `st_blksize'.
	(abort_remote): Replace macro BUFSIZ by `sizeof(buf)'.

2012-05-31  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Use adaptive block sizes in image mode.

	* ftpd/ftpd.c (receive_data): Update signature to
	`(FILE *, FILE *, off_t)'.  Make BUF a pointer to
	allocated memory.
	<TYPE_I> : Allocate BUF of size `blksize'.  Change
	buffer size to this value inside loop calling read().
	(retrieve): Remove `const' from BUFFER_SIZE again.
	If `cmd == 0', use `st_blksize' for setting BUFFER_SIZE.
	(store): Call fstat() on successful stream `fout'.

2012-05-30  Mats Erik Andersson  <gnu@gisladisker.se>

	Incomplete coding of variadic printing.  Each such command
	consumes the pointer, leaving it in an undefined state.
	Some 64-bit systems are sensitive to these mistakes.

	* ftpd/ftpd.c (reply, lreply): Missing va_end(). Give each
	vprintf() and vsyslog() a separate pair va_start()/va_end().
	* src/rcp.c (run_err): Likewise for vfprintf().
	* src/rshd.c (rshd_error): Missing va_end().

2012-05-30  Mats Erik Andersson  <gnu@gisladisker.se>

	ftpd: Allow 64-bit offsets and file sizes.  Restrict
	file size for use of mmap() and only null offset, since
	Solaris and Linux demand page size alignment.  Assign
	a positive malloc size for use in data transmission.

	* ftpd/ftpcmd.y: Include <inttypes.h> or <stdint.h>.
	(token union): Use `intmax_t i' instead of `int i' in order
	to handle 64-bit offsets and sizes.
	(cmd, rcmd, host_port, sizecmd): Use format strings `%jd'
	and `%ju'.  Append `LL' to numerical constants.
	(yylex) <ARGS>: Convert numeric strings using strtoimax().
	* ftpd/ftpd.c (retrieve): Initialise BUFFER_SIZE to `BUFSIZ'
	in all cases.  Essential correction, since malloc() would
	otherwise allocate 0 bytes in binary mode.
	(IU_MMAP_SIZE): New macro.
	(send_data): Initialise BUF to `MAP_FAILED'.  Change LEN
	and FILESIZE to be `off_t'.  Add debug logging about offsets
	and transmission modes `ascii/image/mmap'.
	[HAVE_MMAP]: Attempt mapping only if file size is less than
	IU_MMAP_SIZE and only when `restart_point == 0'.

2012-05-26  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/ftp-localhost.sh (do_transfer, GETME, PUTME):
	New variables.  Environmental TRANSFERTEST sets do_transfer.
	(posttesting): Remove file `$FTPHOME/$PUTME' if $do_transfer
	is true and file exists.
	(test_report): Lessen verbosity by printing exchange data
	only if $VERBOSE is non-empty.
	[do_transfer]: Execute transmission tests.  These execute
	an additional `put' for selected addressing and modes.

2012-05-26  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Reporting and accounting of large files.

	* ftp/extern.h (ptransfer): New signature
	`(char *, long long, struct timeval *, struct timeval *)'.
	* ftp/ftp.c (sendrequest, recvrequest): New type `long long'
	for BYTES and LOCAL_HASHBYTES.
	(ptransfer): New type `long long' for BS.  New format string
	`%lld' for byte counter and byte rate.

2012-05-24  Mats Erik Andersson  <gnu@gisladisker.se>

	Portability to FreeBSD.

	* ftp/cmds.c: Include <stdint.h> for `intmax_t'.
	* ftp/ftp.c: Likewise.

2012-05-24  Mats Erik Andersson  <gnu@gisladisker.se>

	ftp: Large file support.  The implementation
	has been truncating offset values.

	* ftp/cmds.c (restart): Convert `restart_point' using atoll().
	Use a format string `%jd' and cast as `intmax_t'.
	* ftp/ftp.c (sendrequest): Remove cast of `restart_point'
	as `long'. Use format string `%jd' and cast as `intmax_t'.
	(recvrequest): Likewise.  Variables I and N must be `off_t'
	for computations with `restart_point'.

2012-05-21  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd: Adapt to PAM authentication.

	* src/Makefile.am (rexecd_LDADD): Use $(LIBPAM).
	* src/rexecd.c [HAVE_SECURITY_PAM_APPL_H]: Include
	<security/pam_appl.h>.
	(pam_rc, password_pam, pam_flags, pam_handle, pam_conv)
	[WITH_PAM]: New variables.
	(rexec_conv) [WITH_PAM]: New function.
	(remotehost): New variable, used in environment.
	(envinit) [!WITH_PAM]: Add `remotehost' to list.
	(doit) [WITH_PAM]: New variable TOKEN.  Add alternate
	authentication checks.  Set `pam_rc = PAM_ABORT' where
	errors are caught.
	<parent fork>: Set `pam_handle' to NULL, since the child
	process closes all authentication.
	(die) [WITH_PAM]: Call pam_end() if PAM is still active.
	* doc/inetutils.texi (rexecd invocation): Update.

2012-05-20  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd: Use getpwnam_r() if available, thus
	preparing migration to PAM.

	* src/rexecd.c [HAVE_GETPWNAM_R]: Include <xalloc.h>.
	(doit) [HAVE_GETPWNAM_R]: New variables PWBUF, PWBUFLEN,
	and PWSTOR.  Dynamically allocate PWBUF.  Call getpwnam_r()
	with composite check on result.

2012-05-16  Mats Erik Andersson  <gnu@gisladisker.se>

	ping, traceroute: Type-of-Service.

	* doc/inetutils <ping, traceroute invocation>: Update.
	* ping/ping.c (tos): New variable.
	(argp_options): New option `-T/--tos'.
	(parse_opt): New case `T'.
	(main): Set socket option IP_TOS.
	* src/traceroute.c (opt_tos): New variable.
	(argp_options): New option `-t/--tos'.
	(parse_opt): New case `t'.
	(trace_init): New variable FD.  Set socket option IP_TOS.

2012-05-14  Mats Erik Andersson  <gnu@gisladisker.se>

	Build test binaries early.

	* tests/Makefile.am (check_PROGRAMS): Removed variable.
	(bin_PROGRAMS): New variable.
	(TESTS): Use `bin_PROGRAMS' instead of `check_PROGRAMS'.

2012-05-14  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Stop at unreachable destinations.

	* src/traceroute.c (unreach_sign): New variable.
	(do_try): New local variables RC, TYPE, and CODE.  Let negative
	return status from trace_read() be abnormal.  Print additional
	packet failure information for ICMP_DEST_UNREACH.
	(CAPTURE_LEN): New macro.
	(trace_read): Set new signature to `(trace_t *, int *, int *)'.
	Change size of DATA to CAPTURE_LEN.  New variable RC.  Capture
	type and code of incoming ICMP message.
	<TRACE_UDP>: Inspect all ICMP_DEST_UNREACH packets.  Calculate
	port number using length offset in IP header.  Set `stop' for
	all kinds of ICMP_DEST_UNREACH, and set positive return code,
	except for ICMP_PORT_UNREACH.
	<TRACE_ICMP>: Inspect also ICMP_DEST_UNREACH packets.  Check
	their identity only, not seqno.  Set `stop' also for these,
	and have them return positive status.  Calculate OLD_ICMP
	using length offset in IP header.

	* ping/ping_echo.c (ping_echo): Size of RSPACE is MAX_IPOPTLEN.

2012-05-12  Mats Erik Andersson  <gnu@gisladisker.se>

	ping: Support IP option Timestamp.

	* doc/inetutils.texi (ping invocation): Update.
	* ping/ping.c (suboptions): New variable.
	(decode_ip_timestamp): New function.
	(ARG_IPTIMESTAMP): New enumeration value.
	(argp_options): Add long option `ip-timestamp'.
	(parse_opt) <ARG_IPTIMESTAMP>: New case.
	* ping/ping_common.h (OPT_IPTIMESTAMP, SOPT_TSONLY)
	(SOPT_TSADDR, SOPT_TSPRESPEC): New macros.
	* ping/ping_echo.c (ping_echo) [options & OPT_IPTIMESTAMP]:
	New setup case.
	(print_ip_opt): New variable K.
	<IPOPT_TS>: New printout case.
	* ping/ping_impl.h (suboptions) [!USE_IPV6]: New external.

2012-05-11  Mats Erik Andersson  <gnu@gisladisker.se>

	traceroute: Dynamic identity and sequence numbers.

	* src/traceroute.c (seqno): New variable.
	(main): Assign getpid() to `pid'.  Initialise `seqno'.
	(trace_read) <TRACE_UDP>: Replace numerical offset `11'.
	(trace_read) <TRACE_ICMP && ICMP_ECHOREPLY>: Apply ntohs()
	to `ic->icmp_seq' and to `ic->icmp_id'.
	<TRACE_ICMP && ICMP_TIME_EXCEEDED>: Complete code rewrite.
	(trace_write): Activate dynamic `pid' and `seqno' in call to
	icmp_echo_encode().

2012-05-10  Mats Erik Andersson  <gnu@gisladisker.se>

	Refactor address-to-string conversion as common code.

	* ping/ping6.c (options): Remove qualifier `static'.
	(ipaddr2str): Removed function.
	(print_icmp_error): Call ipaddr2str() with new signature.
	* ping/ping_common.c: Include <errno.h>, <netinet/in.h>,
	<arpa/inet.h>, and <netdb.h>.
	(options): New external variable.
	(ipaddr2str, sinaddr2str): New functions.
	* ping/ping_common.h (ipaddr2str, sinaddr2str): New prototypes.
	* ping/ping_echo.c (ipaddr2str): Removed function.
	(print_icmp_header): Call ipaddr2str() with new signature.
	(print_ip_opt): Replace ipaddr2str() with sinaddr2str().

2012-05-10  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/ping6.c (argp_options): New option `verbose'.
	(parse_opt) <v>: New case.
	(ping_echo): Print identity in verbose mode.
	* ping/ping_echo.c (ping_echo): Likewise.
	(print_ip_header): Print IP header dump in verbose mode.

2012-05-09  Mats Erik Andersson  <gnu@gisladisker.se>

	ping: Options `--mask' and `--ttl'.

	* ping/ping.c (ttl): New variable.
	(ARG_TTL): New enumeration value.
	(argp_options): Add long option `mask' as synomym to `address'.
	New long option `ttl'.
	(parse_opt) <ARG_TTL>: New case.
	(main): If `ttl > 0', set value for sockopt IP_TTL.
	(*decode_typ): Add check for `mask'.

	ping6: Option `--hoplimit'.

	* ping/ping6.c (hoplimit): New variable.
	(ARG_HOPLIMIT): New enumeration value.
	(argp_options): New long option `hoplimit'.
	(parse_opt) <ARG_HOPLIMIT>: New case.
	(main): If `hoplimit > 0', set value for sockopt IPV6_UNICAST_HOPS.

	* doc/inetutils.texi (ping invocation): Updates, corrections.

2012-05-09  Mats Erik Andersson  <gnu@gisladisker.se>

	Discriminate UTC from non-UTC time stamps.

	* ping/ping_common.c (is_normed_time, ping_cvt_time): New fcns.
	* ping/ping_common.h (is_normed_time, ping_cvt_time): New prototypes.
	* ping/ping_timestamp.c (print_timestamp): New variable TIMESTR.
	Call ping_cvt_time() to generate strings for three time values.
	[options & OPT_VERBOSE]: Print time difference if both of
	`icmp->icmp_otime' and `icmp->icmp_ttime' are UTC-based.

	* ping/ping_common.h (_PING_BUFLEN):  Really replace the
	parameter name `USE_IPV6' by the neutral name `u'.

2012-05-08  Mats Erik Andersson  <gnu@gisladisker.se>

	Critical package errors in size and allocation.

	* ping/ping.c (send_echo): Replace macro PING_HEADER_LEN by
	calculated value OFF, i.e., the number of consumed bytes.
	* ping/ping6.c (send_echo): Likewise.
	(ping_init): Initialise `p->ping_datalen' as the size of
	`struct timeval', a possible payload.
	* ping/ping_common.h (PING_HEADER_LEN): Use correct size as
	`sizeof(struct icmp6_hdr)' and ICMP_MINLEN, respectively.
	(PING_TIMING): Compare with `sizeof(struct timeval)'.
	(_PING_BUFLEN) <IPv4 case>: Add contribution MAXIPLEN, and
	increase ICMP contribution to ICMP_TSLEN, the maximal length.
	* ping/ping_echo.c (ping_echo) [options & OPT_RROUTE && IP_OPTIONS]:
	Remove call (a recent regression) to ping_set_packetsize().

2012-05-08  Mats Erik Andersson  <gnu@gisladisker.se>

	Incomplete endianness conversions.

	* libicmp/icmp_echo.c (icmp_generic_encode): Apply htons() to
	SEQNO and IDENT.
	* ping/libping.c (my_echo_reply, ping_recv): Apply ntohs() to
	`orig_icmp->icmp_id' and `orig->icmp_seq'.
	* ping/ping6.c (print_echo): Likwise for `icmp6->icmp6_seq'.
	* ping/ping_address.c (print_address): Apply ntohs() to
	`icmp->icmp_seq'.
	* ping/ping_echo.c (print_echo): Likewise.
	(print_ip_header): Apply ntohs() to `ip->ip_len', `ip->ip_id',
	`ip->ip_off', and to `ip->ip_sum'.
	* ping/ping_timestamp.c (print_timestamp): Apply ntohs() to
	`icmp->icmp_seq'.

2012-05-08  Mats Erik Andersson  <gnu@gisladisker.se>

	Use symbolic size names in all harmless cases.

	* libicmp/icmp.h (ICMP_TSLEN): Use size of `n_time'.
	* libicmp/icmp_address.c (icmp_address_encode): Use ICMP_MASKLEN.
	* libicmp/icmp_echo.c (icmp_generic_encode): Use ICMP_MINLEN.
	* libicmp/icmp_timestamp.c (icmp_timestamp_encode): Use ICMP_TSLEN.
	* ping/libping.c (_ping_packetsize): Use ICMP_TSLEN.  Add cases
	for ICMP_ADDRESS and ICMP_ADDRESSREPLY.  Use PING_HEADER_LEN in
	default case.
	(ping_set_dest) [HAVE_STRUCT_SOCKADDR_SA_LEN]: Set `s_in->sin_len'.
	* ping/ping_address.c (ping_address): Use ICMP_MASKLEN.
	* ping/ping_common.h (_ping_setbuf, ping_set_data): Use `use_ipv6'
	as parameter, not the macro name USE_IPV6.
	* ping/ping_echo.c (print_echo): Use PING_HEADER_LEN.
	(print_ip_header): Use `sizeof(*ip)' for IP header size.
	Use tabs at end of printed header.
	(print_ip_data): Use IPPROTO_TCP and IPPROTO_UDP.  Add case
	for IPPROTO_ICMP.
	* ping/ping_timestamp.c (ping_timestamp): Use ICMP_TSLEN.

	Determine correct and relevant diagnostic messages.

	* ping/ping_echo.c (struct icmp_code_descr): Add field `int type'.
	(icmp_code_descr): Prepend every member with a type value for
	correct discrimination.
	(print_icmp_code): New signature `(int, int, char *)'.  Test `type'
	as well as `code' when matching.
	(print_icmp): Update call to print_icmp_code().
	(icmp_diag): New members ICMP_ROUTERADV and ICMP_ROUTERDISCOVERY.
	New members ICMP_INFO_REPLY and ICMP_ADDRESS.  Replace incorrect
	ICMP_MASKREPLY with ICMP_ADDRESSREPLY.
	(print_ip_opt) <IPOPT_SSRR>: New case.  Code shared with IPOPT_LSRR.
	<IPOPT_LSRR, IPOPT_RR>: Replace call to ntohl() by correct htonl().

2012-05-07  Mats Erik Andersson  <gnu@gisladisker.se>

	Portability issue for setting timeval manually.

	* ping/ping.c (ping_run): Erase RESP_TIME, INTVL, and NOW
	before first use.
	* ping/ping6.c (ping_run): Likewise.  Do not erase RESP_TIME
	inside loop.

	Regression in calculating response timing.

	* src/traceroute.c (do_try): Use format string ` %2d ' with HOP.
	New variable SAVE_ERRNO.  Call select() before gettimeofday(),
	but save `errno' in SAVE_ERRNO.  Take care of microsecond
	underflow when calculating time difference.
	(trace_read): Replace numerical size by `sizeof (data)'.

2012-04-27  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/ping_address.c (print_address): Remove duplicate
	prototype.  Print additional newline to conform with output
	formatting for other types of reporting.
	* ping/ping_echo.c (ping_echo)
	[(options & OPT_ROUTE) & IP_OPTIONS]: Increase data length
	to accomodate the amount used for record routes in IP header.

2012-04-24  Mats Erik Andersson  <gnu@gisladisker.se>

	rexec: Read password from stdin.

	* src/rexec.c (main): New variables PASSWORD and N.
	If `arguments.password' is a single dash, read a line
	from standard in and assign it to `arguments.password'.
	* doc/inetutils.texi (rexec invocation):  Mention new
	treatment of `-p/--password'.

2012-04-22  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd: Implement syslog support.

	* src/rexecd.c: Include <syslog.h>.
	(logging, options): New variables.
	(parse_opt): New function.
	(argp): Insert `options' and `parse_opt'.
	(main): Call openlog().  Do not exit at surplus arguments,
	but make a note in syslog.  Log failed getpeername().
	(doit): New variables RHOST and RET.  In addition to error()
	and die(), make many entries in the syslog of varying severity.

	* src/rexec.c (do_rexec): Add a five second alarm around
	accept() for stderr channel, in case the server side is
	not responding.

	* doc/inetutils.texi (rexec, rexecd): Document recent
	additions.  Make option encoding for `rexec' complete.

2012-04-21  Mats Erik Andersson  <gnu@gisladisker.se>

	rexecd: Privilege audit and protocol conformity.

	* src/rexecd.c (doit): Execute changes of group as
	soon as password has been verified.  Remove useless
	call to setegid().  Protect setpgid() by the macro
	HAVE_SETPGID.  Delay sending the single NUL character
	until the time immediately before execution is handed
	over to a shell interpreter.

2012-04-20  Mats Erik Andersson  <gnu@gisladisker.se>

	Portability issue found on 64-bit OpenBSD.

	* ping/ping.c (ping_run): Break infinite loop by calling error()
	after failure in select().
	* ping/ping6.c (ping_run): Likewise.  Clear RESP_TIME.
	* src/traceroute.c (do_try): New variable FD.  Clear TIME and
	calculate NOW before calling select().  Set `fd + 1' to be the
	maximal file descriptor when calling select().  On failure in
	select(), return `errno' for proper detection, not EPERM.

2012-04-20  Mats Erik Andersson  <gnu@gisladisker.se>

	rexec, rexecd: Implement support for IPv6.

	* src/rexec.c (options): New `-4/ipv4', `-6/ipv6', and `-a/ipany'.
	(struct arguments): New member `int af'.
	(parse_opt): Detect `4', `6', and `a'.
	(do_rexec): New variables `ret', `addrlen', `hints', `ai', `res'.
	New type `struct sockaddr_storage` for ADDR.  Removed `host'.
	Replace gethostbyname() by getaddrinfo() in resolving host name.
	(do_rexec) <use error stream>: Use `struct sockaddr_storage` for
	SERV_ADDR and prepare bind() based on properties of ADDR.
	* src/rexecd.c (main): Use `struct sockaddr_storage' for FROM.
	(a_sin): Removed variable.
	(doit): New signature `doit(int, struct sockaddr *, socklen_t)`
	Change PORT to be `in_port_t'.  Remove call to bind().  Rewrite
	preparations for connect() to detect address family.

2012-04-19  Mats Erik Andersson  <gnu@gisladisker.se>

	Let `rexec' return a relevant return status.

	* src/rexec.c (remote_err): New variable.
	(main): Return `remote_err' as status.
	(do_rexec): New variable ON.  Set SO_REUSEADDR on SERV_SOCK.
	(do_rexec) <while loop>: New variables CONSUMED and OFFSET.
	Filter off initial bytes `\000' and `\001' appearing on either
	of the sockets SOCK and ERR_SOCK, since these represent return
	statuses and are now recorded in `remote_err'.

	String storage sanitation and intelligible return codes.

	* src/rexecd.c (username, logname, homedir, shell): Increase length.
	(envinit): Use NULL as last member, not naught.
	(doit): Set SO_REUSEADDR on socket S.  Use sizeof() to calculate
	explicit offset in strncat() with environment variables.  Let
	LOGNAME inherit the value from USER.
	(doit, getstr) <die calls>: Use EXIT_FAILURE as first argument.

2012-04-18  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/rexec.c (do_exec): Set missing values for `sin_family' and
	`sin_len' in SERV_ADDR.
	* src/rexecd.c (die): Use vsnprintf() for variadic lists!  Send
	also final newline character.  Call exit() at the end!

2012-04-13  Mats Erik Andersson  <gnu@gisladisker.se>

	Improve checking of FTP access verification.

	* ftpd/ftpd.c (complete_login): Abort login attempt when
	setegid() fails.
	(pass): Clear LOGIN_ATTEMPTS only if login was really granted.

2012-04-11  Mats Erik Andersson  <gnu@gisladisker.se>

	Support for DragonFly BSD.

	* configure.ac: Define UTMPX for `*dragonfly*'.
	* ftpd/extern.h: Include <sys/socket.h>.
	* src/rexec.c (do_rexec): Explicit casts as `struct sockaddr'.
	* src/tftpd.c (validate_access): Declare TIMEOUTBUF correctly
	to be of type `sigjmp_buf'.
	* telnet/externs.h: Include <errno.h> unconditionally.  Remove
	conditionals for `errno' depending on macro CRAY.

2012-03-31  Alfred M. Szmidt  <ams@gnu.org>

	configure.ac: Minor cleanup.

	* configure.ac: Don't check for mkstemp, don't try to replace
	strdup.
	(long long, long double): Remove checks.
	(AM_C_PROTOTYPES): Likewise.
	(AC_FUNC_ALLOCA, AC_FUNC_MALLOC, AC_FUNC_REALLOC): Likewise.

2012-03-31  Alfred M. Szmidt  <ams@gnu.org>

	* Makefile.am (DISTCLEANFILES): Added $(PACKAGE)-$(VERSION).tar.xz
	to list.

2012-03-29  Alfred M. Szmidt  <ams@gnu.org>

	* tests/.gitignore: Added tools.sh to list.

2012-03-29  Alfred M. Szmidt  <ams@gnu.org>

	Create xz compressed tarballs as part of `make dist'.

	* README-alpha: Updated.
	* configure.ac: Added dist-xz.
	* .gitignore: Added inetutils-*.tar.xz to list.

2012-03-27  Alfred M. Szmidt  <ams@gnu.org>

	Check return code of malloc, or use xmalloc.

	* whois/whois.c: Include "xalloc.h".
	(gwhois_argp_parser, queryformat): Use xmalloc over malloc.
	* telnet/commands.c: Include "xalloc.h".
	(env_init, env_define): Use xmalloc over malloc.
	* src/syslogd.c: Include "xalloc.h".
	(crunch_list): Use xmalloc over malloc.
	* src/rshd.c: Include "xalloc.h".
	(doit): Use xmalloc over malloc.
	* src/rsh.c: Include "xalloc.h".
	(main): Use xmalloc over malloc.
	* src/rlogind.c: Include "xalloc.h".
	(do_shishi_login): Use xmalloc over malloc.
	* src/rlogin.c: Include "xalloc.h".
	(main): Use xmalloc over malloc.
	* libtelnet/shishi.c (krb5shishi_send): Check return code of
	malloc.
	* libtelnet/kerberos5.c (kerberos5_send): Don't use assert to
	check the return code for malloc
	* libinetutils/kcmd.c (kcmd): Check return code of malloc.
	* ifconfig/printif.c: Include "xalloc.h".
	(print_interfaceX): Use xmalloc over malloc.
	* ftp/cmds.c: Include "xalloc.h".
	(dotrans, domap): Use xmalloc over malloc.

2012-03-21  Mats Erik Andersson  <gnu@gisladisker.se>

	* configure.ac (DD, MKTEMP, NETSTAT): New variables.  Use
	AC_PATH_PROG on `dd', `mktemp', and `netstat'.  Declare as
	precious with AC_ARG_VAR.
	(SED): New variable.  Set using AC_PROG_SED, protect by
	AC_ARG_VAR.
	(GREP): Protect using AC_ARG_VAR.
	* tests/Makefile.am (BUILT_SOURCES, EXTRA_DIST, CLEANFILES)
	(tools_subst): New variables.
	(tools.sh): New target.
	* tests/ftp-localhost.sh: Source `tools.sh'.  Use $GREP, $MKTEMP,
	$NETSTAT, and $SED instead of utility names.  Change tests for
	`grep', and `netstat'; check $need_mktemp.
	(FTPHOME): Check also fifth field of passwd, should GECOS be
	missing.
	(USER): Calculate using `func_id_user'.
	* tests/hostname.sh: Source `tools.sh'.  `func_id_uid` replaces
	`id -u'.
	* tests/ping-localhost.sh: Likewise.
	* tests/traceroute-localhost.sh: Likewise.
	* tests/syslogd.sh: Check directory early, then source `tools.sh'.
	Check $need_mktemp and $need_netstat.  Use $SED, $MKTEMP,
	$NETSTAT, and $GREP.  Replace `id -u' by `func_id_uid'.
	* tests/telnet-localhost.sh: Source `tools.sh'.  Check
	$need_mktemp.  Use $SED, $MKTEMP, and $GREP.
	(USER): Compute using `func_id_user'.
	* tests/tftp.sh: Source `tools.sh'.  Check $need_dd, $need_mktemp,
	and $need_netstat.  Remove checks for `netstat' and `grep'.  Use
	$SED, $MKTEMP, $NETSTAT, $GREP, and $DD.
	(USER): Compute using `func_id_user'.
	* tests/tools.sh.in: New file.

2012-03-20  Mats Erik Andersson  <gnu@gisladisker.se>

	* am/libcurses.m4 (IU_LIB_TERMCAP) <termlib detection>: Add a
	missing use of `test'.
	(HAVE_TERMLIB_TGETENT): New macro, replaces HAVE_TERMINFO_TGETENT.

2012-03-15  Simon Josefsson  <simon@josefsson.org>

	* doc/inetutils.texi (dnsdomainname invocation): Doc fix.
	* man/dnsdomainname.h2m: Likewise.
	* src/dnsdomainname.c (doc): Likewise.

	* src/dnsdomainname.c (dnsdomainname): Don't error when canonical
	name does not have domain name component (compatibility with
	Debian dnsdomainname).  Suggested by Mats Erik Andersson
	<gnu@gisladisker.se>.

	* tests/dnsdomainname.sh: Reject non-0 and non-1 exit codes (i.e.,
	crashes).

2012-03-15  Mats Erik Andersson  <gnu@gisladisker.se>

	* tests/dnsdomainname.sh: Replace `! test -x' by `test ! -x' for
	shell portability.

2012-03-14  Simon Josefsson  <simon@josefsson.org>

	* tests/dnsdomainname.sh: Don't fail on configuration errors.
	Suggested by Mats Erik Andersson <mats.andersson@gisladisker.se>.

2012-03-14  Mats Erik Andersson  <gnu@gisladisker.se>

	Make explicit dependency on header files for libwrap and termcap.

	* am/libcurses.m4 (IU_LIB_TERMCAP): Check whether tgetent() is
	really declared in <termcap.h>, not only checking presence of
	<termcap.h>.  That failing, check declaration of tgetent() using
	the pair <curses.h>, and <term.h>.  In case of no successful
	detection at all, set LIBTERMCAP to empty.
	* configure.ac (LIBWRAP): Define only if hosts_ctl() is present in
	libwrap and also the header <tcpd.h> exists.

2012-03-13  Mats Erik Andersson  <gnu@gisladisker.se>

	* src/traceroute.c (do_try): When displaying traces, print host
	name only if in resolving mode; otherwise only numerical address.
	Insert one additional blank before time printout.
	(get_hostname): Remove conditional clause on
	OPT_RESOLVE_HOSTNAMES.

2012-03-12  Simon Josefsson  <simon@josefsson.org>

	* NEWS: Mention new dnsdomainname tool.
	* configure.ac: Add tool dnsdomainname.
	* doc/inetutils.texi: Document dnsdomainname.
	* man/Makefile.am: Build dnsdomainname.1.
	* man/dnsdomainname.h2m: New file.
	* src/.gitignore: Ignore dnsdomainname.
	* src/Makefile.am (bin_PROGRAMS): Add $(dnsdomainname_BUILD).
	(dnsdomainname_SOURCES): New variable.
	(EXTRA_PROGRAMS): Add dnsdomainname.
	* src/dnsdomainname.c: New file.
	* tests/dnsdomainname.sh: New file.

2012-03-10  Mats Erik Andersson  <gnu@gisladisker.se>

	* whois/tld_serv_list (.cz, .fo, .gl, .gs, .hk, .ie, .il, .in)
	(.is, .jp, .kr, .kz, .lt, .lu, .lv, .ms, .mx, .ng, .nz, .pe, .pl)
	(.ro, .ru, .se, .sg, .si, .sk, .sm, .su, .tf, .th, .tr, .tw, .us):
	Updated entry.
	(.dz, .ec, .es, .eu, .fi, .gd, .gg, .gi, .gy, .hn, .hr, .ht, .im)
	(.io, .ir, .je, .ke, .la, .ly, .ma, .md, .me, .mg, .mn, .mp, .mu)
	(.my, .na, .nc, .nf, .pm, .pr, .pt, .qa, .re, .rs, .sa, .sb, .sc)
	(.so, .sx, .tk, .tl, .tv, .tz, .ua, .uy, .uz, .vc, .ve, .wf, .yt):
	New or upgraded from web entry.
	(.hm, .ki, .mf, .pk, .pw, .sl, .sn, .tj, .ug, .um, .vn, .yu, .za):
	Broken address or other comment.

2012-03-06  Mats Erik Andersson  <gnu@gisladisker.se>

	* ping/ping6.c (print_echo): Use flag NI_NUMERICHOST in call to
	getnameinfo() whenever the option OPT_NUMERIC is active.
	* ping/ping_echo.c (ipaddr2str): Isolate case OPT_NUMERIC to call
	xstrdup().  Then call xstrdup() if gethostbyaddr() fails.  In main
	body, replace every `hp->h_name' for `ipstr', and conversely,
	since only `hp->h_name' can fail do be defined.
	* tests/ping-localhost.sh: Insert option `-n' to ping and ping6.

2012-03-03  Mats Erik Andersson <gnu@gisladisker.se>

	Display command prompt only in interactive mode.

	* src/tftp.c (fromatty): New variable; true in interactive mode.
	(main): Assign value to FROMATTY.
	(command): Display prompt only if FROMATTY is true.

2012-03-02  Mats Erik Andersson <gnu@gisladisker.se>

	Make service lookup optional in FTP client.

	* ftp/cmds.h (DEFPORT) [!DEFPORT]: New macro.  Define as
	IPPORT_FTP if available, otherwise as 21.
	(another): Condition call to add_history() on FROMATTY.
	(setpeer): Call getservbyname() for `ftp/tcp'.  Set port if
	successful; use DEFPORT otherwise.
	* ftp/ftp_var.h (sp): Remove external variable.
	* ftp/main.c (main): Remove call to getservbyname() and the use of
	SP.
	(cmdscanner): Condition call to add_history() on FROMATTY.

2012-03-01  Mats Erik Andersson <gnu@gisladisker.se>

	Subtests for SIGHUP reaction of `inetd' and `syslogd'.

	* tests/syslogd.sh: Write a second configuration file after first
	run, send SIGHUP to server, and evaluate message response.
	(SUCCESSES): Update arithmetic expression used in evaluation.
	(OUT_USER, OUT_DEBUG, TAG2, COUNT2, COUNT2_debug, COUNT3)
	(COUNT3_info): New variables.  <verbose report>: Print messages of
	files $OUT_USER and $OUT_DEBUG.

	* tests/tftp.sh: Calculate new port after first test run, send
	SIGHUP to server, and transmit a small file at each adress in old
	list.
	(do_conf_reload): New variable.

2012-03-01  Mats Erik Andersson <gnu@gisladisker.se>

	Reduce external prerequisites in test scripts.

	* tests/ftp-localhost.sh: Replace `head -1' by `sed 1q'.
	* tests/telnet-localhost.sh, tests/tftp.sh: Likewise.  Replace `ps
	pid' by `kill -0 pid'.
	* tests/syslogd.sh: Likewise.  Replace `wc -l' by `grep -c'.

	* tests/tftp.sh: Do not issue `set -m', since no job control in
	use.

2012-02-25  Alfred M. Szmidt  <ams@gnu.org>

	* bootstrap.conf (gnulib_modules): Sort lexically.

2012-02-25  Alfred M. Szmidt  <ams@gnu.org>

	Silence sc_makefile_at_at_check.

	* whois/Makefile.am (bin_PROGRAMS): Use $(...) type of variable
	reference instead of @...@.
	* telnetd/Makefile.am: Likewise.
	* telnet/Makefile.am (bin_PROGRAMS): Likewise.
	* talkd/Makefile.am (inetdaemon_PROGRAMS): Likewise.
	* talk/Makefile.am (bin_PROGRAMS): Likewise.
	* src/Makefile.am (bin_PROGRAMS, inetdaemon_PROGRAMS)
	(install-exec-hook): Likewise.
	* ping/Makefile.am (bin_PROGRAMS, install-exec-hook): Likewise.
	* libls/Makefile.am (noinst_LIBRARIES): Likewise.
	* ifconfig/Makefile.am (bin_PROGRAMS): Likewise.
	* ftpd/Makefile.am (inetdaemon_PROGRAMS): Likewise.
	* ftp/Makefile.am (bin_PROGRAMS): Likewise.

2012-02-25  Alfred M. Szmidt  <ams@gnu.org>

	* cfg.mk (local-checks-to-skip): Added sc_assignment_in_if to
	list.
	(sc_assignment_in_if): New target.

	* bootstrap: Updated from gnulib.

	* src/inetd.c (main, tcpmux, chargen_dg, chargen_stream)
	(nextconfig, newstr, run_service): Fix indentation.

2012-02-22  Mats Erik Andersson <gnu@gisladisker.se>

	* tests/ping-localhost.sh, tests/traceroute-localhost.sh: Mend
	string quotation for expected variable expansion.
	* tests/syslogd.sh (SYSLOGD, LOGGER): Allow value overriding.
	* tests/telnet-localhost.sh (INETD, TELNET, ADDRPEEK): Likewise.
	(TARGET): New variable, replacing previous TARGET4.

2012-02-22  Mats Erik Andersson <gnu@gisladisker.se>

	Implement group assignment for services.

	* src/inetd.c (struct servtab): New component `char *se_group'.
	(run_service): New variable GRP.  Check existence of
	`sep->se_group'.  If valid, then apply setgid() to `grp->gr_gid'
	instead of `pwd->pw_gid'.  <initgroups> [HAVE_INITGROUPS]: Use
	`grp->gr_id' if an explicit group was stated, otherwise use
	`pwd->pw_gid'.
	(print_service): Display also group membership.
